# xcoll

<!---![PyPI - Python Version](https://img.shields.io/pypi/pyversions/xcoll?logo=PyPI?style=plastic) ![PyPI - Wheel](https://img.shields.io/pypi/wheel/xcoll?logo=PyPI?style=plastic)-->

![GitHub release (latest by date)](https://img.shields.io/github/v/release/xsuite/xcoll?style=plastic)
![GitHub](https://img.shields.io/github/license/xsuite/xcoll?style=plastic)
![PyPi](https://img.shields.io/pypi/dm/xcoll?logo=PyPI&style=plastic)
![GitHub all releases](https://img.shields.io/github/downloads/xsuite/xcoll/total?logo=GitHub&style=plastic)

![GitHub pull requests](https://img.shields.io/github/issues-pr/xsuite/xcoll?logo=GitHub&style=plastic)
![GitHub issues](https://img.shields.io/github/issues/xsuite/xcoll?logo=GitHub&style=plastic)
![GitHub repo size](https://img.shields.io/github/repo-size/xsuite/xcoll?logo=GitHub&style=plastic)

Collimation in xtrack simulations

## Description

## Getting Started

### Dependencies

* python >= 3.8
    * numpy
    * pandas
    * xsuite (in particular xobjects, xdeps, xtrack, xpart)

### Installing
`xcoll` is packaged using `poetry`, and can be easily installed with `pip`:
```bash
pip install xcoll
```
For a local installation, clone and install in editable mode (need to have `pip` >22):
```bash
git clone git@github.com:xsuite/xcoll.git
pip install -e xcoll
```

### Example

## Features

## Authors

* [Frederik Van der Veken](https://github.com/freddieknets) (frederik@cern.ch)
* [Despina Demetriadou](https://github.com/ddemetriadou)
* [Andrey Abramov](https://github.com/anabramo)
* [Giovanni Iadarola](https://github.com/giadarol)


## Version History

* 0.1
    * Initial Release

## License

This project is [Apache 2.0 licensed](./LICENSE).

# Collimasim

Collimasim provides Python bindings to BDSIM (Geant4) in order to enable collimation studies in pure tracking codes

## Requiremends
 - BDSIM installed on the system
 - python3
 - CMake >3.17

## Installation

To isntall use:

```bash
git clone --recurse-submodules https://gitlab.cern.ch/anabramo/collimasim.git
python -m pip install --user --editable ./
```

## Usage

See tests/test.py for an example of how to use

FlukaIO 
=======

How to compile
==============

In a machine with CppUTest correctly configured, it can be compiled and tested running "make".

In a machine without CppUTest both 32 and 64 bit versions of the libraries can be compiled issuing the following commands:

make libs BUILD32=Y
make clean
make libs BUILD64=Y

The resulting libraries will be compiled under the directory "lib".

Documentation
=============

The doxygen documentation can be generated with the command "make doc"

Compiling samples
=================

Run "make samples" to compile sample clients and servers under samples directory.

# Test suite for collimasim

To run all the tests successfully, both `Xsuite` and `pyAT` must be installed

To run with pytest, the extension `pytest-forked` must be installed

```
  pip install pytest-forked
```

and then 

```
  pytest --forked --continue-on-collection-errors
```
in the `collimasim/tests` directory to run the tests.

This is because collimasim is currently not re-entry safe. 
Once an instance of BDSIM has been launched in a process, 
no further instances can be launched in that process. 
This appears to be due to the global state not being reset 
properly after the BDISM instance terminates. 
To be investigated in the future. 
The flag --continue-on-collection-errors ensures that 
the Xsuite tests run if pyAT isn't isntalled and vice versa.

! ================================================================================================ !
!  SixTrack String Tools
! ~~~~~~~~~~~~~~~~~~~~~~~
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last Modified: 2018-04-16
!
!  Note: Careful with adding use <module> to this module as it easily creates circular dependencies
! ================================================================================================ !
module string_tools

  use strings
  use parpro, only : mNameLen, mFileName, mPathName
  use, intrinsic :: iso_fortran_env, only : int16, int32, int64, real32, real64, real128

  implicit none

  public str_strip, chr_strip, chr_trimZero
  public str_stripQuotes, chr_stripQuotes
  public str_sub, chr_expandBrackets
  public chr_lPad, chr_rPad, chr_lPadCut, chr_rPadCut
  public chr_toUpper, chr_toLower, chr_isNumeric
  public str_inStr, chr_inStr

  interface str_cast
    module procedure str_toReal32
    module procedure str_toReal64
    module procedure str_toReal128
    module procedure str_toInt16
    module procedure str_toInt32
    module procedure str_toInt64
    module procedure str_toLog
  end interface str_cast

  interface chr_cast
    module procedure chr_toReal32
    module procedure chr_toReal64
    module procedure chr_toReal128
    module procedure chr_toInt16
    module procedure chr_toInt32
    module procedure chr_toInt64
    module procedure chr_toLog
  end interface chr_cast

  private :: str_toReal32
  private :: str_toReal64
  private :: str_toReal128
  private :: str_toInt16
  private :: str_toInt32
  private :: str_toInt64
  private :: str_toLog

  private :: chr_toReal32
  private :: chr_toReal64
  private :: chr_toReal128
  private :: chr_toInt16
  private :: chr_toInt32
  private :: chr_toInt64
  private :: chr_toLog

contains

! ================================================================================================ !
!  String Split Routine
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-05-18
!  Splits a string into an array of strings by one or more space,
!    but not within a pair of single our double quotes.
!  Note: Copying data from one string to another string, by slicing the char array, does not work
!        with the intel compiler unless -assume realloc-lhs is enabled.
! ================================================================================================ !
subroutine str_split(toSplit, sArray, nArray, hasErr, fixLen, nIndent)

  use crcoall

  type(string),               intent(in)  :: toSplit
  type(string), allocatable,  intent(out) :: sArray(:)
  integer,                    intent(out) :: nArray
  logical,                    intent(out) :: hasErr
  integer,      optional,     intent(in)  :: fixLen
  integer,      optional,     intent(out) :: nIndent

  character(len=:), allocatable :: mskSplit, tVal
  integer mLen, nVal, nInd
  integer i, iVal, iSt
  logical hErr

  call chr_scanString(toSplit%chr, mskSplit, mLen, nVal, nInd, hErr)
  if(present(fixLen))  mLen    = fixLen
  if(present(nIndent)) nIndent = nInd
  nArray = nVal
  hasErr = hErr

  if(nVal == 0) return

  if(allocated(sArray)) deallocate(sArray)
  allocate(sArray(nVal))

  iVal = 0
  iSt  = 0
  tVal = ""
  do i=1,len(mskSplit)
    if(mskSplit(i:i) == "X") then
      iSt = iSt + 1
      if(iSt > mLen) then
        write(lerr,"(2(a,i0))") "SPLIT> ERROR Split element ",iVal," is longer than the buffer of ",mLen,"."
        hasErr = .true.
        exit
      end if
      tVal = tVal//toSplit%chr(i:i)
    else
      if(iSt > 0) then
        iSt  = 0
        iVal = iVal + 1
        if(iVal > nVal) exit
        sArray(iVal) = tVal
        tVal = ""
      end if
    end if
  end do

end subroutine str_split

subroutine chr_split(toSplit, sArray, nArray, hasErr, fixLen, nIndent)

  use crcoall

  character(len=*),              intent(in)    :: toSplit
  character(len=:), allocatable, intent(inout) :: sArray(:)
  integer,                       intent(out)   :: nArray
  logical,                       intent(out)   :: hasErr
  integer,          optional,    intent(in)    :: fixLen
  integer,          optional,    intent(out)   :: nIndent

  character(len=:), allocatable :: mskSplit
  integer mLen, nVal, nInd
  integer i, iVal, iSt
  logical hErr

  call chr_scanString(toSplit, mskSplit, mLen, nVal, nInd, hErr)
  if(present(fixLen))  mLen    = fixLen
  if(present(nIndent)) nIndent = nInd
  nArray = nVal
  hasErr = hErr

  if(nVal == 0) return

  if(allocated(sArray)) deallocate(sArray)
  allocate(character(len=mLen) :: sArray(nVal))
  do i=1,nVal
    sArray(i) = repeat(" ",mLen)
  end do

  iVal = 1
  iSt  = 0
  do i=1,len(mskSplit)
    if(mskSplit(i:i) == "X") then
      iSt = iSt + 1
      if(iSt > mLen) then
        write(lerr,"(2(a,i0))") "SPLIT> ERROR Split element ",iVal," is longer than the buffer of ",mLen,"."
        hasErr = .true.
        exit
      end if
      sArray(iVal)(iSt:iSt) = toSplit(i:i)
    else
      if(iSt > 0) then
        iSt  = 0
        iVal = iVal + 1
        if(iVal > nVal) exit
      end if
    end if
  end do

end subroutine chr_split

! ================================================================================================ !
!  Scan a String and Mark it for Splitting
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-06-01
! ================================================================================================ !
subroutine chr_scanString(theString, theMask, maxLen, nValues, nIndent, hasErr)

  use crcoall

  character(len=*),              intent(in)  :: theString
  character(len=:), allocatable, intent(out) :: theMask
  integer,                       intent(out) :: maxLen
  integer,                       intent(out) :: nValues
  integer,                       intent(out) :: nIndent
  logical,                       intent(out) :: hasErr

  character ch, pCh
  integer   i, nCh, qSt, nIn, vSt, vLn, nVl
  logical   isI

  nCh = len(theString)
  allocate(character(len=nCh) :: theMask)
  theMask = repeat(" ",nCh)
  hasErr  = .false.
  maxLen  = 0

  nIn = 0         ! Counter for indents
  vSt = 0         ! 0 = no value, 1 = in value, 2 = comment char
  isI = .true.    ! If we are in the beginning of the line (no values yet)
  qSt = 0         ! 0 = not in quote, 1 = in single quote, 2 = in double quote

  do i=1,nCh
    ch  = theString(i:i)
    vSt = 0                               ! Default to treat everything as not a value
    if(ch == " " .and. isI) nIn = nIn + 1 ! Count indents, but only spaces
    if(ch /= " ") isI = .false.           ! Stop counting indents
    if(ch == char(0)) ch = " "            ! Treat null as space
    if(ch == char(9)) ch = " "            ! Treat tab as space
    if(ch == "'" .and. qSt == 0) qSt = 1  ! Entering single quoted region
    if(ch == '"' .and. qSt == 0) qSt = 3  ! Entering double quoted region
    if(ch /= " " .and. qSt == 0) vSt = 1  ! This is a value if it is not in quotes
    if(ch /= "'" .and. qSt == 2) vSt = 1  ! This is a value in single quotes
    if(ch /= '"' .and. qSt == 4) vSt = 1  ! This is a value in double quotes
    if(ch == "'" .and. qSt == 2) qSt = 0  ! Exiting single quoted region
    if(ch == '"' .and. qSt == 4) qSt = 0  ! Exiting double quoted region
    if(ch == "!" .and. qSt == 0) vSt = 2  ! Comment character encountered
    if(qSt == 1) qSt = 2                  ! Flag the newly entered quoted region for saving values next time
    if(qSt == 3) qSt = 4                  ! Flag the newly entered quoted region for saving values next time
    if(vSt == 1) theMask(i:i) = "X"       ! Mark character as a value
    if(vSt == 2) exit                     ! We've reached a comment character, exit
    if(ichar(ch) < 32) then               ! This is a control character, we don't want those
      write(lerr,"(2(a,i0))") "SPLIT> ERROR Control character char(",ichar(ch),") encountered at position ",i
      hasErr = .true.
      return
    end if
  end do
  nIndent = nIn

  ! Report un-closed quotes
  if(qSt > 0) then
    write(lerr,"(a,i0,a)") "SPLIT> ERROR Reached end of line with quotes still open."
    hasErr = .true.
    return
  end if

  ! Sum everything up
  vLn = 0
  nVl = 0
  pCh = " "
  do i=1,nCh
    ch = theMask(i:i)
    if(ch == "X") then                   ! This index is part of a value
      vLn    = vLn + 1                   ! Increment the value length
      maxLen = max(maxLen, vLn)          ! Update max value length
      if(pCh == " ") nVl = nVl + 1       ! If previous char was space, count the "edge" as a new value
    else                                 ! This index is not part of a value
      vLn = 0                            ! Reset the value length counter
    end if
    pCh = ch                             ! Record the current char for next round
  end do
  nValues = nVl

end subroutine chr_scanString

! ================================================================================================ !
!  Expand Brackets
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-05-18
!  Will return a string with the content of brackets N(something something) repeated N times.
!  This routine is NOT recursive.
! ================================================================================================ !
function chr_expandBrackets(theString) result(theResult)

  implicit none

  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: theResult, theBuffer

  integer, allocatable :: bPos(:,:)
  integer ch, nLB, nRB, tSP, lSP, lLB, iSet, nSet, iPos, iMult
  logical iErr

  ! Count the brackets
  nLB = 0
  nRB = 0
  do ch=1,len(theString)
    if(theString(ch:ch) == "(") nLB = nLB + 1
    if(theString(ch:ch) == ")") nRB = nRB + 1
  end do

  ! If there are none, then just return
  if(nLB == 0 .or. nLB /= nRB) then
    theResult = theString
    return
  end if

  ! Otherwise, get all the positions for slicing
  allocate(bPos(3,nLB))
  theBuffer = " "//theString//" "
  bPos(:,:) = 0
  lSP  = 0
  tSP  = 0
  lLB  = 0
  iSet = 0
  do ch=1,len(theBuffer)
    if(theBuffer(ch:ch) == " ") then
      tSP = ch
    elseif(theBuffer(ch:ch) == "(") then
      lSP = tSP
      lLB = ch
    elseif(theBuffer(ch:ch) == ")") then
      if(lSP > 0 .and. lLB > 0 .and. lLB-lSP > 1 .and. ch-lSP > 2) then
        iSet = iSet + 1
        bPos(1,iSet) = lSP
        bPos(2,iSet) = lLB
        bPos(3,iSet) = ch
        lSP = 0
        lLB = 0
      end if
    end if
  end do
  nSet = iSet

  ! Then combine all the pieces
  iPos      = 1
  theResult = ""
  do iSet=1,nSet
    theResult = theResult//theBuffer(iPos:bPos(1,iSet))
    call chr_cast(theBuffer(bPos(1,iSet)+1:bPos(2,iSet)-1),iMult,iErr)
    theResult = theResult//repeat(theBuffer(bPos(2,iSet)+1:bPos(3,iSet)-1)//" ",iMult)
    iPos      = bPos(3,iSet)+1
  end do
  theResult = trim(adjustl(theResult//theBuffer(iPos:)))

  deallocate(bPos)

end function chr_expandBrackets

! ================================================================================================ !
!  SubString Routine
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-14
!  Returns a substring of a string
!  This is a safer way of extracting a substring than slicing string%chr.
!  Writing a substring of a string to another string produces garbage with the intel compiler.
! ================================================================================================ !
function str_sub(theString, iA, iB) result(retString)

  type(string), intent(in)      :: theString
  type(string)                  :: retString
  character(len=:), allocatable :: tmpString

  integer iA, iB, oldLen, newLen

  oldLen = len(theString%chr)
  newLen = iB - iA + 1

  if(newLen <= 0) then
    retString = string("")
    return
  end if
  if(iA < 1)      iA = 1
  if(iB > oldLen) iB = oldLen

  allocate(character(newLen) :: tmpString)
  tmpString(1:newLen) = theString%chr(iA:iB)
  retString           = string(tmpString)
  deallocate(tmpString)

end function str_sub

! ================================================================================================ !
!  Strip String Routine
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-14
!  Trims leading and trailing white spaces from a string
!  str_trim is for strings in and out
!  chr_trim is for char arrays in and out
! ================================================================================================ !
function str_strip(theString) result(retString)
  type(string), intent(in) :: theString
  type(string)             :: retString
  retString = trim(adjustl(theString))
end function str_strip

function chr_strip(theString) result(retString)
  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: retString
  retString = trim(adjustl(theString))
end function chr_strip

! ================================================================================================ !
!  Pad String With Spaces
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-11-27
!   * chr_lPad    :: Pad a string to the left to specified size. Does not trunctae if longer.
!   * chr_rPad    :: Pad a string to the right to specified size. Does not trunctae if longer.
!   * chr_lPadCut :: Pad a string to the left to specified size. Does trunctae if longer.
!   * chr_rPadCut :: Pad a string to the right to specified size. Does trunctae if longer.
! ================================================================================================ !
function chr_lPad(theString, theSize) result(retString)
  character(len=*), intent(in)  :: theString
  integer,          intent(in)  :: theSize
  character(len=:), allocatable :: retString
  integer                       :: inSize
  inSize = len(theString)
  if(inSize > 0 .and. inSize < theSize) then
    retString = repeat(" ",theSize-inSize)//theString(1:inSize)
  else
    retString = theString
  end if
end function chr_lPad

function chr_rPad(theString, theSize) result(retString)
  character(len=*), intent(in)  :: theString
  integer,          intent(in)  :: theSize
  character(len=:), allocatable :: retString
  integer                       :: inSize
  inSize = len(theString)
  if(inSize > 0 .and. inSize < theSize) then
    retString = theString(1:inSize)//repeat(" ",theSize-inSize)
  else
    retString = theString
  end if
end function chr_rPad

function chr_lPadCut(theString, theSize) result(retString)
  character(len=*), intent(in) :: theString
  integer,          intent(in) :: theSize
  character(len=theSize) :: retString
  integer                :: inSize
  inSize = len(theString)
  if(inSize > theSize) then
    retString = theString(1:theSize)
  elseif(inSize > 0) then
    retString = repeat(" ",theSize-inSize)//theString(1:inSize)
  else
    retString = repeat(" ",theSize)
  end if
end function chr_lPadCut

function chr_rPadCut(theString, theSize) result(retString)
  character(len=*), intent(in) :: theString
  integer,          intent(in) :: theSize
  character(len=theSize) :: retString
  integer                :: inSize
  inSize = len(theString)
  if(inSize > theSize) then
    retString = theString(1:theSize)
  elseif(inSize > 0) then
    retString = theString(1:inSize)//repeat(" ",theSize-inSize)
  else
    retString = repeat(" ",theSize)
  end if
end function chr_rPadCut

! ================================================================================================ !
!  Convert to Lower/Upper Case
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-10-04
! ================================================================================================ !
function chr_toUpper(theString) result(retString)
  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: retString
  character          :: ch
  integer, parameter :: ulOffset = ichar("A") - ichar("a")
  integer            :: i
  allocate(character(len(theString)) :: retString)
  do i = 1,len(theString)
    ch = theString(i:i)
    if(ch >= "a" .and. ch <= "z") ch = char(ichar(ch)+ulOffset)
    retString(i:i) = ch
  end do
end function chr_toUpper

function chr_toLower(theString) result(retString)
  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: retString
  character          :: ch
  integer, parameter :: ulOffset = ichar("A") - ichar("a")
  integer            :: i
  allocate(character(len(theString)) :: retString)
  do i = 1,len(theString)
    ch = theString(i:i)
    if(ch >= "A" .and. ch <= "Z") ch = char(ichar(ch)-ulOffset)
    retString(i:i) = ch
  end do
end function chr_toLower

! ================================================================================================ !
!  Check if String is a Number
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2019-04-05
! ================================================================================================ !
logical function chr_isNumeric(theString)
  character(len=*), intent(in) :: theString
  integer ioStat
  real dumDum
  read(theString,"(e15.6)",iostat=ioStat) dumDum
  if(ioStat == 0) then
    chr_isNumeric = .true.
  else
    chr_isNumeric = .false.
  end if
end function chr_isNumeric

! ================================================================================================ !
!  Trim Zero String Routine
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-14
!  Removes zero chars from any length string
! ================================================================================================ !
function chr_trimZero(theString) result(retString)

  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: retString

  integer ch

  allocate(character(len=len(theString)) :: retString)
  do ch=1, len(theString)
    if(theString(ch:ch) == char(0)) then
      retString(ch:ch) = " "
    else
      retString(ch:ch) = theString(ch:ch)
    end if
  end do
  retString = trim(retString)

end function chr_trimZero

! ================================================================================================ !
!  Count the Occurence of a Single Character in a String
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-16
! ================================================================================================ !
function str_inStr(theString, theNeedle) result(nNeedle)

  type(string),     intent(in)  :: theString
  character(len=1), intent(in)  :: theNeedle
  integer                       :: nNeedle

  integer ch

  nNeedle = 0
  do ch=1, len(theString%chr)
    if(theString%chr(ch:ch) == theNeedle) then
      nNeedle = nNeedle + 1
    end if
  end do

end function str_inStr

function chr_inStr(theString, theNeedle) result(nNeedle)

  character(len=*), intent(in)  :: theString
  character(len=1), intent(in)  :: theNeedle
  integer                       :: nNeedle

  integer ch

  nNeedle = 0
  do ch=1, len(theString)
    if(theString(ch:ch) == theNeedle) then
      nNeedle = nNeedle + 1
    end if
  end do

end function chr_inStr

! ================================================================================================ !
!  Strip Quotes Routine
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-14
!  Removes a matching pair of double quotes at the beginning and end of a string
! ================================================================================================ !
function str_stripQuotes(theString) result(retString)

  type(string), intent(in) :: theString
  type(string)             :: tmpString
  type(string)             :: retString

  integer strLen

  tmpString = str_strip(theString)
  strLen    = len(tmpString)

  if(strLen < 2) then
    retString = tmpString
    return
  end if

  if(tmpString%chr(1:1) == '"' .and. tmpString%chr(strLen:strLen) == '"') then
    retString = str_sub(tmpString,2,strLen-1)
    return
  else
    retString = tmpString
    return
  end if

end function str_stripQuotes

function chr_stripQuotes(theString) result(retString)

  character(len=*), intent(in)  :: theString
  character(len=:), allocatable :: tmpString
  character(len=:), allocatable :: retString

  integer strLen

  tmpString = chr_strip(theString)
  strLen    = len(tmpString)

  if(strLen < 2) then
    retString = tmpString
    return
  end if

  if(tmpString(1:1) == '"' .and. tmpString(strLen:strLen) == '"') then
    retString = tmpString(2:strLen-1)
    return
  else
    retString = tmpString
    return
  end if

end function chr_stripQuotes

! ================================================================================================ !
!  Rounding Routines
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-04-20
!  A wrapper for round_near for strings and character arrays
! ================================================================================================ !
subroutine str_toReal32(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  type(string),      intent(in)    :: theString
  real(kind=real32), intent(out)   :: theValue
  logical,           intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine str_toReal32

subroutine chr_toReal32(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  character(len=*),  intent(in)    :: theString
  real(kind=real32), intent(out)   :: theValue
  logical,           intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine chr_toReal32

subroutine str_toReal64(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  type(string),      intent(in)    :: theString
  real(kind=real64), intent(out)   :: theValue
  logical,           intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine str_toReal64

subroutine chr_toReal64(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  character(len=*),  intent(in)    :: theString
  real(kind=real64), intent(out)   :: theValue
  logical,           intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine chr_toReal64

subroutine str_toReal128(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  type(string),       intent(in)    :: theString
  real(kind=real128), intent(out)   :: theValue
  logical,            intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine str_toReal128

subroutine chr_toReal128(theString, theValue, rErr)

  use floatPrecision
  use crcoall

  implicit none

  character(len=*),   intent(in)    :: theString
  real(kind=real128), intent(out)   :: theValue
  logical,            intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine chr_toReal128

! ================================================================================================ !
!  String to Integer
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-05-18
! ================================================================================================ !

subroutine str_toInt16(theString, theValue, rErr)

  use crcoall

  type(string),        intent(in)    :: theString
  integer(kind=int16), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString%chr)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int16 width error ",readErr
    rErr = .true.
  end if

end subroutine str_toInt16

subroutine chr_toInt16(theString, theValue, rErr)

  use crcoall

  character(len=*),    intent(in)    :: theString
  integer(kind=int16), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int16 width error ",readErr
    rErr = .true.
  end if

end subroutine chr_toInt16

subroutine str_toInt32(theString, theValue, rErr)

  use crcoall

  type(string),        intent(in)    :: theString
  integer(kind=int32), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString%chr)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int32 width error ",readErr
    rErr = .true.
  end if

end subroutine str_toInt32

subroutine chr_toInt32(theString, theValue, rErr)

  use crcoall

  character(len=*),    intent(in)    :: theString
  integer(kind=int32), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int32 width error ",readErr
    rErr = .true.
  end if

end subroutine chr_toInt32

subroutine str_toInt64(theString, theValue, rErr)

  use crcoall

  type(string),        intent(in)    :: theString
  integer(kind=int64), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString%chr)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int64 width error ",readErr
    rErr = .true.
  end if

end subroutine str_toInt64

subroutine chr_toInt64(theString, theValue, rErr)

  use crcoall

  character(len=*),    intent(in)    :: theString
  integer(kind=int64), intent(out)   :: theValue
  logical,             intent(inout) :: rErr

  character(len=:),    allocatable   :: tmpString
  integer                            :: readErr

  tmpString = trim(theString)
  read(tmpString,*,iostat=readErr) theValue
  if(readErr /= 0) then
    write(lerr,"(a,i0)") "TYPECAST> ERROR Failed to cast '"//tmpString//"' to int64 width error ",readErr
    rErr = .true.
  end if

end subroutine chr_toInt64

! ================================================================================================ !
!  String to Logical
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-05-18
! ================================================================================================ !

subroutine str_toLog(theString, theValue, rErr)

  use crcoall

  type(string),     intent(in)    :: theString
  logical,          intent(out)   :: theValue
  logical,          intent(inout) :: rErr

  character(len=:), allocatable   :: tmpString

  tmpString = chr_toLower(trim(theString%chr))
  select case(tmpString)
  case("true",".true.","on","1")
    theValue = .true.
  case("false",".false.","off","0")
    theValue = .false.
  case default
    write(lerr,"(a)") "TYPECAST> ERROR Failed to cast '"//trim(theString)//"' to logical"
    rErr = .true.
  end select

end subroutine str_toLog

subroutine chr_toLog(theString, theValue, rErr)

  use crcoall

  character(len=*), intent(in)    :: theString
  logical,          intent(out)   :: theValue
  logical,          intent(inout) :: rErr

  character(len=:), allocatable   :: tmpString

  tmpString = chr_toLower(trim(theString))
  select case(tmpString)
  case("true",".true.","on","1")
    theValue = .true.
  case("false",".false.","off","0")
    theValue = .false.
  case default
    write(lerr,"(a)") "TYPECAST> ERROR Failed to cast '"//trim(theString)//"' to logical"
    rErr = .true.
  end select

end subroutine chr_toLog

! ================================================================================================ !
!  Real to String
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-07-13
! ================================================================================================ !
subroutine chr_fromReal(theValue, theString, nPrec, ePrec, rErr)

  use crcoall
  use floatPrecision

  real(kind=fPrec),             intent(in)    :: theValue
  integer,                      intent(in)    :: nPrec, ePrec
  character(len=nPrec+ePrec+4), intent(out)   :: theString
  logical,                      intent(inout) :: rErr

  ERROR STOP 'DELETED THIS CODE BECAUSE OF COMPILATION ERRORS. SHOULD NOT HAVE BEEN NEEDED. UNDO.'

end subroutine chr_fromReal

! ================================================================================================ !
!  HERE FOLLOWS THE OLD ROUTINES
! ================================================================================================ !

end module string_tools

MODULE files
  USE floatPrecision

CONTAINS

SUBROUTINE realfromfile(filename,x)
  IMPLICIT NONE
  CHARACTER(len=80), INTENT(in)  :: filename  ! input
  REAL(kind=fPrec), INTENT(out)  :: x(20000)  ! output

  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="read")
  DO  i = 1, nrows
    READ(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE realfromfile

SUBROUTINE intfromfile(filename,x)
  IMPLICIT NONE
  CHARACTER(len=80), INTENT(in) :: filename   ! input
  INTEGER(kind=4), INTENT(out)  :: x(20000)   ! output
  

  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="read")
  DO  i = 1, nrows
    READ(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE intfromfile

SUBROUTINE boolfromfile(filename,x)
  IMPLICIT NONE
  CHARACTER(len=80), INTENT(in) :: filename   ! input
  LOGICAL(kind=4), INTENT(out)  :: x(20000)   ! output

  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="read")
  DO  i = 1, nrows
    READ(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE boolfromfile

SUBROUTINE realtofile(x,filename)
  IMPLICIT NONE
  REAL(kind=fPrec), INTENT(in)   :: x(20000)  ! input
  CHARACTER(len=80), INTENT(in)  :: filename  ! input
  
  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="write")
  DO  i = 1, nrows
    WRITE(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE realtofile

SUBROUTINE inttofile(x,filename)
  IMPLICIT NONE
  INTEGER(kind=4), INTENT(in)    :: x(20000)  ! input
  CHARACTER(len=80), INTENT(in)  :: filename  ! input
  
  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="write")
  DO  i = 1, nrows
    WRITE(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE inttofile

SUBROUTINE booltofile(x,filename)
  IMPLICIT NONE
  LOGICAL(kind=4), INTENT(in)    :: x(20000)  ! input
  CHARACTER(len=80), INTENT(in)  :: filename  ! input
  
  INTEGER :: nrows=20000
  INTEGER :: i

  OPEN(UNIT=11, FILE=filename, ACTION="write")
  DO  i = 1, nrows
    WRITE(11,*)  x(i)
  END DO
  CLOSE(UNIT=11)

END SUBROUTINE booltofile

END MODULE files

! ================================================================================================ !
!
!  Crystal Collimation Module
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
!  Written by: Igor Yazynin, Valentina Previtali and Daniele Mirarchi, BE-ABP-HSS
!  Re-written for SixTrack 5 by: Marco D'Andrea and Veronica K. Berglyd Olsen, BE-ABP-HSS (2019)
!
!  Last modified: 2021-12-03
!
! ================================================================================================ !
module coll_crystal

  use floatPrecision
  use numerical_constants
  !use coll_materials, only : nmat

  implicit none

  integer,          private, save :: iProc       = 0
  integer,          private, save :: n_chan      = 0
  integer,          private, save :: n_VR        = 0
  integer,          private, save :: n_amorphous = 0

  ! Shared settings for the currently active crystal
  integer,          private, save :: c_orient   = 0    ! Crystal orientation [0-2]
  real(kind=fPrec), private, save :: c_rcurv    = zero ! Crystal geometrical parameters [m]
  real(kind=fPrec), private, save :: c_xmax     = zero ! Crystal geometrical parameters [m]
  real(kind=fPrec), private, save :: c_ymax     = zero ! Crystal geometrical parameters [m]
  real(kind=fPrec), private, save :: c_alayer   = zero ! Crystal amorphous layer [mm]
  real(kind=fPrec), private, save :: c_miscut   = zero ! Crystal miscut angle in rad
  real(kind=fPrec), private, save :: c_cpTilt   = zero ! Cosine of positive crystal tilt
  real(kind=fPrec), private, save :: c_spTilt   = zero ! Sine of positive crystal tilt
  real(kind=fPrec), private, save :: c_cnTilt   = zero ! Cosine of negative crystal tilt
  real(kind=fPrec), private, save :: c_snTilt   = zero ! Sine of negative crystal tilt
  real(kind=fPrec), private, save :: c_cBend    = zero ! Cosine of crystal bend
  real(kind=fPrec), private, save :: c_sBend    = zero ! Sine of crystal bend
  real(kind=fPrec), private, save :: cry_tilt   = zero ! Crystal tilt angle in rad
  real(kind=fPrec), private, save :: cry_length = zero ! Crystal length [m]
  real(kind=fPrec), private, save :: cry_bend   = zero ! Crystal bending angle in rad

  ! Rutherford Scatter
  real(kind=fPrec), parameter     :: tlcut_cry = 0.0009982_fPrec
  real(kind=fPrec), private, save :: cgen_cry(200)
  real(kind=fPrec), private, save :: zatom_curr_cry
  real(kind=fPrec), private, save :: emr_curr_cry

  real(kind=fPrec), private, save :: enr
  real(kind=fPrec), private, save :: mom
  real(kind=fPrec), private, save :: betar
  real(kind=fPrec), private, save :: gammar
  real(kind=fPrec), private, save :: bgr
  real(kind=fPrec), private, save :: tmax
  real(kind=fPrec), private, save :: plen

  real(kind=fPrec), parameter :: aTF = 0.194e-10_fPrec ! Screening function [m]
  real(kind=fPrec), parameter :: dP  = 1.920e-10_fPrec ! Distance between planes (110) [m]
  real(kind=fPrec), parameter :: u1  = 0.075e-10_fPrec ! Thermal vibrations amplitude

  ! pp cross-sections and parameters for energy dependence
  real(kind=fPrec), parameter :: pptref_cry = 0.040_fPrec
  real(kind=fPrec), parameter :: freeco_cry = 1.618_fPrec

  ! Crystal Specific Material Arrays
  ! logical,          private, save :: validMat(nmat) = .false. ! True for materials the crystal module supports
  ! real(kind=fPrec), private, save :: dlri(nmat)     = zero
  ! real(kind=fPrec), private, save :: dlyi(nmat)     = zero
  ! real(kind=fPrec), private, save :: ai(nmat)       = zero
  ! real(kind=fPrec), private, save :: eUm(nmat)      = zero
  ! real(kind=fPrec), private, save :: collnt(nmat)   = zero    ! Nuclear Collision length [m]

  ! Processes
  integer, parameter :: proc_out         =  -1     ! Crystal not hit
  integer, parameter :: proc_AM          =   1     ! Amorphous
  integer, parameter :: proc_VR          =   2     ! Volume reflection
  integer, parameter :: proc_CH          =   3     ! Channeling
  integer, parameter :: proc_VC          =   4     ! Volume capture
  integer, parameter :: proc_absorbed    =   5     ! Absorption
  integer, parameter :: proc_DC          =   6     ! Dechanneling
  integer, parameter :: proc_pne         =   7     ! Proton-neutron elastic interaction
  integer, parameter :: proc_ppe         =   8     ! Proton-proton elastic interaction
  integer, parameter :: proc_diff        =   9     ! Single diffractive
  integer, parameter :: proc_ruth        =  10     ! Rutherford scattering
  integer, parameter :: proc_ch_absorbed =  15     ! Channeling followed by absorption
  integer, parameter :: proc_ch_pne      =  17     ! Channeling followed by proton-neutron elastic interaction
  integer, parameter :: proc_ch_ppe      =  18     ! Channeling followed by proton-proton elastic interaction
  integer, parameter :: proc_ch_diff     =  19     ! Channeling followed by single diffractive
  integer, parameter :: proc_ch_ruth     =  20     ! Channeling followed by Rutherford scattering
  integer, parameter :: proc_TRVR        = 100     ! Volume reflection in VR-AM transition region
  integer, parameter :: proc_TRAM        = 101     ! Amorphous in VR-AM transition region

contains

! ================================================================================================ !
!  Initialise the crystal module
! ================================================================================================ !
! subroutine cry_init
! 
!   use coll_materials
! 
!   integer m
! 
!   ! dlri : Radiation length(m), updated from PDG for Si
!   ! dlyi : Nuclear length(m)
!   ! ai   : Si110 1/2 interplan. dist. mm, Ge taken from A. Fomin, Si from initial implementation
!   ! eUm  : Only for Si(110) and Ge(110) potent. [eV], Ge taken from A. Fomin, Si from initial implementation
! 
!   ! Si
!   m = collmat_getCollMatID("Si")
!   validMat(m) = .true.
!   dlri(m)     =  0.0937_fPrec
!   dlyi(m)     =  0.4652_fPrec
!   ai(m)       =  0.96e-7_fPrec
!   eUm(m)      = 21.34_fPrec
!   collnt(m)   =  0.3016_fPrec
! 
!   ! W
!   m = collmat_getCollMatID("W")
!   validMat(m) = .true.
!   dlri(m)     =  0.0035_fPrec
!   dlyi(m)     =  0.096_fPrec
!   ai(m)       =  0.56e-7_fPrec
!   eUm(m)      = 21.0_fPrec
!   collnt(m)   = zero
! 
!   ! C
!   m = collmat_getCollMatID("C")
!   validMat(m) = .true.
!   dlri(m)     =  0.188_fPrec
!   dlyi(m)     =  0.400_fPrec
!   ai(m)       =  0.63e-7_fPrec
!   eUm(m)      = 21.0_fPrec
!   collnt(m)   = zero
! 
!   ! Ge
!   m = collmat_getCollMatID("Ge")
!   validMat(m) = .true.
!   dlri(m)     =  0.02302_fPrec
!   dlyi(m)     =  0.2686_fPrec
!   ai(m)       =  1.0e-7_fPrec
!   eUm(m)      = 40.0_fPrec
!   collnt(m)   =  0.1632_fPrec
! 
! end subroutine cry_init

! ================================================================================================ !
!  Initialise a crystal collimator
! ================================================================================================ !

subroutine cry_startElement(c_length, new_length, c_rotation, cryTilt, cryBend, cryThick, cryXDim, &
                            cryYDim, cryOrient, cryMiscut)
  !use crcoall
  use coll_common, only: cry_proc
  !use coll_materials
  use mathlib_bouncer
  !use mod_common_track

  real(kind=fPrec), intent(in)    :: c_length     ! Collimator length in m
  real(kind=fPrec), intent(inout) :: new_length
  real(kind=fPrec), intent(in)    :: c_rotation   ! Collimator rotation angle vs vertical in radians
  real(kind=fPrec), intent(in)    :: cryTilt
  real(kind=fPrec), intent(in)    :: cryBend
  real(kind=fPrec), intent(in)    :: cryThick
  real(kind=fPrec), intent(in)    :: cryXDim
  real(kind=fPrec), intent(in)    :: cryYDim
  real(kind=fPrec), intent(in)    :: cryOrient
  real(kind=fPrec), intent(in)    :: cryMiscut

  real(kind=fPrec) bendAng

  cry_tilt = cryTilt       ! global variable

  bendAng  = c_length/cryBend     ! cryBend is bending radius
  if(cry_tilt >= (-one)*bendAng) then
    cry_length = cryBend*(sin_mb(bendAng + cry_tilt) - sin_mb(cry_tilt))
  else
    cry_length = cryBend*(sin_mb(bendAng - cry_tilt) + sin_mb(cry_tilt))
  end if

  c_rcurv  = cryBend
  c_alayer = cryThick
  c_xmax   = cryXDim
  c_ymax   = cryYDim
  c_orient = cryOrient
  c_miscut = cryMiscut
  cry_bend = cry_length/c_rcurv
  c_cBend  = cos_mb(cry_bend)
  c_sBend  = sin_mb(cry_bend)
  c_cpTilt = cos_mb(cry_tilt)
  c_spTilt = sin_mb(cry_tilt)
  c_cnTilt = cos_mb(-cry_tilt)
  c_snTilt = sin_mb(-cry_tilt)

  n_chan      = 0
  n_VR        = 0
  n_amorphous = 0

  cry_proc(:) = proc_out

  new_length = cry_length

end subroutine cry_startElement

! ================================================================================================ !
!  Subroutine for checking for interactions with crystal
! ================================================================================================ !
subroutine cry_doCrystal(j,x,xp,z,zp,s,p,x0,xp0,zlm,s_imp,isImp,nhit,nabs, &
  lhit,part_abs,impact,indiv,c_length, cry_do_exenergy, cry_do_anuc, cry_do_zatom, cry_do_emr, &
  cry_do_rho, cry_do_hcut, cry_do_bnref, cry_do_csref0, cry_do_csref1, cry_do_csref5, cry_do_dlri, &
  cry_do_dlyi, cry_do_eum, cry_do_ai, cry_do_collnt)

  use parpro
  use coll_common, only : cry_proc, cry_proc_prev, cry_proc_tmp
  use mathlib_bouncer

  integer,          intent(in)    :: j
  ! integer,          intent(in)    :: mat

  real(kind=fPrec), intent(inout) :: x,xp
  real(kind=fPrec), intent(inout) :: z,zp
  real(kind=fPrec), intent(inout) :: s,p
  real(kind=fPrec), intent(inout) :: x0,xp0
  real(kind=fPrec), intent(inout) :: zlm,s_imp
  integer,          intent(inout) :: nhit,nabs
  integer,          intent(inout) :: lhit(npart)
  integer,          intent(inout) :: part_abs(npart)
  real(kind=fPrec), intent(inout) :: impact(npart)
  real(kind=fPrec), intent(inout) :: indiv(npart)
  real(kind=fPrec), intent(in)    :: c_length
  real(kind=fPrec), intent(in)    :: cry_do_exenergy
  real(kind=fPrec), intent(in)    :: cry_do_anuc
  real(kind=fPrec), intent(in)    :: cry_do_zatom
  real(kind=fPrec), intent(in)    :: cry_do_emr
  real(kind=fPrec), intent(in)    :: cry_do_rho
  real(kind=fPrec), intent(in)    :: cry_do_hcut
  real(kind=fPrec), intent(in)    :: cry_do_bnref
  real(kind=fPrec), intent(in)    :: cry_do_csref0
  real(kind=fPrec), intent(in)    :: cry_do_csref1
  real(kind=fPrec), intent(in)    :: cry_do_csref5
  real(kind=fPrec), intent(in)    :: cry_do_dlri
  real(kind=fPrec), intent(in)    :: cry_do_dlyi
  real(kind=fPrec), intent(in)    :: cry_do_eum
  real(kind=fPrec), intent(in)    :: cry_do_ai
  real(kind=fPrec), intent(in)    :: cry_do_collnt

  logical,          intent(inout) :: isImp

  real(kind=fPrec) s_temp,s_shift,s_rot,s_int
  real(kind=fPrec) x_temp,x_shift,x_rot,x_int
  real(kind=fPrec) xp_temp,xp_shift,xp_rot,xp_int,xp_tangent
  real(kind=fPrec) tilt_int,shift,delta,a_eq,b_eq,c_eq
  real(kind=fPrec) s_P, x_P, s_P_tmp, x_P_tmp

  s_temp     = zero
  s_shift    = zero
  s_rot      = zero
  s_int      = zero
  x_temp     = zero
  x_shift    = zero
  x_rot      = zero
  x_int      = zero
  xp_temp    = zero
  xp_shift   = zero
  xp_rot     = zero
  xp_int     = zero
  xp_tangent = zero
  tilt_int   = zero
  shift      = zero
  delta      = zero
  a_eq       = zero
  b_eq       = zero
  c_eq       = zero
  s_imp      = zero

  ! Determining if particle previously interacted with a crystal and storing the process ID
  if(cry_proc_tmp(j) /= proc_out) then
    cry_proc_prev(j) = cry_proc_tmp(j)
  end if

  iProc       = proc_out
  cry_proc(j) = proc_out

  ! Transform in the crystal reference system
  ! 1st transformation: shift of the center of the reference frame
  if(cry_tilt < zero) then
    s_shift = s
    shift   = c_rcurv*(one - c_cpTilt)
    if(cry_tilt < -cry_bend) then
      shift = c_rcurv*(c_cnTilt - cos_mb(cry_bend - cry_tilt))
    end if
    x_shift = x - shift
  else
    s_shift = s
    x_shift = x
  end if
  
  ! 2nd transformation: rotation
  s_rot  = x_shift*c_spTilt + s_shift*c_cpTilt
  x_rot  = x_shift*c_cpTilt - s_shift*c_spTilt
  xp_rot = xp - cry_tilt

  ! 3rd transformation: drift to the new coordinate s=0
  xp = xp_rot
  x  = x_rot - xp_rot*s_rot
  z  = z - zp*s_rot
  s  = zero
  
  ! Check that particle hit the crystal
  if(x >= zero .and. x < c_xmax) then
    ! MISCUT first step: P coordinates (center of curvature of crystalline planes)
    s_P = (c_rcurv-c_xmax)*sin_mb(-c_miscut)
    x_P = c_xmax + (c_rcurv-c_xmax)*cos_mb(-c_miscut)

    call cry_interact(x,xp,z,zp,p,cry_length,s_P,x_P, cry_do_exenergy, cry_do_anuc, cry_do_zatom, &
                     cry_do_emr, cry_do_rho, cry_do_hcut, cry_do_bnref, cry_do_csref0, cry_do_csref1, &
                     cry_do_csref5, cry_do_dlri, cry_do_dlyi, cry_do_eum, cry_do_ai, cry_do_collnt)
    s   = c_rcurv*c_sBend
    zlm = c_rcurv*c_sBend
    if(iProc /= proc_out) then
      isImp        = .true.
      nhit         = nhit + 1
      lhit(j)      = 1
      impact(j)    = x0
      indiv(j)     = xp0
    end if

  else

    if(x < zero) then ! Crystal can be hit from below
      xp_tangent = sqrt((-(two*x)*c_rcurv + x**2)/(c_rcurv**2))
    else              ! Crystal can be hit from above
      xp_tangent = asin_mb((c_rcurv*(one - c_cBend) - x)/sqrt(((two*c_rcurv)*(c_rcurv - x))*(one - c_cBend) + x**2))
    end if

    ! If the hit is below, the angle must be greater or equal than the tangent,
    ! or if the hit is above, the angle must be smaller or equal than the tangent
    if((x < zero .and. xp >= xp_tangent) .or. (x >= zero .and. xp <= xp_tangent)) then

      ! If it hits the crystal, calculate in which point and apply the transformation and drift to that point
      a_eq  = one + xp**2
      b_eq  = (two*xp)*(x - c_rcurv)
      c_eq  = -(two*x)*c_rcurv + x**2
      delta = b_eq**2 - four*(a_eq*c_eq)
      s_int = (-b_eq - sqrt(delta))/(two*a_eq)
      s_imp = s_int

      ! MISCUT first step: P coordinates (center of curvature of crystalline planes)
      s_P_tmp = (c_rcurv-c_xmax)*sin_mb(-c_miscut)
      x_P_tmp = c_xmax + (c_rcurv-c_xmax)*cos_mb(-c_miscut)

      if(s_int < c_rcurv*c_sBend) then
        ! Transform to a new reference system: shift and rotate
        x_int  = xp*s_int + x
        xp_int = xp
        z      = z + zp*s_int
        x      = zero
        s      = zero

        tilt_int = s_int/c_rcurv
        xp       = xp-tilt_int

        ! MISCUT first step (bis): transform P in new reference system
        ! Translation
        s_P_tmp = s_P_tmp - s_int
        x_P_tmp = x_P_tmp - x_int
        ! Rotation
        s_P = s_P_tmp*cos_mb(tilt_int) + x_P_tmp*sin_mb(tilt_int)
        x_P = -s_P_tmp*sin_mb(tilt_int) + x_P_tmp*cos_mb(tilt_int)

        call cry_interact(x,xp,z,zp,p,cry_length-(tilt_int*c_rcurv),s_P,x_P, cry_do_exenergy, cry_do_anuc, cry_do_zatom, &
                     cry_do_emr, cry_do_rho, cry_do_hcut, cry_do_bnref, cry_do_csref0, cry_do_csref1, &
                     cry_do_csref5, cry_do_dlri, cry_do_dlyi, cry_do_eum, cry_do_ai, cry_do_collnt)
        s   = c_rcurv*sin_mb(cry_bend - tilt_int)
        zlm = c_rcurv*sin_mb(cry_bend - tilt_int)
        if(iProc /= proc_out) then
          x_rot    = x_int
          s_rot    = s_int
          xp_rot   = xp_int
          s_shift  =  s_rot*c_cnTilt + x_rot*c_snTilt
          x_shift  = -s_rot*c_snTilt + x_rot*c_cnTilt
          xp_shift = xp_rot + cry_tilt

          if(cry_tilt < zero) then
            x0  = x_shift + shift
            xp0 = xp_shift
          else
            x0  = x_shift
            xp0 = xp_shift
          end if

          isImp        = .true.
          nhit         = nhit + 1
          lhit(j)      = 1
          impact(j)    = x0
          indiv(j)     = xp0
        end if

        ! un-rotate
        x_temp  = x
        s_temp  = s
        xp_temp = xp
        s       =  s_temp*cos_mb(-tilt_int) + x_temp*sin_mb(-tilt_int)
        x       = -s_temp*sin_mb(-tilt_int) + x_temp*cos_mb(-tilt_int)
        xp      = xp_temp + tilt_int

        ! 2nd: shift back the 2 axis
        x = x + x_int
        s = s + s_int

      else

        s = c_rcurv*sin_mb(cry_length/c_rcurv)
        x = x + s*xp
        z = z + s*zp

      end if

    else

      s = c_rcurv*sin_mb(cry_length/c_rcurv)
      x = x + s*xp
      z = z + s*zp

    end if

  end if

  ! transform back from the crystal to the collimator reference system
  ! 1st: un-rotate the coordinates
  x_rot  = x
  s_rot  = s
  xp_rot = xp

  s_shift  =  s_rot*c_cnTilt + x_rot*c_snTilt
  x_shift  = -s_rot*c_snTilt + x_rot*c_cnTilt
  xp_shift = xp_rot + cry_tilt

  ! 2nd: shift back the reference frame
  if(cry_tilt < zero) then
    s  = s_shift
    x  = x_shift + shift
    xp = xp_shift
  else
    x  = x_shift
    s  = s_shift
    xp = xp_shift
  end if

  ! 3rd: shift to new S=Length position
  x = xp*(c_length - s) + x
  z = zp*(c_length - s) + z
  s = c_length

  nabs = 0
  cry_proc(j) = iProc
  if(iProc == proc_AM) then
    n_amorphous = n_amorphous + 1
  else if(iProc == proc_VR) then
    n_VR = n_VR + 1
  else if(iProc == proc_CH) then
    n_chan = n_Chan + 1
  else if(iProc == proc_absorbed) then
    nabs = 1   ! TODO: do we need to set part_abs_pos etc?
  else if(iProc == proc_ch_absorbed) then
    nabs = 1
  end if

  ! Storing the process ID for the next interaction
  cry_proc_tmp(j) = cry_proc(j)

end subroutine cry_doCrystal

! ================================================================================================ !
!  Subroutine for the movements of the particles in the crystal
!  Simple tranport protons in crystal 2
! ================================================================================================ !
subroutine cry_interact(x, xp, y, yp, pc, length, s_P, x_P, cry_int_exenergy, cry_int_anuc, &
                        cry_int_zatom, cry_int_emr, cry_int_rho, cry_int_hcut, cry_int_bnref, &
                        cry_int_csref0, cry_int_csref1, cry_int_csref5, cry_int_dlri, cry_int_dlyi, &
                        cry_int_eum, cry_int_ai, cry_int_collnt)

  use mod_ranlux
  use mod_funlux
  use mod_common_main
  use floatPrecision
  !use coll_materials, only : zatom, exenergy, rho, anuc
  use mathlib_bouncer
  use physical_constants

  ! integer,          intent(in)    :: is  ! Material number
  real(kind=fPrec), intent(inout) :: x
  real(kind=fPrec), intent(inout) :: xp
  real(kind=fPrec), intent(inout) :: y
  real(kind=fPrec), intent(inout) :: yp
  real(kind=fPrec), intent(inout) :: pc
  real(kind=fPrec), intent(in)    :: length
  real(kind=fPrec), intent(in)    :: s_P
  real(kind=fPrec), intent(in)    :: x_P
  real(kind=fPrec), intent(in)    :: cry_int_exenergy
  real(kind=fPrec), intent(in)    :: cry_int_anuc
  real(kind=fPrec), intent(in)    :: cry_int_zatom
  real(kind=fPrec), intent(in)    :: cry_int_emr
  real(kind=fPrec), intent(in)    :: cry_int_rho
  real(kind=fPrec), intent(in)    :: cry_int_hcut
  real(kind=fPrec), intent(in)    :: cry_int_bnref
  real(kind=fPrec), intent(in)    :: cry_int_csref0
  real(kind=fPrec), intent(in)    :: cry_int_csref1
  real(kind=fPrec), intent(in)    :: cry_int_csref5
  real(kind=fPrec), intent(in)    :: cry_int_dlri
  real(kind=fPrec), intent(in)    :: cry_int_dlyi
  real(kind=fPrec), intent(in)    :: cry_int_eum
  real(kind=fPrec), intent(in)    :: cry_int_ai
  real(kind=fPrec), intent(in)    :: cry_int_collnt
  

  integer nam,zn                        ! Switch on/off the nuclear interaction (NAM) and the MCS (ZN)
  real(kind=fPrec) ymax,ymin            ! Crystal geometrical parameters
  real(kind=fPrec) s_length             ! Element length along s
  real(kind=fPrec) DESt                 ! Changed energy loss by ionization now calculated and not tabulated
  real(kind=fPrec) x0,y0                ! Coordinates of the particle [m]
  real(kind=fPrec) s                    ! Long coordinates of the particle [m]
  real(kind=fPrec) a_eq,b_eq,c_eq,delta ! Second order equation param.
  real(kind=fPrec) Ang_rms, Ang_avr     ! Volume reflection mean angle [rad]
  real(kind=fPrec) Dechan               ! Probability for dechanneling
  real(kind=fPrec) Lrefl,Srefl          ! Distance of the reflection point [m]
  real(kind=fPrec) Vcapt                ! Volume capture probability
  real(kind=fPrec) Chann                ! Channeling probability
  real(kind=fPrec) N_atom               ! Probability for entering channeling near atomic planes
  real(kind=fPrec) Dxp                  ! Variation in angle
  real(kind=fPrec) xpcrit               ! Critical angle for curved crystal[rad]
  real(kind=fPrec) xpcrit0              ! Critical angle for str. crystal [rad]
  real(kind=fPrec) Rcrit                ! Critical curvature radius [m]
  real(kind=fPrec) ratio                ! X=c_rcurv/Rcrit
  real(kind=fPrec) TLdech1,TLdech2      ! Typical dechanneling length(2) [m]
  real(kind=fPrec) tdech,Ldech,Sdech    ! Angle, lenght, and S coordinate of dechanneling point
  real(kind=fPrec) Rlength,Red_S        ! Reduced length/s coordinate (in case of dechanneling)
  real(kind=fPrec) am_len               ! Amorphous length
  real(kind=fPrec) len_xs,len_ys        ! Amorphous length
  real(kind=fPrec) xp_rel               ! Xp-c_miscut angle in mrad
  real(kind=fPrec) alpha                ! Par for new chann prob
  real(kind=fPrec) Pvr                  ! Prob for VR->AM transition

  ! Quantities for length and deflection calculation
  real(kind=fPrec) const_dech,xpin,ypin,tchan,tdefl,tP,L_chan,mep
  real(kind=fPrec) s_K,x_K,s_M,x_M,s_F,x_F,r,a
  real(kind=fPrec) A_F,B_F,C_F,alpha_F,beta_F

  real(kind=fPrec), parameter :: c_v1 =  1.7_fPrec ! Fitting coefficient
  real(kind=fPrec), parameter :: c_v2 = -1.5_fPrec ! Fitting coefficient

  nam = 1 ! Switch on/off the nuclear interaction (NAM) and the MCS (ZN)
  zn  = 1

  ! dE/dX and dechanneling length calculation
  mom    = pc*c1e3                ! [GeV]
  enr    = sqrt(mom**2 + pmap**2) ! [MeV]
  gammar = enr/pmap
  betar  = mom/enr
  bgr    = betar*gammar
  mep    = pmae/pmap  ! Electron/proton

  tmax = (two*pmae*bgr**2)/(one + two*gammar*mep + mep**2)  ! [MeV]
  plen = sqrt((cry_int_rho*cry_int_zatom)/cry_int_anuc)*28.816e-6_fPrec ! [MeV]

  const_dech = ((256.0_fPrec/(nine*pi**2)) * &
    (one/(log_mb(((two*pmae)*gammar)/(cry_int_exenergy*c1e3)) - one))) * ((aTF*dP)/(crade*pmae)) ! [m/MeV]
  const_dech = const_dech*c1e3 ! [m/GeV]

  s        = zero
  s_length = c_rcurv*sin_mb(length/c_rcurv)
  L_chan   = length

  ! MISCUT second step: fundamental coordinates (crystal edges and plane curvature radius)
  s_K = c_rcurv*sin_mb(length/c_rcurv)
  x_K = c_rcurv*(1-cos_mb(length/c_rcurv))
  s_M = (c_rcurv-c_xmax)*sin_mb(length/c_rcurv)
  x_M = c_xmax + (c_rcurv-c_xmax)*(1-cos_mb(length/c_rcurv))
  r   = sqrt(s_P**2 + (x-x_P)**2)

  ! MISCUT third step: F coordinates (exit point) on crystal exit face
  A_F = (tan_mb(length/c_rcurv))**2 + one
  B_F = ((-two)*(tan_mb(length/c_rcurv))**2)*c_rcurv + (two*tan_mb(length/c_rcurv))*s_P - two*x_P
  C_F = ((tan_mb(length/c_rcurv))**2)*(c_rcurv**2) - ((two*tan_mb(length/c_rcurv))*s_P)*c_rcurv + s_P**2 + x_P**2 - r**2

  x_F = (-B_F-sqrt(B_F**2-four*(A_F*C_F)))/(two*A_F)
  s_F = (-tan_mb(length/c_rcurv))*(x_F-c_rcurv)

  if(x_F >= x_K .and. x_F <= x_M .and. s_F >= s_M .and. s_F <= s_K) then
    ! No additional steps required for miscut
  else if (c_miscut == 0 .and. abs(x_F-x_K) <= c1m13 .and. abs(s_F-s_K) <= c1m13) then
    ! no miscut, entrance from below: exit point is K (lower edge)
    x_F = x_K
    s_F = s_K
  else if (c_miscut == 0 .and. abs(x_F-x_M) <= c1m13 .and. abs(s_F-s_M) <= c1m13) then
    ! no miscut, entrance from above: exit point is M (upper edge)
    x_F = x_M
    s_F = s_M
  else

    ! MISCUT Third step (bis): F coordinates (exit point)  on bent side
    if(c_miscut < 0) then
      ! Intersect with bottom side
      alpha_F = (c_rcurv-x_P)/x_P
      beta_F = -(r**2-s_P**2-x_P**2)/(two*s_P)
      A_F = alpha_F**2 + one
      B_F = two*(alpha_F*beta_F) - two*c_rcurv
      C_F = beta_F**2
    else
      ! Intersect with top side
      alpha_F = (c_rcurv-x_P)/s_P
      beta_F = -(r**2+c_xmax*(c_xmax-(two*c_rcurv))-s_P**2-x_P**2)/(two*s_P)
      A_F = alpha_F**2 + one
      B_F = two*(alpha_F*beta_F) - two*c_rcurv
      C_F = beta_F**2 - c_xmax*(c_xmax-two*c_rcurv)
    endif
    
    x_F = (-B_F-sqrt(B_F**2-four*(A_F*C_F)))/(two*A_F)
    s_F = alpha_F*x_F + beta_F
    
  endif

  ! MISCUT fourth step: deflection and length calculation
  a = sqrt(s_F**2+(x-x_F)**2)
  tP = acos_mb((2*(r**2)-a**2)/(2*(r**2)))
  tdefl = asin_mb((s_f-s_P)/r)
  L_chan = r*tP

  xp_rel = xp - c_miscut

  ymin = -c_ymax/two
  ymax =  c_ymax/two

  ! FIRST CASE: p don't interact with crystal
  if(y < ymin .or. y > ymax .or. x > c_xmax) then
    x     = x + xp*s_length
    y     = y + yp*s_length
    iProc = proc_out
    return

  ! SECOND CASE: p hits the amorphous layer
  else if(x < c_alayer .or. y-ymin < c_alayer .or. ymax-y < c_alayer) then
    x0    = x
    y0    = y
    a_eq  = one + xp**2
    b_eq  = (two*x)*xp - (two*xp)*c_rcurv
    c_eq  = x**2 - (two*x)*c_rcurv
    delta = b_eq**2 - (four*a_eq)*c_eq
    s     = (-b_eq+sqrt(delta))/(two*a_eq)
    if(s >= s_length) then
      s = s_length
    end if
    x         =  xp*s + x0
    len_xs = sqrt((x-x0)**2 + s**2)
    if(yp >= zero .and. y + yp*s <= ymax) then
      len_ys = yp*len_xs
    else if(yp < zero .and. y + yp*s >= ymin) then
      len_ys = yp*len_xs
    else
      s      = (ymax-y)/yp
      len_ys = sqrt((ymax-y)**2 + s**2)
      x      = x0 + xp*s
      len_xs = sqrt((x-x0)**2 + s**2)
    end if
    am_len = sqrt(len_xs**2 + len_ys**2)
    s     = s/two
    x     = x0 + xp*s
    y     = y0 + yp*s
    iProc = proc_AM
    call cry_calcIonLoss(pc,am_len,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
    call cry_moveAM(nam,am_len,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
    x = x + xp*(s_length-s)
    y = y + yp*(s_length-s)
    return

  else if(x > c_xmax-c_alayer .and. x < c_xmax) then
    iProc = proc_AM
    call cry_calcIonLoss(pc,s_length,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
    call cry_moveAM(nam,s_length,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
    return

  end if

  ! THIRD CASE: the p interacts with the crystal.
  ! Define typical angles/probabilities for orientation 110
  xpcrit0 = sqrt((c2m9*cry_int_eUm)/pc)    ! Critical angle (rad) for straight crystals
  Rcrit   = (pc/(c2m6*cry_int_eUm))*cry_int_ai ! Critical curvature radius [m]

  ! If R>Rcritical=>no channeling is possible (ratio<1)
  ratio  = c_rcurv/Rcrit
  xpcrit = (xpcrit0*(c_rcurv-Rcrit))/c_rcurv ! Critical angle for curved crystal

  if(ratio <= one) then ! no possibile channeling
    Ang_rms = ((c_v1*0.42_fPrec)*xpcrit0)*sin_mb(1.4_fPrec*ratio) ! RMS scattering
    Ang_avr = ((c_v2*xpcrit0)*c5m2)*ratio                         ! Average angle reflection
    Vcapt   = zero                                                ! Probability of VC

  else if(ratio <= three) then ! Strongly bent crystal
    Ang_rms = ((c_v1*0.42_fPrec)*xpcrit0)*sin_mb(0.4713_fPrec*ratio + 0.85_fPrec) ! RMS scattering
    Ang_avr = (c_v2*xpcrit0)*(0.1972_fPrec*ratio - 0.1472_fPrec)                  ! Average angle reflection
    Vcapt   = 7.0e-4_fPrec*(ratio - 0.7_fPrec)/pc**c2m1                           ! Correction by sasha drozdin/armen
    ! K=0.0007 is taken based on simulations using CATCH.f (V.Biryukov)

  else ! Rcry >> Rcrit
    Ang_rms = (c_v1*xpcrit0)*(one/ratio)                ! RMS scattering
    Ang_avr = (c_v2*xpcrit0)*(one - 1.6667_fPrec/ratio) ! Average angle for VR
    Vcapt   = 7.0e-4_fPrec*(ratio - 0.7_fPrec)/pc**c2m1 ! Probability for VC correction by sasha drozdin/armen
    ! K=0.0007 is taken based on simulations using CATCH.f (V.Biryukov)

  end if

  if(c_orient == 2) then
    Ang_avr = Ang_avr*0.93_fPrec
    Ang_rms = Ang_rms*1.05_fPrec
    xpcrit  = xpcrit*0.98_fPrec
  end if

  if(abs(xp_rel) < xpcrit) then
    alpha  = xp_rel/xpcrit
    Chann  = sqrt(0.9_fPrec*(one - alpha**2))*sqrt(one-(one/ratio)) ! Saturation at 95%
    N_atom = c1m1

    ! if they can channel: 2 options
    if(coll_rand() <= chann) then ! option 1:channeling

      TLdech1 = (const_dech*pc)*(one-one/ratio)**2 ! Updated calculate typical dech. length(m)
      if(coll_rand() <= n_atom) then
        TLdech1 = ((const_dech/c2e2)*pc)*(one-one/ratio)**2  ! Updated dechanneling length (m)
      end if

      Dechan = -log_mb(coll_rand()) ! Probability of dechanneling
      Ldech  = TLdech1*Dechan   ! Actual dechan. length

      ! careful: the dechanneling lentgh is along the trajectory
      ! of the particle -not along the longitudinal coordinate...
      if(ldech < l_chan) then
        iProc = proc_DC
        Dxp   = Ldech/r ! Change angle from channeling [mrad]
        Sdech = Ldech*cos_mb(c_miscut + half*Dxp)
        x     = x  + Ldech*(sin_mb(half*Dxp+c_miscut)) ! Trajectory at channeling exit
        xp    = xp + Dxp + (two*(coll_rand()-half))*xpcrit
        y     = y  + yp * Sdech

        call cry_calcIonLoss(pc,ldech,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
        pc = pc - half*dest*Ldech ! Energy loss to ionization while in CH [GeV]
        x  = x  + (half*(s_length-Sdech))*xp
        y  = y  + (half*(s_length-Sdech))*yp

        call cry_calcIonLoss(pc,s_length-sdech,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
        call cry_moveAM(nam,s_length-sdech,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
        x = x + (half*(s_length-Sdech))*xp
        y = y + (half*(s_length-Sdech))*yp
      else
        iProc = proc_CH
        xpin  = XP
        ypin  = YP

        call cry_moveCH(nam,l_chan,x,xp,yp,pc,c_rcurv,rcrit, cry_int_anuc, cry_int_zatom, &
                        cry_int_emr, cry_int_rho, cry_int_hcut, cry_int_bnref, cry_int_csref0, &
                        cry_int_csref1, cry_int_csref5, cry_int_eum, cry_int_collnt)
                        ! check if a nuclear interaction happen while in CH
        if(iProc /= proc_CH) then
          ! if an nuclear interaction happened, move until the middle with initial xp,yp then
          ! propagate until the "crystal exit" with the new xp,yp accordingly with the rest
          ! of the code in "thin lens approx"
          x = x + (half*L_chan)*xpin
          y = y + (half*L_chan)*ypin
          x = x + (half*L_chan)*XP
          y = y + (half*L_chan)*YP

          call cry_calcIonLoss(pc,length,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          pc = pc - dest*length ! energy loss to ionization [GeV]
        else
          Dxp = tdefl + (half*ran_gauss(zero))*xpcrit ! Change angle[rad]
        
          xp  = Dxp
          x   = x + L_chan*(sin_mb(half*Dxp)) ! Trajectory at channeling exit
          y   = y + s_length * yp

          call cry_calcIonLoss(pc,length,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          pc = pc - (half*dest)*length ! energy loss to ionization [GeV]
        end if
      end if

    else ! Option 2: VR

      ! good for channeling but don't channel (1-2)
      iProc = proc_VR

      xp = xp + (0.45_fPrec*(xp_rel/xpcrit + one))*Ang_avr
      x  = x  + (half*s_length)*xp
      y  = y  + (half*s_length)*yp

      call cry_calcIonLoss(pc,s_length,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
      call cry_moveAM(nam,s_length,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)

      x = x + (half*s_length)*xp
      y = y + (half*s_length)*yp

    end if

  else ! case 3-2: no good for channeling. check if the  can VR

    Lrefl = xp_rel*r ! Distance of refl. point [m]
    Srefl = sin_mb(xp_rel/two + c_miscut)*Lrefl

    if(Lrefl > zero .and. Lrefl < L_chan) then ! VR point inside

      ! 2 options: volume capture and volume reflection

      if(coll_rand() > Vcapt .or. ZN == zero) then ! Option 1: VR

        iProc = proc_VR
        x     = x + xp*Srefl
        y     = y + yp*Srefl
        Dxp   = Ang_avr
        xp    = xp + Dxp + Ang_rms*ran_gauss(zero)
        x     = x  + (half*xp)*(s_length - Srefl)
        y     = y  + (half*yp)*(s_length - Srefl)

        call cry_calcIonLoss(pc,s_length-srefl,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
        call cry_moveAM(nam,s_length-srefl,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
        x = x + (half*xp)*(s_length - Srefl)
        y = y + (half*yp)*(s_length - Srefl)

      else ! Option 2: VC

        x = x + xp*Srefl
        y = y + yp*Srefl

        TLdech2 = (const_dech/c1e1)*pc*(one-one/ratio)**2          ! Updated typical dechanneling length(m)
        Ldech   = TLdech2*(sqrt(c1m2 - log_mb(coll_rand())) - c1m1)**2 ! Updated DC length
        tdech   = Ldech/c_rcurv
        Sdech   = Ldech*cos_mb(xp + half*tdech)

        if(Ldech < Length-Lrefl) then

          iProc = proc_DC
          Dxp   = Ldech/c_rcurv + (half*ran_gauss(zero))*xpcrit
          x     = x + Ldech*(sin_mb(half*Dxp+xp)) ! Trajectory at channeling exit
          y     = y + Sdech*yp
          xp    =  Dxp
          Red_S = (s_length - Srefl) - Sdech
          x     = x + (half*xp)*Red_S
          y     = y + (half*yp)*Red_S

          call cry_calcIonLoss(pc,srefl,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          pc = pc - dest*Srefl ! "added" energy loss before capture

          call cry_calcIonLoss(pc,sdech,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          pc = pc - (half*dest)*Sdech ! "added" energy loss while captured

          call cry_calcIonLoss(pc,red_s,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          call cry_moveAM(nam,red_s,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
          x = x + (half*xp)*Red_S
          y = y + (half*yp)*Red_S

        else

          iProc   = proc_VC
          Rlength = Length - Lrefl
          tchan   = Rlength/c_rcurv
          Red_S   = Rlength*cos_mb(xp + half*tchan)

          call cry_calcIonLoss(pc,lrefl,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          pc   = pc - dest*Lrefl ! "added" energy loss before capture
          xpin = xp
          ypin = yp

          call cry_moveCH(nam,rlength,x,xp,yp,pc,c_rcurv,rcrit, cry_int_anuc, cry_int_zatom, &
                        cry_int_emr, cry_int_rho, cry_int_hcut, cry_int_bnref, cry_int_csref0, &
                        cry_int_csref1, cry_int_csref5, cry_int_eum, cry_int_collnt)
                        ! check if a nuclear interaction happen while in CH
          if(iProc /= proc_VC) then
            ! if an nuclear interaction happened, move until the middle with initial xp,yp then propagate until
            ! the "crystal exit" with the new xp,yp accordingly with the rest of the code in "thin lens approx"
            x = x + (half*Rlength)*xpin
            y = y + (half*Rlength)*ypin
            x = x + (half*Rlength)*XP
            y = y + (half*Rlength)*YP

            call cry_calcIonLoss(pc,rlength,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
            pc = pc - dest*Rlength
          else
            Dxp = (Length-Lrefl)/c_rcurv
            x   = x + sin_mb(half*Dxp+xp)*Rlength ! Trajectory at channeling exit
            y   = y + red_S*yp
            xp  = tdefl + (half*ran_gauss(zero))*xpcrit ! [mrad]

            call cry_calcIonLoss(pc,rlength,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
            pc = pc - (half*dest)*Rlength  ! "added" energy loss once captured
          end if
        end if
      end if

    else

      ! Case 3-3: move in amorphous substance (big input angles)
      ! Modified for transition vram daniele
      if(xp_rel > tdefl-c_miscut + two*xpcrit .or. xp_rel < -xpcrit) then
        iProc = proc_AM
        x     = x + (half*s_length)*xp
        y     = y + (half*s_length)*yp
        if(zn > zero) then
          call cry_calcIonLoss(pc,s_length,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          call cry_moveAM(nam,s_length,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
        end if
        x = x + (half*s_length)*xp
        y = y + (half*s_length)*yp
      else
        Pvr = (xp_rel-(tdefl-c_miscut))/(two*xpcrit)
        if(coll_rand() > Pvr) then
          iProc = proc_TRVR
          x     = x + xp*Srefl
          y     = y + yp*Srefl

          Dxp = (((-three*Ang_rms)*xp_rel)/(two*xpcrit) + Ang_avr) + ((three*Ang_rms)*(tdefl-c_miscut))/(two*xpcrit)
          xp  = xp + Dxp
          x   = x + (half*xp)*(s_length-Srefl)
          y   = y + (half*yp)*(s_length-Srefl)

          call cry_calcIonLoss(pc,s_length-srefl,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          call cry_moveAM(nam,s_length-srefl,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
          x = x + (half*xp)*(s_length - Srefl)
          y = y + (half*yp)*(s_length - Srefl)
        else
          iProc = proc_TRAM
          x = x + xp*Srefl
          y = y + yp*Srefl
          Dxp = ((((-one*(13.6_fPrec/pc))*sqrt(s_length/cry_int_dlri))*c1m3)*xp_rel)/(two*xpcrit) + &
            (((13.6_fPrec/pc)*sqrt(s_length/cry_int_dlri))*c1m3)*(one+(tdefl-c_miscut)/(two*xpcrit))
          xp = xp+Dxp
          x  = x + (half*xp)*(s_length-Srefl)
          y  = y + (half*yp)*(s_length-Srefl)

          call cry_calcIonLoss(pc,s_length-srefl,dest, cry_int_exenergy, cry_int_anuc, cry_int_zatom, cry_int_rho)
          call cry_moveAM(nam,s_length-srefl,dest,cry_int_dlyi,cry_int_dlri,xp,yp,pc, cry_int_anuc, cry_int_zatom, &
                    cry_int_emr, cry_int_hcut, cry_int_bnref, cry_int_csref0, cry_int_csref1, &
                    cry_int_csref5, cry_int_collnt)
          x = x + (half*xp)*(s_length - Srefl)
          y = y + (half*yp)*(s_length - Srefl)
        end if
      end if
    end if
  end if

end subroutine cry_interact

! ================================================================================================ !
!  Subroutine for the calculazion of the energy loss by ionisation
! ================================================================================================ !
subroutine cry_calcIonLoss(pc,dz,EnLo, cry_ci_exenergy, cry_ci_anuc, cry_ci_zatom, cry_ci_rho)

  use mod_ranlux
  use mod_funlux
  use floatPrecision
  !use coll_materials, only : zatom, exenergy, rho, anuc
  use mathlib_bouncer
  use physical_constants

  real(kind=fPrec), intent(in)  :: pc
  real(kind=fPrec), intent(in)  :: dz
  real(kind=fPrec), intent(out) :: EnLo
  real(kind=fPrec), intent(in)    :: cry_ci_exenergy
  real(kind=fPrec), intent(in)    :: cry_ci_anuc
  real(kind=fPrec), intent(in)    :: cry_ci_zatom
  real(kind=fPrec), intent(in)    :: cry_ci_rho

  real(kind=fPrec) thl,tt,cs_tail,prob_tail
  real(kind=fPrec), parameter :: k = 0.307075_fPrec ! Constant in front bethe-bloch [mev g^-1 cm^2]

  thl       = (((((four*k)*cry_ci_zatom)*dz)*c1e2)*cry_ci_rho)/(cry_ci_anuc*betar**2) ! [MeV]
  EnLo      = ((k*cry_ci_zatom)/(cry_ci_anuc*betar**2)) * ( &
    half*log_mb(((((two*pmae)*bgr)*bgr)*Tmax)/(c1e6*cry_ci_exenergy**2)) - &
    betar**2 - log_mb(plen/(cry_ci_exenergy*c1e3)) - log_mb(bgr) + half    &
  )
  EnLo      = ((EnLo*cry_ci_rho)*c1m1)*dz ! [GeV]
  Tt        = (EnLo*c1e3)+thl          ! [MeV]

  cs_tail   = ((k*cry_ci_zatom)/(cry_ci_anuc*betar**2)) * ((half*((one/Tt)-(one/Tmax))) - &
    (log_mb(Tmax/Tt)*(betar**2)/(two*Tmax)) + ((Tmax-Tt)/((four*(gammar**2))*(pmap**2))))
  prob_tail = ((cs_tail*cry_ci_rho)*dz)*c1e2

  if(coll_rand() < prob_tail) then
    EnLo = ((k*cry_ci_zatom)/(cry_ci_anuc*betar**2)) * ( &
      half*log_mb((two*pmae*bgr*bgr*Tmax)/(c1e6*cry_ci_exenergy**2)) -      &
      betar**2 - log_mb(plen/(cry_ci_exenergy*c1e3)) - log_mb(bgr) + half + &
      TMax**2/(eight*(gammar**2)*(pmap**2)) &
    )
    EnLo = (EnLo*cry_ci_rho)*c1m1 ! [GeV/m]
  else
    EnLo = EnLo/dz ! [GeV/m]
  end if

end subroutine cry_calcIonLoss

! ================================================================================================ !
!  Subroutine for the movement in the amorphous
! ================================================================================================ !
subroutine cry_moveAM(nam,dz,dei,dly,dlr,xp,yp,pc, cry_am_anuc, cry_am_zatom, cry_am_emr, cry_am_hcut, &
                      cry_am_bnref, cry_am_csref0, cry_am_csref1, cry_am_csref5, cry_am_collnt)

  use mod_ranlux
  use mod_funlux
  use floatPrecision
  ! use coll_materials, only : anuc, hcut, bnref, csref
  use mathlib_bouncer
  use physical_constants

  !integer,          intent(in)    :: is
  integer,          intent(in)    :: nam
  real(kind=fPrec), intent(in)    :: dz
  real(kind=fPrec), intent(in)    :: dei
  real(kind=fPrec), intent(in)    :: dly
  real(kind=fPrec), intent(in)    :: dlr
  real(kind=fPrec), intent(inout) :: xp
  real(kind=fPrec), intent(inout) :: yp
  real(kind=fPrec), intent(inout) :: pc
  
  real(kind=fPrec), intent(in)    :: cry_am_anuc
  real(kind=fPrec), intent(in)    :: cry_am_zatom
  real(kind=fPrec), intent(in)    :: cry_am_emr
  real(kind=fPrec), intent(in)    :: cry_am_hcut
  real(kind=fPrec), intent(in)    :: cry_am_bnref
  real(kind=fPrec), intent(in)    :: cry_am_csref0
  real(kind=fPrec), intent(in)    :: cry_am_csref1
  real(kind=fPrec), intent(in)    :: cry_am_csref5
  real(kind=fPrec), intent(in)    :: cry_am_collnt

  integer i,length_cry,ichoix
  real(kind=fPrec) t,xran_cry(1),bn,cs(0:5),cprob(0:5),freep,zlm,xp_in,yp_in,xm2,xln15s,tz,tx,tlow, &
    thigh,teta,pptot,ppsd,ppel,pc_in,kymcs,kxmcs,ecmsq,dya,bsd,bpp,aran

  xp_in = xp
  yp_in = yp
  pc_in = pc

  ! New treatment of scattering routine based on standard sixtrack routine
  ! useful calculations for cross-section and event topology calculation
  ecmsq  = ((two*pmap)*c1m3)*pc
  xln15s = log_mb(0.15_fPrec*ecmsq)

  ! New models, see Claudia's thesis
  pptot = (0.041084_fPrec - 0.0023302_fPrec*log_mb(ecmsq)) + 0.00031514_fPrec*log_mb(ecmsq)**2
  ppel  = (11.7_fPrec - 1.59_fPrec*log_mb(ecmsq) + 0.134_fPrec*log_mb(ecmsq)**2)/c1e3
  ppsd  = (4.3_fPrec + 0.3_fPrec*log_mb(ecmsq))/c1e3
  bpp   = 7.156_fPrec + 1.439_fPrec*log_mb(sqrt(ecmsq))

  ! Distribution for Ruth. scatt.
  tlow      = tlcut_cry
  zatom_curr_cry = cry_am_zatom
  emr_curr_cry = cry_am_emr
  thigh     = cry_am_hcut
  call funlxp(cry_ruth,cgen_cry(1),tlow,thigh)

  ! Cross-section calculation
  ! freep: number of nucleons involved in single scattering
  freep = freeco_cry * cry_am_anuc**(one/three)

  ! Compute pp and pn el+single diff contributions to cross-section (both added : quasi-elastic or qel later)
  cs(3) = freep*ppel
  cs(4) = freep*ppsd

  ! Correct TOT-CSec for energy dependence of qel
  ! TOT CS is here without a Coulomb contribution
  cs(0) = cry_am_csref0 + freep*(pptot - pptref_cry)
  bn    = (cry_am_bnref*cs(0))/cry_am_csref0

  ! Also correct inel-CS
  cs(1) = (cry_am_csref1*cs(0))/cry_am_csref0

  ! Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
  cs(2) = ((cs(0) - cs(1)) - cs(3)) - cs(4)
  cs(5) = cry_am_csref5

  ! Now add Coulomb
  cs(0) = cs(0) + cs(5)

  ! Calculate cumulative probability
  cprob(:) = zero
  cprob(5) = one
  do i=1,4
    cprob(i) = cprob(i-1) + cs(i)/cs(0)
  end do

  ! Multiple Coulomb Scattering
  xp  = xp*c1e3
  yp  = yp*c1e3
  pc  = pc - dei*dz ! Energy lost because of ionization process[GeV]

  dya   = (13.6_fPrec/pc)*sqrt(dz/dlr) ! RMS of coloumb scattering MCS (mrad)
  kxmcs = dya*ran_gauss(zero)
  kymcs = dya*ran_gauss(zero)

  xp = xp+kxmcs
  yp = yp+kymcs

  if(nam == 0) return ! Turn on/off nuclear interactions

  ! Can nuclear interaction happen?
  zlm = -cry_am_collnt*log_mb(coll_rand())

  if(zlm < dz) then
    ! Choose nuclear interaction
    aran = coll_rand()
    i=1
10  if(aran > cprob(i)) then
      i = i+1
      goto 10
    end if
    ichoix = i

    ! Do the interaction
    t = 0 ! default value to cover ichoix=1
    select case(ichoix)
    case(1) ! Deep inelastic, impinging p disappeared
      iProc = proc_absorbed

    case(2) ! p-n elastic
      iProc = proc_pne
      t     = -log_mb(coll_rand())/bn

    case(3) ! p-p elastic
      iProc = proc_ppe
      t     = -log_mb(coll_rand())/bpp

    case(4) ! Single diffractive
      iProc = proc_diff
      xm2   = exp_mb(coll_rand()*xln15s)
      pc    = pc*(one - xm2/ecmsq)
      if(xm2 < two) then
        bsd = two*bpp
      else if(xm2 >= two .and. xm2 <= five) then
        bsd = ((106.0_fPrec - 17.0_fPrec*xm2)*bpp)/36.0_fPrec
      else if(xm2 > five) then
        bsd = 7.0_fPrec*bpp/12.0_fPrec
      end if
      t = -log_mb(coll_rand())/bsd

    case(5)
      iProc      = proc_ruth
      length_cry = 1
      call funlux(cgen_cry(1),xran_cry,length_cry)
      t = xran_cry(1)

    end select

    ! Calculate the related kick
    if(ichoix == 4) then
      teta = sqrt(t)/pc_in ! DIFF has changed PC
    else
      teta = sqrt(t)/pc
    end if

    tx = (teta*ran_gauss(zero))*c1e3
    tz = (teta*ran_gauss(zero))*c1e3

    ! Change p angle
    xp = xp + tx
    yp = yp + tz
  end if

  xp = xp/c1e3
  yp = yp/c1e3

end subroutine cry_moveAM

! ================================================================================================ !
!  Subroutine for check if a nuclear interaction happen while in channeling
! ================================================================================================ !
subroutine cry_moveCH(nam,dz,x,xp,yp,pc,r,rc, cry_ch_anuc, cry_ch_zatom, cry_ch_emr, cry_ch_rho, &
                      cry_ch_hcut, cry_ch_bnref, cry_ch_csref0, cry_ch_csref1, cry_ch_csref5, &
                      cry_ch_eum, cry_ch_collnt)

  use crcoall
  use mod_ranlux
  use mod_funlux
  use floatPrecision
  use coll_common, only : coll_debug
  use coll_materials, only : csect
  use mathlib_bouncer
  use physical_constants

  integer,          intent(in)    :: nam
  real(kind=fPrec), intent(in)    :: dz
  real(kind=fPrec), intent(inout) :: x
  real(kind=fPrec), intent(inout) :: xp
  real(kind=fPrec), intent(inout) :: yp
  real(kind=fPrec), intent(inout) :: pc
  real(kind=fPrec), intent(in)    :: r
  real(kind=fPrec), intent(in)    :: rc
  
  real(kind=fPrec), intent(in)    :: cry_ch_anuc
  real(kind=fPrec), intent(in)    :: cry_ch_zatom
  real(kind=fPrec), intent(in)    :: cry_ch_emr
  real(kind=fPrec), intent(in)    :: cry_ch_rho
  real(kind=fPrec), intent(in)    :: cry_ch_hcut
  real(kind=fPrec), intent(in)    :: cry_ch_bnref
  real(kind=fPrec), intent(in)    :: cry_ch_csref0
  real(kind=fPrec), intent(in)    :: cry_ch_csref1
  real(kind=fPrec), intent(in)    :: cry_ch_csref5
  real(kind=fPrec), intent(in)    :: cry_ch_eum
  real(kind=fPrec), intent(in)    :: cry_ch_collnt

  integer i,np,length_cry,ichoix
  real(kind=fPrec) t,xran_cry(1),bn,cs(0:5),cprob(0:5),freep,zlm,xp_in,yp_in,xminU,xm2,xln15s,x_min,&
    x_max,x_i,Umin,Ueff,tz,tx,tlow,thigh,teta,rho_min,rho_max,pv,pptot,ppsd,ppel,PC_in,nuc_cl_l,    &
    N_am,Et,ecmsq,Ec,csref_inel_rsc,csref_tot_rsc,bsd,bpp,aran,avrrho

  xp_in = xp
  yp_in = yp
  pc_in = pc

  ! New treatment of scattering routine based on standard sixtrack routine

  ! Useful calculations for cross-section and event topology calculation
  ecmsq  = ((two*pmap)*c1m3)*pc
  xln15s = log_mb(0.15_fPrec*ecmsq)

  ! New models, see Claudia's thesis
  pptot = (0.041084_fPrec - 0.0023302_fPrec*log_mb(ecmsq)) + 0.00031514_fPrec*log_mb(ecmsq)**2
  ppel  = (11.7_fPrec - 1.59_fPrec*log_mb(ecmsq) + 0.134_fPrec*log_mb(ecmsq)**2)/c1e3
  ppsd  = (4.3_fPrec + 0.3_fPrec*log_mb(ecmsq))/c1e3
  bpp   = 7.156_fPrec + 1.439_fPrec*log_mb(sqrt(ecmsq))

  ! Distribution for Ruth. scatt.
  tlow      = tlcut_cry
  zatom_curr_cry = cry_ch_zatom
  emr_curr_cry = cry_ch_emr
  thigh     = cry_ch_hcut
  call funlxp(cry_ruth,cgen_cry(1),tlow,thigh)

  ! Rescale the total and inelastic cross-section accordigly to the average density seen
  x_i = x
  np  = int(x_i/dp)    ! Calculate in which crystalline plane the particle enters
  x_i = x_i - Np*dP    ! Rescale the incoming x at the left crystalline plane
  x_i = x_i - (dP/two) ! Rescale the incoming x in the middle of crystalline planes

  pv   = pc**2/sqrt(pc**2 + (pmap*c1m3)**2)*c1e9          ! Calculate pv=P/E
  Ueff = cry_ch_eUm*((two*x_i)/dp)*((two*x_i)/dp) + pv*x_i/r ! Calculate effective potential
  Et   = (pv*xp**2)/two + Ueff                            ! Calculate transverse energy
  Ec   = (cry_ch_eUm*(one-rc/r))*(one-rc/r)                  ! Calculate critical energy in bent crystals

  ! To avoid negative Et
  xminU = ((-dp**2*pc)*c1e9)/(eight*cry_ch_eUm*r)
  Umin  = abs((cry_ch_eUm*((two*xminU)/dp))*((two*xminU)/dP) + pv*xminU/R)
  Et    = Et + Umin
  Ec    = Ec + Umin

  ! Calculate min e max of the trajectory between crystalline planes
  x_min = (-(dP/two)*Rc)/R - (dP/two)*sqrt(Et/Ec)
  x_Max = (-(dP/two)*Rc)/R + (dP/two)*sqrt(Et/Ec)

  ! Change ref. frame and go back with 0 on the crystalline plane on the left
  x_min = x_min - dp/two
  x_max = x_max - dp/two

  ! Calculate the "normal density" in m^-3
  N_am  = ((cry_ch_rho*6.022e23_fPrec)*c1e6)/cry_ch_anuc

  ! Calculate atomic density at min and max of the trajectory oscillation
  rho_max = ((N_am*dp)/two)*(erf(x_max/sqrt(two*u1**2)) - erf((dP-x_Max)/sqrt(two*u1**2)))
  rho_min = ((N_am*dP)/two)*(erf(x_min/sqrt(two*u1**2)) - erf((dP-x_min)/sqrt(two*u1**2)))

  ! "zero-approximation" of average nuclear density seen along the trajectory
  avrrho  = (rho_max - rho_min)/(x_max - x_min)
  avrrho  = (two*avrrho)/N_am

  csref_tot_rsc  = cry_ch_csref0*avrrho ! Rescaled total ref cs
  csref_inel_rsc = cry_ch_csref1*avrrho ! Rescaled inelastic ref cs

  ! Cross-section calculation
  freep = freeco_cry * cry_ch_anuc**(one/three)

  ! compute pp and pn el+single diff contributions to cross-section (both added : quasi-elastic or qel later)
  cs(3) = freep*ppel
  cs(4) = freep*ppsd

  ! correct TOT-CSec for energy dependence of qel
  ! TOT CS is here without a Coulomb contribution
  cs(0) = csref_tot_rsc + freep*(pptot - pptref_cry)

  ! Also correct inel-CS
  if(csref_tot_rsc == zero) then
    cs(1) = zero
  else
    cs(1) = (csref_inel_rsc*cs(0))/csref_tot_rsc
  end if

  ! Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
  cs(2) = ((cs(0) - cs(1)) - cs(3)) - cs(4)
  cs(5) = cry_ch_csref5

  ! Now add Coulomb
  cs(0) = cs(0) + cs(5)

  ! Calculate cumulative probability
  cprob(:) = zero
  cprob(5) = one
  if(cs(0) == zero) then
    do i=1,4
      cprob(i) = cprob(i-1)
    end do
  else
    do i=1,4
      cprob(i) = cprob(i-1) + cs(i)/cs(0)
    end do
  end if

  ! Multiple Coulomb Scattering
  xp = xp*c1e3
  yp = yp*c1e3

  ! Turn on/off nuclear interactions
  if(nam == 0) return

  ! Can nuclear interaction happen?
  ! Rescaled nuclear collision length
  if(avrrho == zero) then
    nuc_cl_l = c1e6
  else
    nuc_cl_l = cry_ch_collnt/avrrho
  end if
  zlm = -nuc_cl_l*log_mb(coll_rand())

  ! write(889,*) x_i,pv,Ueff,Et,Ec,N_am,avrrho,csref_tot_rsc,csref_inel_rsc,nuc_cl_l

  if(zlm < dz) then
    ! Choose nuclear interaction
    aran = coll_rand()
    i=1
10  if(aran > cprob(i)) then
      i=i+1
      goto 10
    end if
    ichoix = i

    ! Do the interaction
    t = 0 ! default value to cover ichoix=1
    select case(ichoix)
    case(1) ! deep inelastic, impinging p disappeared
      iProc = proc_ch_absorbed

    case(2) ! p-n elastic
      iProc = proc_ch_pne
      bn    = (cry_ch_bnref*cs(0))/csref_tot_rsc
      t     = -log_mb(coll_rand())/bn

    case(3) ! p-p elastic
      iProc = proc_ch_ppe
      t     = -log_mb(coll_rand())/bpp

    case(4) ! Single diffractive
      iProc = proc_ch_diff
      xm2   = exp_mb(coll_rand()*xln15s)
      pc    = pc*(one - xm2/ecmsq)
      if(xm2 < two) then
        bsd = two*bpp
      else if(xm2 >= two .and. xm2 <= five) then
        bsd = ((106.0_fPrec - 17.0_fPrec*xm2)*bpp)/36.0_fPrec
      else if(xm2 > five) then
        bsd = (seven*bpp)/12.0_fPrec
      end if
      t = -log_mb(coll_rand())/bsd

    case(5)
      iProc      = proc_ch_ruth
      length_cry = 1
      call funlux(cgen_cry(1),xran_cry,length_cry)
      t = xran_cry(1)

    end select

    ! Calculate the related kick -----------
    if(ichoix == 4) then
      teta = sqrt(t)/pc_in ! DIFF has changed PC!!!
    else
      teta = sqrt(t)/pc
    end if

    tx = (teta*ran_gauss(zero))*c1e3
    tz = (teta*ran_gauss(zero))*c1e3

    ! Change p angle
    xp = xp + tx
    yp = yp + tz

  end if

  xp = xp/c1e3
  yp = yp/c1e3

end subroutine cry_moveCH

! ================================================================================================ !
! Definition of rutherford scattering formula
! ================================================================================================ !
function cry_ruth(t_cry)

  use floatPrecision
  use coll_materials
  use mathlib_bouncer

  real(kind=fPrec) cry_ruth,t_cry
  real(kind=fPrec), parameter :: cnorm  = 2.607e-5_fPrec
  real(kind=fPrec), parameter :: cnform = 0.8561e3_fPrec

  cry_ruth = (cnorm*exp_mb((-t_cry*cnform)*emr_curr_cry**2))*(zatom_curr_cry/t_cry)**2

end function cry_ruth

end module coll_crystal

! ============================================================================ !
!  Collimation K2 Physics Module
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! ============================================================================ !
module coll_k2

  use floatPrecision
  use numerical_constants

  implicit none

  !integer,          private, save :: mat   ! Current material
  !integer,          private, save :: mcurr ! Current material, used for Rutherford scattering integration
  real(kind=fPrec), private, save :: zatom_curr
  real(kind=fPrec), private, save :: emr_curr
  real(kind=fPrec), private, save :: zlm
  real(kind=fPrec), private, save :: zlm1
  real(kind=fPrec), private, save :: p0
  real(kind=fPrec), private, save :: length
  real(kind=fPrec), private, save :: xln15s
  real(kind=fPrec), private, save :: pptot
  real(kind=fPrec), private, save :: ppsd
  real(kind=fPrec), private, save :: ppel
  real(kind=fPrec), private, save :: ecmsq
  real(kind=fPrec), private, save :: bpp
  real(kind=fPrec), private, save :: xpsd
  real(kind=fPrec), private, save :: zpsd
  real(kind=fPrec), private, save :: psd

  ! RB DM 2014 added variables for FLUKA output
  real(kind=fPrec), private, save :: xInt,xpInt,yInt,ypInt,sInt
  real(kind=fPrec), private, save :: x,xp,z,zp,dpop

contains

!>
!! "Merlin" scattering collimation configuration
!! This routine pre-calcuates some varibles for
!! the nuclear properties
!<
!subroutine k2coll_merlinInit
!
!  use coll_materials
!
!  integer i
!
!  ! Compute the electron densnity and plasma energy for each material
!  do i=1, nmat
!    edens(i) = k2coll_calcElectronDensity(zatom(i),rho(i),anuc(i))
!    pleng(i) = k2coll_calcPlasmaEnergy(edens(i))
!  end do
!
!end subroutine k2coll_merlinInit

!>
!! K2 scattering collimation configuration
!<
subroutine k2coll_init
!nothing currently
end subroutine k2coll_init

! ================================================================================================ !
!  Collimation K2 Routine
! ~~~~~~~~~~~~~~~~~~~~~~~~
!  G. ROBERT-DEMOLAIZE, November 1st, 2004
!  Based on routines by JBJ. Changed by RA 2001
! ================================================================================================ !
subroutine k2coll_collimate(run_exenergy, run_anuc, run_zatom, run_emr, run_rho, &
                run_hcut, run_bnref, run_csref0, run_csref1, &
                run_csref5, run_radl, run_dlri, run_dlyi, run_eum, run_ai, &
                run_collnt, is_crystal, c_length, c_rotation, c_aperture, c_offset, c_tilt,  &
                x_in, xp_in, y_in, yp_in, p_in, s_in, enom, lhit, part_abs_local, &
                impact, indiv, lint, onesided, nhit_stage, j_slices, nabs_type, linside)

  use, intrinsic :: iso_fortran_env, only : int16
  use parpro
  use crcoall
  !use coll_db
  use coll_common
  use coll_crystal, only : cry_doCrystal
  use coll_materials
  use mod_common, only : iexact, napx, unit208
  use mod_common_main, only : partID, naa
  use mathlib_bouncer
  use mod_ranlux

  !integer,          intent(in)    :: matid        ! Material ID
  real(kind=fPrec), intent(in)    :: run_exenergy
  real(kind=fPrec), intent(in)    :: run_anuc
  real(kind=fPrec), intent(in)    :: run_zatom
  real(kind=fPrec), intent(in)    :: run_emr
  real(kind=fPrec), intent(in)    :: run_rho
  real(kind=fPrec), intent(in)    :: run_hcut
  real(kind=fPrec), intent(in)    :: run_bnref
  real(kind=fPrec), intent(in)    :: run_csref0
  real(kind=fPrec), intent(in)    :: run_csref1
  real(kind=fPrec), intent(in)    :: run_csref5
  real(kind=fPrec), intent(in)    :: run_radl
  real(kind=fPrec), intent(in)    :: run_dlri
  real(kind=fPrec), intent(in)    :: run_dlyi
  real(kind=fPrec), intent(in)    :: run_eum
  real(kind=fPrec), intent(in)    :: run_ai
  real(kind=fPrec), intent(in)    :: run_collnt
  logical,          intent(in)    :: is_crystal

  real(kind=fPrec), intent(in)    :: c_length     ! Collimator length in m
  real(kind=fPrec), intent(in)    :: c_rotation   ! Collimator rotation angle vs vertical in radians
  real(kind=fPrec), intent(in)    :: c_aperture   ! Collimator aperture in m
  real(kind=fPrec), intent(in)    :: c_offset     ! Collimator offset in m
  real(kind=fPrec), intent(inout) :: c_tilt(2)    ! Collimator tilt in radians

  real(kind=fPrec), intent(inout) :: x_in(npart)  ! Particle coordinate
  real(kind=fPrec), intent(inout) :: xp_in(npart) ! Particle coordinate
  real(kind=fPrec), intent(inout) :: y_in(npart)  ! Particle coordinate
  real(kind=fPrec), intent(inout) :: yp_in(npart) ! Particle coordinate
  real(kind=fPrec), intent(inout) :: p_in(npart)  ! Particle coordinate
  real(kind=fPrec), intent(inout) :: s_in(npart)  ! Particle coordinate

  real(kind=fPrec), intent(in)    :: enom         ! Reference momentum in GeV
  logical,          intent(in)    :: onesided

  integer,          intent(inout) :: lhit(npart)
  integer,          intent(inout) :: part_abs_local(npart)
  integer,          intent(inout) :: nabs_type(npart)
  integer,          intent(inout) :: nhit_stage(npart)
  real(kind=fPrec), intent(inout) :: indiv(npart)
  real(kind=fPrec), intent(inout) :: lint(npart)
  real(kind=fPrec), intent(inout) :: impact(npart)
  logical,          intent(inout) :: linside(napx)

  logical isImp
  integer j,nabs,nhit,j_slices
  real(kind=fPrec) keeps,fracab,drift_length,mirror,tiltangle
  real(kind=fPrec) x00,z00,p,sp,s,s_impact
  real(kind=fPrec) x_flk,xp_flk,y_flk,yp_flk,s_flk,zpj
  real(kind=fPrec) x_Dump,xpDump,y_Dump,ypDump,s_Dump
  real(kind=fPrec) cRot,sRot,cRRot,sRRot
  real(kind=fPrec) xIn,xpIn,yIn,ypIn,xOut,xpOut,yOut,ypOut,sImp,sOut
  real(kind=fPrec) x_in0,xp_in0

  ! ien0,ien1: particle energy entering/leaving the collimator
  ! energy in MeV
  real(kind=fPrec)    :: ien0, ien1
  integer(kind=int16) :: nnuc0,nnuc1

  ! Initilaisation
  !mat = matid
  length = c_length
  p0     = enom

  ! Initialise scattering processes
  call k2coll_scatin(p0, run_anuc, run_zatom, run_emr, run_rho, run_hcut, run_bnref, run_csref0, run_csref1, run_csref5)

  nhit   = 0
  nabs   = 0
  fracab = zero
  mirror = one

  ! Compute rotation factors for collimator rotation
  cRot   = cos_mb(c_rotation)
  sRot   = sin_mb(c_rotation)
  cRRot  = cos_mb(-c_rotation)
  sRRot  = sin_mb(-c_rotation)

  !Set energy and nucleon change variables as with the coupling
  nnuc0 = 0
  ien0  = zero
  nnuc1 = 0
  ien1  = zero

  do j=1,napx

    if(part_abs_local(j) /= 0) then
      ! Don't do scattering process for particles already absorbed
      cycle
    end if

    impact(j) = -one
    lint(j)   = -one
    indiv(j)  = -one

    x      = x_in(j)
    xp     = xp_in(j)
    xp_in0 = xp_in(j)
    z      = y_in(j)
    zp     = yp_in(j)
    p      = p_in(j)
    sp     = zero
    dpop   = (p - p0)/p0
    x_flk  = zero
    y_flk  = zero
    xp_flk = zero
    yp_flk = zero

    ! Transform particle coordinates to get into collimator coordinate  system
    ! First do rotation into collimator frame
    x  =  x_in(j)*cRot + sRot*y_in(j)
    z  =  y_in(j)*cRot - sRot*x_in(j)
    xp = xp_in(j)*cRot + sRot*yp_in(j)
    zp = yp_in(j)*cRot - sRot*xp_in(j)

    ! For one-sided collimators consider only positive X. For negative X jump to the next particle
    if(onesided .and. x < zero) then
      cycle
    end if

! Log input energy + nucleons as per the FLUKA coupling
    nnuc0   = nnuc0 + naa(j)
    ien0    = ien0 + rcp(j) * c1e3


    ! Now mirror at the horizontal axis for negative X offset
    if(x < zero) then
      mirror    = -one
      tiltangle = -one*c_tilt(2)
    else
      mirror    = one
      tiltangle = c_tilt(1)
    end if
    x  = mirror*x
    xp = mirror*xp

    ! Shift with opening and offset
    x = (x - c_aperture/two) - mirror*c_offset

    ! Include collimator tilt
    if(tiltangle > zero) then
      xp = xp - tiltangle
    end if
    if(tiltangle < zero) then
      x  = x + sin_mb(tiltangle) * c_length
      xp = xp - tiltangle
    end if

    ! CRY Only: x_in0 has to be assigned after the change of reference frame
    x_in0 = x

    ! After finishing the coordinate transformation, or the coordinate manipulations in case of pencil beams,
    ! save the initial coordinates of the impacting particles
    xIn  = x
    xpIn = xp
    yIn  = z
    ypIn = zp

    ! particle passing above the jaw are discarded => take new event
    ! entering by the face, shorten the length (zlm) and keep track of
    ! entrance longitudinal coordinate (keeps) for histograms

    ! The definition is that the collimator jaw is at x>=0.

    ! 1) Check whether particle hits the collimator
    isImp = .false.
    s     = zero
    keeps = zero
    zlm   = -one*length

    if(is_crystal) then ! This is a crystal collimator

      call cry_doCrystal(j,x,xp,z,zp,s,p,x_in0,xp_in0,zlm,sImp,isImp,nhit,nabs,lhit,&
                         part_abs_local,impact,indiv,c_length, run_exenergy, run_anuc, &
                         run_zatom, run_emr, run_rho, run_hcut, run_bnref, run_csref0, &
                         run_csref1, run_csref5, run_dlri, run_dlyi, run_eum, run_ai, run_collnt)

      if(nabs /= 0) then
        part_abs_local(j)  = 1
        lint(j)                = zlm
      end if

      sImp  = (s - c_length) + sImp
      sOut  = s
      xOut  = x
      xpOut = xp
      yOut  = z
      ypOut = zp

    else ! "Normal" collimator

      if(x >= zero) then
        ! Particle hits collimator and we assume interaction length ZLM equal
        ! to collimator length (what if it would leave collimator after
        ! small length due to angle???)
        zlm       = length
        impact(j) = x
        indiv(j)  = xp
      else if(xp <= zero) then
        ! Particle does not hit collimator. Interaction length ZLM is zero.
        zlm = zero
      else
        ! Calculate s-coordinate of interaction point
        s = (-one*x)/xp
        if(s <= zero) then
          write(lerr,"(a)") "COLLK2> ERROR S <= zero. This should not happen!"
          !call prror
        end if
        if(s < length) then
          zlm       = length - s
          impact(j) = zero
          indiv(j)  = xp
        else
          zlm = zero
        end if
      end if

      ! First do the drift part
      ! DRIFT PART
      drift_length = length - zlm
      if(drift_length > zero) then
        if(iexact) then
          zpj = sqrt(one-xp**2-zp**2)
          x   = x  + drift_length*(xp/zpj)
          z   = z  + drift_length*(zp/zpj)
          sp  = sp + drift_length
        else
          x  = x  + xp* drift_length
          z  = z  + zp * drift_length
          sp = sp + drift_length
        end if
      end if

      ! Now do the scattering part
      if(zlm > zero) then
        if(.not.linside(j)) then
          ! first time particle hits collimator: entering jaw
          linside(j) = .true.
          if(dowrite_impact) then
            if(tiltangle > zero) then
              x_Dump = (x + c_aperture/two + tiltangle*sp)*mirror + c_offset
            else
              x_Dump = (x + c_aperture/two + tiltangle*(sp - c_length))*mirror + c_offset
            end if
            xpDump = (xp + tiltangle)*mirror
            y_Dump = z
            ypDump = zp
            s_Dump = sp+real(j_slices-1,fPrec)*c_length
          end if
        end if

        s_impact = sp
        nhit = nhit + 1
        call k2coll_jaw(s,nabs,partID(j), run_exenergy, run_anuc, run_zatom, run_rho, run_radl)

        nabs_type(j) = nabs
        lhit(j)  = 1

        isImp = .true.
        sImp  = s_impact+(real(j_slices,fPrec)-one)*c_length
        sOut  = (s+sp)+(real(j_slices,fPrec)-one)*c_length
        xOut  = x
        xpOut = xp
        yOut  = z
        ypOut = zp

        ! Writeout should be done for both inelastic and single diffractive. doing all transformations
        ! in x_flk and making the set to 99.99 mm conditional for nabs=1
        if(dowrite_impact .or. nabs == 1 .or. nabs == 4) then
          ! Transform back to lab system for writeout.
          ! keep x,y,xp,yp unchanged for continued tracking, store lab system variables in x_flk etc

          x_flk  = xInt
          xp_flk = xpInt

          if(tiltangle > zero) then
            x_flk  = x_flk  + tiltangle*(sInt+sp)
            xp_flk = xp_flk + tiltangle
          else if(tiltangle < zero) then
            xp_flk = xp_flk + tiltangle
            x_flk  = x_flk  - sin_mb(tiltangle) * (length-(sInt+sp))
          end if

          x_flk  = (x_flk + c_aperture/two) + mirror*c_offset
          x_flk  = mirror*x_flk
          xp_flk = mirror*xp_flk
          y_flk  = (  yInt*cRRot -  x_flk*sRRot)*c1e3
          yp_flk = ( ypInt*cRRot - xp_flk*sRRot)*c1e3
          x_flk  = ( x_flk*cRRot +   yInt*sRRot)*c1e3
          xp_flk = (xp_flk*cRRot +  ypInt*sRRot)*c1e3
          s_flk  = (sInt+sp)+(real(j_slices,fPrec)-one)*c_length

          ! Finally, the actual coordinate change to 99 mm
          if(nabs == 1) then
            fracab  = fracab + 1
            x       = 99.99e-3_fPrec
            z       = 99.99e-3_fPrec
            lint(j) = zlm
            part_abs_local(j)  = 1
          end if
        end if
      end if ! Collimator jaw interaction

      if(nabs /= 1 .and. zlm > zero) then
        ! Do the rest drift, if particle left collimator early
        drift_length = (length-(s+sp))
        if(drift_length > c1m15) then
          linside(j) = .false.
          if(dowrite_impact) then
            if(tiltangle > zero) then
              x_Dump = (x + c_aperture/two + tiltangle*(s+sp))*mirror + c_offset
            else
              x_Dump = (x + c_aperture/two + tiltangle*(s+sp-c_length))*mirror + c_offset
            end if
            xpDump = (xp+tiltangle)*mirror
            y_Dump = z
            ypDump = zp
            s_Dump = s+sp+real(j_slices-1,fPrec)*c_length

          end if
          if(iexact) then
            zpj = sqrt(one-xp**2-zp**2)
            x   = x  + drift_length*(xp/zpj)
            z   = z  + drift_length*(zp/zpj)
            sp  = sp + drift_length
          else
            x  = x  + xp * drift_length
            z  = z  + zp * drift_length
            sp = sp + drift_length
          end if
        end if
        lint(j) = zlm - drift_length
      end if

    end if ! Collimator isCrystal

    ! Transform back to particle coordinates with opening and offset
    if(x < 99.0e-3_fPrec) then
      ! Include collimator tilt
      if(tiltangle > zero) then
        x  = x  + tiltangle*c_length
        xp = xp + tiltangle
      else if(tiltangle < zero) then
        x  = x  + tiltangle*c_length
        xp = xp + tiltangle
        x  = x  - sin_mb(tiltangle) * c_length
      end if

      ! Transform back to particle coordinates with opening and offset
      z00 = z
      x00 = x + mirror*c_offset
      x   = (x + c_aperture/two) + mirror*c_offset

      ! Now mirror at the horizontal axis for negative X offset
      x  = mirror * x
      xp = mirror * xp

      ! Last do rotation into collimator frame
      x_in(j)  =  x*cRRot +  z*sRRot
      y_in(j)  =  z*cRRot -  x*sRRot
      xp_in(j) = xp*cRRot + zp*sRRot
      yp_in(j) = zp*cRRot - xp*sRRot

! Log output energy + nucleons as per the FLUKA coupling
! Do not log dead particles
      nnuc1       = nnuc1 + naa(j)                          ! outcoming nucleons
      ien1        = ien1  + rcp(j) * c1e3                   ! outcoming energy

      if(is_crystal) then
        p_in(j) = p
        s_in(j) = s_in(j) + s
      else
        p_in(j) = (one + dpop) * p0
        s_in(j) = sp + (real(j_slices,fPrec)-one) * c_length
      end if
    else
      x_in(j) = x
      y_in(j) = z
    end if

  end do ! End of loop over all particles

end subroutine k2coll_collimate

!>
!! k2coll_scatin(plab)
!! Configure the K2 scattering routine cross sections
!<
subroutine k2coll_scatin(plab, sc_anuc, sc_zatom, sc_emr, sc_rho, sc_hcut, sc_bnref, sc_csref0, sc_csref1, sc_csref5)

  use mod_funlux
  use coll_common
  use coll_materials
  use mathlib_bouncer
  use physical_constants
  use mod_units
  use crcoall

  real(kind=fPrec), intent(in) :: plab
  real(kind=fPrec), intent(in) :: sc_anuc
  real(kind=fPrec), intent(in) :: sc_zatom
  real(kind=fPrec), intent(in) :: sc_emr
  real(kind=fPrec), intent(in) :: sc_rho
  real(kind=fPrec), intent(in) :: sc_hcut
  real(kind=fPrec), intent(in) :: sc_bnref
  real(kind=fPrec), intent(in) :: sc_csref0
  real(kind=fPrec), intent(in) :: sc_csref1
  real(kind=fPrec), intent(in) :: sc_csref5

  real(kind=fPrec), parameter :: tlcut = 0.0009982_fPrec
  integer i

  integer csUnit
  character(len=23), parameter :: cs_fileName = "MaterialInformation.txt"
  logical csErr

  ecmsq = (two*(pmap*c1m3)) * plab
  xln15s = log_mb(0.15_fPrec*ecmsq)
  ! Claudia Fit from COMPETE collaboration points "arXiv:hep-ph/0206172v1 19Jun2002"
  pptot = 0.041084_fPrec-0.0023302_fPrec*log_mb(ecmsq)+0.00031514_fPrec*log_mb(ecmsq)**2
  ! Claudia used the fit from TOTEM for ppel (in barn)
  ppel = (11.7_fPrec-1.59_fPrec*log_mb(ecmsq)+0.134_fPrec*log_mb(ecmsq)**2)/c1e3
  ! Claudia updated SD cross that cointains renormalized pomeron flux (in barn)
  ppsd = (4.3_fPrec+0.3_fPrec*log_mb(ecmsq))/c1e3


  ! Claudia new fit for the slope parameter with new data at sqrt(s)=7 TeV from TOTEM
  bpp = 7.156_fPrec + 1.439_fPrec*log_mb(sqrt(ecmsq))

  ! Unmeasured tungsten data, computed with lead data and power laws
  !bnref(4) = bnref(5)*(anuc(4)/anuc(5))**(two/three)
  !emr(4)   = emr(5)  *(anuc(4)/anuc(5))**(one/three)

  ! Compute cross-sections (CS) and probabilities + Interaction length
  ! Last two material treated below statement number 100
    zatom_curr = sc_zatom
    emr_curr = sc_emr
    ! Prepare for Rutherford differential distribution
    call funlxp(k2coll_ruth, cgen(1), tlcut, sc_hcut)

    ! freep: number of nucleons involved in single scattering
    freep = freeco * sc_anuc**(one/three)

    ! compute pp and pn el+single diff contributions to cross-section
    ! (both added : quasi-elastic or qel later)
    csect(3) = freep * ppel
    csect(4) = freep * ppsd

    ! correct TOT-CSec for energy dependence of qel
    ! TOT CS is here without a Coulomb contribution
    csect(0) = sc_csref0 + freep * (pptot - pptref)
    bn       = (sc_bnref * csect(0)) / sc_csref0

    ! also correct inel-CS
    csect(1) = (sc_csref1 * csect(0)) / sc_csref0

    ! Nuclear Elastic is TOT-inel-qel ( see definition in RPP)
    csect(2) = ((csect(0) - csect(1)) - csect(3)) - csect(4)
    csect(5) = sc_csref5

    ! Now add Coulomb
    csect(0) = csect(0) + csect(5)

    ! Interaction length in meter
    xintl = (c1m2*sc_anuc)/(((fnavo * sc_rho)*csect(0))*1e-24_fPrec)

    ! Filling CProb with cumulated normalised Cross-sections
    do i=1,4
      cprob(i) = cprob(i-1) + csect(i)/csect(0)
    end do

  ! Last two materials for 'vaccum' (nmat-1) and 'full black' (nmat)
  !cprob(1,nmat-1) = one
  !cprob(1,nmat)   = one
  !xintl(nmat-1)   = c1e12
  !xintl(nmat)     = zero

end subroutine k2coll_scatin

!>
!! jaw(s,nabs,icoll,iturn,ipart)
!!     RB: adding as input arguments to jaw variables icoll,iturn,ipart
!!         these are only used for the writeout of particle histories
!!
!! Input:   ZLM is interaction length
!!          MAT is choice of material
!!
!! Output:  nabs = 1   Particle is absorped
!!          nabs = 4   Single-diffractive scattering
!!          dpop       Adjusted for momentum loss (dE/dx)
!!          s          Exit longitudinal position
!!
!! Physics:  If monte carlo interaction length greater than input
!!           interaction length, then use input interaction length
!!           Is that justified???
!<
subroutine k2coll_jaw(s, nabs, ipart, j_exenergy, j_anuc, j_zatom, j_rho, j_radl)

  use mod_ranlux
  use coll_common
  use coll_materials
  use mathlib_bouncer

  real(kind=fPrec), intent(inout) :: s
  integer,          intent(inout) :: nabs
  integer,          intent(in)    :: ipart
  real(kind=fPrec), intent(in)    :: j_exenergy
  real(kind=fPrec), intent(in)    :: j_anuc
  real(kind=fPrec), intent(in)    :: j_zatom
  real(kind=fPrec), intent(in)    :: j_rho
  real(kind=fPrec), intent(in)    :: j_radl

  real(kind=fPrec) m_dpodx,p,rlen,t,dxp,dzp,p1,zpBef,xpBef,pBef
  integer inter,nabs_tmp

  ! Note that the input parameter is dpop. Here the momentum p is constructed out of this input.
  p    = p0*(one+dpop)
  nabs = 0
  nabs_tmp = nabs


  ! Initialize the interaction length to input interaction length
  rlen = zlm

  ! Do a step for a point-like interaction.
  ! Get monte-carlo interaction length.
10 continue
  zlm1     = (-one*xintl)*log_mb(coll_rand())
  nabs_tmp = 0  ! type of interaction reset before following scattering process
  xpBef    = xp ! save angles and momentum before scattering
  zpBef    = zp
  pBef     = p

  ! If the monte-carlo interaction length is longer than the
  ! remaining collimator length, then put it to the remaining
  ! length, do multiple coulomb scattering and return.
  ! LAST STEP IN ITERATION LOOP
  if(zlm1 > rlen) then
    zlm1 = rlen
    call k2coll_mcs(s, j_radl)
    s = (zlm-rlen)+s
    call k2coll_calcIonLoss(p,rlen,m_dpodx, j_exenergy, j_anuc, j_zatom, j_rho)  ! DM routine to include tail
    p = p-m_dpodx*s

    dpop = (p-p0)/p0
    return
  end if

  ! Otherwise do multi-coulomb scattering.
  ! REGULAR STEP IN ITERATION LOOP
  call k2coll_mcs(s, j_radl)

  ! Check if particle is outside of collimator (X.LT.0) after
  ! MCS. If yes, calculate output longitudinal position (s),
  ! reduce momentum (output as dpop) and return.
  ! PARTICLE LEFT COLLIMATOR BEFORE ITS END.
  if(x <= zero) then
    s = (zlm-rlen)+s

    call k2coll_calcIonLoss(p,rlen,m_dpodx, j_exenergy, j_anuc, j_zatom, j_rho)
    p = p-m_dpodx*s
    dpop = (p-p0)/p0

    return
  end if

  ! Check whether particle is absorbed. If yes, calculate output
  ! longitudinal position (s), reduce momentum (output as dpop)
  ! and return.
  ! PARTICLE WAS ABSORBED INSIDE COLLIMATOR DURING MCS.

  inter    = k2coll_ichoix()
  nabs     = inter
  nabs_tmp = nabs

  ! RB, DM: save coordinates before interaction for writeout to FLUKA_impacts.dat
  xInt  = x
  xpInt = xp
  yInt  = z
  ypInt = zp
  sInt  = (zlm-rlen)+zlm1

  if(inter == 1) then
    s = (zlm-rlen)+zlm1

    call k2coll_calcIonLoss(p,rlen,m_dpodx, j_exenergy, j_anuc, j_zatom, j_rho)
    p = p-m_dpodx*s

    dpop = (p-p0)/p0

    return
  end if

  ! Now treat the other types of interaction, as determined by ICHOIX:

  ! Nuclear-Elastic:          inter = 2
  ! pp Elastic:               inter = 3
  ! Single-Diffractive:       inter = 4    (changes momentum p)
  ! Coulomb:                  inter = 5

  ! As the single-diffractive interaction changes the momentum, save input momentum in p1.
  p1 = p

  ! Gettran returns some monte carlo number, that, as I believe, gives the rms transverse momentum transfer.
  t = k2coll_gettran(inter,p)

  ! Tetat calculates from the rms transverse momentum transfer in
  ! monte-carlo fashion the angle changes for x and z planes. The
  ! angle change is proportional to SQRT(t) and 1/p, as expected.
  call k2coll_tetat(t,p,dxp,dzp)

  ! Apply angle changes
  xp = xp+dxp
  zp = zp+dzp

  ! Treat single-diffractive scattering.
  if(inter == 4) then

    ! added update for s
    s    = (zlm-rlen)+zlm1
    xpsd = dxp
    zpsd = dzp
    psd  = p1

    ! Add this code to get the momentum transfer also in the calling routine
    dpop = (p-p0)/p0
  end if

  ! Calculate the remaining interaction length and close the iteration loop.
  rlen = rlen-zlm1
  goto 10

end subroutine k2coll_jaw

!>
!! mcs(s)
!!++  Input:   zlm1   Monte-carlo interaction length
!!
!!++  Output:  s      Longitudinal position
!!++           p0     Reference momentum
!!++           dpop   Relative momentum offset
!!
!!     collimator: x>0 and y<zlm1
!<
subroutine k2coll_mcs(s, mc_radl)

  use coll_materials

  real(kind=fPrec), intent(inout) :: s
  real(kind=fPrec), intent(in)    :: mc_radl

  real(kind=fPrec) theta,rlen0,rlen,ae,be!,radl_mat,rad_len

  real(kind=fPrec), parameter :: h   = 0.001_fPrec
  real(kind=fPrec), parameter :: dh  = 0.0001_fPrec
  real(kind=fPrec), parameter :: bn0 = 0.4330127019_fPrec

  !radl_mat = radl(mat)
  theta    = 13.6e-3_fPrec/(p0*(one+dpop))
  !rad_len  = radl(mat)

  x     = (x/theta)/mc_radl
  xp    = xp/theta
  z     = (z/theta)/mc_radl
  zp    = zp/theta
  rlen0 = zlm1/mc_radl
  rlen  = rlen0

10 continue
  ae = bn0*x
  be = bn0*xp

  call k2coll_soln3(ae,be,dh,rlen,s)
  if(s < h) s = h

  call k2coll_scamcs(x,xp,s)
  if(x <= zero) then
    s = (rlen0-rlen)+s
    goto 20
  end if
  if(s+dh >= rlen) then
    s = rlen0
    goto 20
  end if
  rlen = rlen-s
  goto 10

20 continue
  call k2coll_scamcs(z,zp,s)
  s  = s*mc_radl
  x  = (x*theta)*mc_radl
  xp = xp*theta
  z  = (z*theta)*mc_radl
  zp = zp*theta

end subroutine k2coll_mcs

!>
!! k2coll_calcIonLoss(IS,PC,DZ,EnLo)
!! subroutine for the calculazion of the energy loss by ionization
!! Either mean energy loss from Bethe-Bloch, or higher energy loss, according to finite probability from cross section
!! Written by DM for crystals, introduced in main code by RB
!! Updated and improved for numerical stability by VKBO
!<
subroutine k2coll_calcIonLoss(PC, DZ, EnLo, ci_exenergy, ci_anuc, ci_zatom, ci_rho)

  use mod_ranlux
  use coll_materials
  use mathlib_bouncer
  use physical_constants

  !integer,          intent(in)  :: IS   ! IS material ID
  real(kind=fPrec), intent(in)  :: PC   ! PC momentum in GeV
  real(kind=fPrec), intent(in)  :: DZ   ! DZ length traversed in material (meters)
  real(kind=fPrec), intent(out) :: EnLo ! EnLo energy loss in GeV/meter
  real(kind=fPrec),    intent(in)    :: ci_exenergy
  real(kind=fPrec),    intent(in)    :: ci_anuc
  real(kind=fPrec),    intent(in)    :: ci_zatom
  real(kind=fPrec),    intent(in)    :: ci_rho

  real(kind=fPrec) exEn,thl,Tt,cs_tail,prob_tail,enr,mom,betar,gammar,bgr,kine,Tmax,plen
  real(kind=fPrec), parameter :: k = 0.307075_fPrec ! Constant in front of Bethe-Bloch [MeV g^-1 cm^2]

  mom    = PC*c1e3                     ! [GeV/c] -> [MeV/c]
  enr    = (mom*mom + pmap*pmap)**half ! [MeV]
  gammar = enr/pmap
  betar  = mom/enr
  bgr    = betar*gammar
  kine   = ((two*pmae)*bgr)*bgr

  ! Mean excitation energy
  exEn = ci_exenergy*c1e3 ! [MeV]

  ! Tmax is max energy loss from kinematics
  Tmax = kine/(one + (two*gammar)*(pmae/pmap) + (pmae/pmap)**2) ! [MeV]

  ! Plasma energy - see PDG 2010 table 27.1
  plen = (((ci_rho*ci_zatom)/ci_anuc)**half)*28.816e-6_fPrec ! [MeV]

  ! Calculate threshold energy
  ! Above this threshold, the cross section for high energy loss is calculated and then
  ! a random number is generated to determine if tail energy loss should be applied, or only mean from Bethe-Bloch
  ! below threshold, only the standard Bethe-Bloch is used (all particles get average energy loss)

  ! thl is 2*width of Landau distribution (as in fig 27.7 in PDG 2010). See Alfredo's presentation for derivation
  thl = ((((four*(k*ci_zatom))*DZ)*c1e2)*ci_rho)/(ci_anuc*betar**2) ! [MeV]

  ! Bethe-Bloch mean energy loss
  EnLo = ((k*ci_zatom)/(ci_anuc*betar**2)) * ( &
    half*log_mb((kine*Tmax)/(exEn*exEn)) - betar**2 - log_mb(plen/exEn) - log_mb(bgr) + half &
  )
  EnLo = ((EnLo*ci_rho)*c1m1)*DZ ! [GeV]

  ! Threshold Tt is Bethe-Bloch + 2*width of Landau distribution
  Tt = EnLo*c1e3 + thl ! [MeV]

  ! Cross section - see Alfredo's presentation for derivation
  cs_tail = ((k*ci_zatom)/(ci_anuc*betar**2)) * ( &
    half*((one/Tt)-(one/Tmax)) - (log_mb(Tmax/Tt)*betar**2)/(two*Tmax) + (Tmax-Tt)/((four*gammar**2)*pmap**2) &
  )

  ! Probability of being in tail: cross section * density * path length
  prob_tail = ((cs_tail*ci_rho)*DZ)*c1e2

  ! Determine based on random number if tail energy loss occurs.
  if(coll_rand() < prob_tail) then
    EnLo = ((k*ci_zatom)/(ci_anuc*betar**2)) * ( &
      half*log_mb((kine*Tmax)/(exEn*exEn)) - betar**2 - log_mb(plen/exEn) - log_mb(bgr) + &
      half + TMax**2/((eight*gammar**2)*pmap**2) &
    )
    EnLo = (EnLo*ci_rho)*c1m1 ! [GeV/m]
  else
    ! If tail energy loss does not occur, just use the standard Bethe-Bloch
    EnLo = EnLo/DZ  ! [GeV/m]
  end if

end subroutine k2coll_calcIonLoss

!>
!! k2coll_tetat(t,p,tx,tz)
!! Generate sine and cosine of an angle uniform in [0,2pi](see RPP)
!<
subroutine k2coll_tetat(t, p, tx, tz)

  use mod_ranlux

  real(kind=fPrec), intent(in)  :: t
  real(kind=fPrec), intent(in)  :: p
  real(kind=fPrec), intent(out) :: tx
  real(kind=fPrec), intent(out) :: tz

  real(kind=fPrec) va,vb,va2,vb2,r2,teta

  teta = sqrt(t)/p

10 continue
  va  = two*coll_rand() - one
  vb  = coll_rand()
  va2 = va**2
  vb2 = vb**2
  r2  = va2 + vb2
  if(r2 > one) goto 10
  tx  = (teta*((two*va)*vb))/r2
  tz  = (teta*(va2 - vb2))/r2

end subroutine k2coll_tetat

!>
!! k2coll_soln3(a,b,dh,smax,s)
!<
subroutine k2coll_soln3(a, b, dh, smax, s)

  real(kind=fPrec), intent(in)    :: a
  real(kind=fPrec), intent(in)    :: b
  real(kind=fPrec), intent(in)    :: dh
  real(kind=fPrec), intent(in)    :: smax
  real(kind=fPrec), intent(inout) :: s

  real(kind=fPrec) c

  if(b == zero) then
    s = a**0.6666666666666667_fPrec
  ! s = a**(two/three)
    if(s > smax) s = smax
    return
  end if

  if(a == zero) then
    if(b > zero) then
      s = b**2
    else
      s = zero
    end if
    if(s > smax) s=smax
    return
  end if

  if(b > zero) then
    if(smax**3 <= (a + b*smax)**2) then
      s = smax
      return
    else
      s = smax*half
      call k2coll_iterat(a,b,dh,s)
    end if
  else
    c = (-one*a)/b
    if(smax < c) then
      if(smax**3 <= (a + b*smax)**2) then
        s = smax
        return
      else
        s = smax*half
        call k2coll_iterat(a,b,dh,s)
      end if
    else
      s = c*half
      call k2coll_iterat(a,b,dh,s)
    end if
  end if

end subroutine k2coll_soln3

!>
!! k2coll_scamcs(xx,xxp,s)
!<
subroutine k2coll_scamcs(xx, xxp, s)

  use mathlib_bouncer
  use mod_ranlux

  real(kind=fPrec), intent(inout) :: xx
  real(kind=fPrec), intent(inout) :: xxp
  real(kind=fPrec), intent(in)    :: s

  real(kind=fPrec) v1,v2,r2,a,z1,z2,ss,x0,xp0,sss

  x0  = xx
  xp0 = xxp

10 continue
  v1 = two*coll_rand() - one
  v2 = two*coll_rand() - one
  r2 = v1**2 + v2**2
  if(r2 >= one) goto 10

  a   = sqrt((-two*log_mb(r2))/r2)
  z1  = v1*a
  z2  = v2*a
  ss  = sqrt(s)
  sss = one + 0.038_fPrec*log_mb(s)
  xx  = x0  + s*(xp0 + ((half*ss)*sss)*(z2 + z1*0.577350269_fPrec))
  xxp = xp0 + (ss*z2)*sss

end subroutine k2coll_scamcs

subroutine k2coll_iterat(a, b, dh, s)

  real(kind=fPrec), intent(in)    :: a
  real(kind=fPrec), intent(in)    :: b
  real(kind=fPrec), intent(in)    :: dh
  real(kind=fPrec), intent(inout) :: s

  real(kind=fPrec) ds

  ds = s

10 continue
  ds = ds*half

  if(s**3 < (a+b*s)**2) then
    s = s+ds
  else
    s = s-ds
  end if

  if(ds < dh) then
    return
  else
    goto 10
  end if

end subroutine k2coll_iterat

!>
!! k2coll_ruth(t)
!! Calculate the rutherford scattering cross section
!<
real(kind=fPrec) function k2coll_ruth(t)

  use mathlib_bouncer
  use coll_materials

  real(kind=fPrec), intent(in) :: t

  ! DM: changed 2.607d-4 to 2.607d-5 to fix Rutherford bug
  real(kind=fPrec), parameter :: cnorm  = 2.607e-5_fPrec
  real(kind=fPrec), parameter :: cnform = 0.8561e3_fPrec

  k2coll_ruth = (cnorm*exp_mb(((-one*t)*cnform)*emr_curr**2)) * (zatom_curr/t)**2

end function k2coll_ruth

!>
!! k2coll_gettran(inter,xmat,p)
!! This function determines: GETTRAN - rms transverse momentum transfer
!! Note: For single-diffractive scattering the vector p of momentum
!! is modified (energy loss is applied)
!<
real(kind=fPrec) function k2coll_gettran(inter, p)

  use mathlib_bouncer
  use mod_ranlux
  use mod_funlux
  use coll_materials

  integer,          intent(in)    :: inter
  !integer,          intent(in)    :: xmat
  real(kind=fPrec), intent(inout) :: p

  real(kind=fPrec) xm2,bsd,xran(1)

  ! Neither if-statements below have an else, so defaulting function return to zero.
  k2coll_gettran = zero

  select case(inter)
  case(2) ! Nuclear Elastic
    k2coll_gettran = (-one*log_mb(coll_rand()))/bn
  case(3) ! pp Elastic
    k2coll_gettran = (-one*log_mb(coll_rand()))/bpp
  case(4) ! Single Diffractive
    xm2 = exp_mb(coll_rand() * xln15s)
    p   = p * (one - xm2/ecmsq)
    if(xm2 < two) then
      bsd = two * bpp
    else if(xm2 >= two .and. xm2 <= five) then
      bsd = ((106.0_fPrec - 17.0_fPrec*xm2)*bpp)/36.0_fPrec
    else
      bsd = (seven*bpp)/12.0_fPrec
    end if
    k2coll_gettran = (-one*log_mb(coll_rand()))/bsd
  case(5) ! Coulomb
    call funlux(cgen(1), xran, 1)
    k2coll_gettran = xran(1)
  end select

end function k2coll_gettran

!>
!! k2coll_ichoix(ma)
!! Select a scattering type (elastic, sd, inelastic, ...)
!<
integer function k2coll_ichoix()

  use mod_ranlux
  use coll_materials

  !integer, intent(in) :: ma
  integer i
  real(kind=fPrec) aran

  aran = coll_rand()
  i    = 1
10 continue
  if(aran > cprob(i)) then
    i = i+1
    goto 10
  end if

  k2coll_ichoix = i

end function k2coll_ichoix

!>
!! k2coll_calcElectronDensity(AtomicNumber, Density, AtomicMass)
!! Function to calculate the electron density in a material
!! Should give the number per cubic meter
!<
real(kind=fPrec) function k2coll_calcElectronDensity(AtomicNumber, Density, AtomicMass)

  real(kind=fPrec) , intent(in) :: AtomicNumber
  real(kind=fPrec) , intent(in) :: Density
  real(kind=fPrec) , intent(in) :: AtomicMass

  real(kind=fPrec), parameter :: Avogadro = 6.022140857e23_fPrec
  real(kind=fPrec) PartA, PartB

  PartA = (AtomicNumber*Avogadro) * Density
  PartB = AtomicMass * c1m6 ! 1e-6 factor converts to n/m^-3
  k2coll_calcElectronDensity = PartA/PartB

end function k2coll_calcElectronDensity

!>
!! k2coll_calcPlasmaEnergy(ElectronDensity)
!! Function to calculate the plasma energy in a material
!! CalculatePlasmaEnergy = (PlanckConstantBar * sqrt((ElectronDensity *(ElectronCharge**2)) / &
!!& (ElectronMass * FreeSpacePermittivity)))/ElectronCharge*eV;
!<
real(kind=fPrec) function k2coll_calcPlasmaEnergy(ElectronDensity)

  use physical_constants

  real(kind=fPrec), intent(in) :: ElectronDensity

  real(kind=fPrec) sqrtAB,PartA

  ! Values from the 2016 PDG
  real(kind=fPrec), parameter :: PlanckConstantBar = 1.054571800e-34_fPrec
  real(kind=fPrec), parameter :: ElectronCharge = echarge 
  real(kind=fPrec), parameter :: ElectronCharge2 = ElectronCharge*ElectronCharge
  real(kind=fPrec), parameter :: ElectronMass = 9.10938356e-31_fPrec
  real(kind=fPrec), parameter :: SpeedOfLight2 = clight*clight
  real(kind=fPrec), parameter :: FreeSpacePermeability = 16.0e-7_fPrec*atan(one)
  real(kind=fPrec), parameter :: FSPC2 = FreeSpacePermeability*SpeedOfLight2
  real(kind=fPrec), parameter :: FreeSpacePermittivity = one/FSPC2
  real(kind=fPrec), parameter :: PartB = ElectronMass * FreeSpacePermittivity

  PartA  = ElectronDensity * ElectronCharge2
  sqrtAB = sqrt(PartA/PartB)

  k2coll_calcPlasmaEnergy = ((PlanckConstantBar*sqrtAB)/ElectronCharge)*c1m9

end function k2coll_calcPlasmaEnergy


end module coll_k2

! ================================================================================================ !
!  RANLUX
! ~~~~~~~~
!                                 default
!   Luxury Level    0     1     2   *3*    4
!    data ndskip    0    24    73   199   365
! Corresponds to p=24    48    97   223   389
!      time factor  1    2     3     6    10   on slow workstation
!                   1   1.5    2     3     5   on fast mainframe
!
! Reference:
! James, F. ‘RANLUX: A FORTRAN Implementation of the High Quality Pseudorandom Number Generator of
!     Luscher’. Comput.Phys.Commun. 79 (1994): 111–14. https://doi.org/10.1016/0010-4655(94)90233-X.
! ================================================================================================ !
module mod_ranlux

  use floatPrecision
  use numerical_constants

  implicit none

  private

  integer jseed,lp,i,k,inner,izip,izip2,ivec,isk,isd,ilx,iouter

  integer, parameter :: maxlev = 4
  integer, parameter :: lxdflt = 3
  integer, parameter :: igiga = 1000000000
  integer, parameter :: itwo24 = 2**24
  integer, parameter :: jsdflt = 314159265
  integer, parameter :: icons = 2147483563

  integer, save :: ndskip(0:maxlev) = [0, 24, 73, 199, 365]
  integer, save :: isdext(25)
  integer, save :: iseeds(24)
  integer, save :: next(24)

  real(kind=fPrec), parameter :: twop12 = 4096.0
  real(kind=fPrec), save :: seeds(24)
  real(kind=fPrec), save :: twom12
  real(kind=fPrec), save :: twom24
  real(kind=fPrec), save :: carry = zero
  real(kind=fPrec) :: uni

  integer, save :: luxlev = lxdflt
  logical, save :: notyet = .true.
  integer, save :: in24 = 0
  integer, save :: i24 = 24
  integer, save :: j24 = 10
  integer, save :: kount = 0
  integer, save :: mkount = 0
  integer, save :: inseed
  integer, save :: nskip

  public ranlux
  public rluxin
  public rluxut
  public rluxat
  public rluxgo
  public rndm4
  public rndm5
  public coll_rand
  public ran_gauss
  public ran_gauss2

contains

!         Subtract-and-borrow random number generator proposed by
!         Marsaglia and Zaman, implemented by F. James with the name
!         RCARRY in 1991, and later improved by Martin Luescher
!         in 1993 to produce "Luxury Pseudorandom Numbers".
!     Fortran 77 coded by F. James, 1993
!
!   LUXURY LEVELS.
!   ------ ------      The available luxury levels are:
!
!  level 0  (p=24): equivalent to the original RCARRY of Marsaglia
!           and Zaman, very long period, but fails many tests.
!  level 1  (p=48): considerable improvement in quality over level 0,
!           now passes the gap test, but still fails spectral test.
!  level 2  (p=97): passes all known tests, but theoretically still
!           defective.
!  level 3  (p=223): DEFAULT VALUE.  Any theoretically possible
!           correlations have very small chance of being observed.
!  level 4  (p=389): highest possible luxury, all 24 bits chaotic.
!
!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
!!!  Calling sequences for RANLUX:                                  ++
!!!      CALL RANLUX (RVEC, LEN)   returns a vector RVEC of LEN     ++
!!!                   32-bit random floating point numbers between  ++
!!!                   zero (not included) and one (also not incl.). ++
!!!      CALL RLUXGO(LUX,INT,K1,K2) initializes the generator from  ++
!!!               one 32-bit integer INT and sets Luxury Level LUX  ++
!!!               which is integer between zero and MAXLEV, or if   ++
!!!               LUX .GT. 24, it sets p=LUX directly.  K1 and K2   ++
!!!               should be set to zero unless restarting at a break++
!!!               point given by output of RLUXAT (see RLUXAT).     ++
!!!      CALL RLUXAT(LUX,INT,K1,K2) gets the values of four integers++
!!!               which can be used to restart the RANLUX generator ++
!!!               at the current point by calling RLUXGO.  K1 and K2++
!!!               specify how many numbers were generated since the ++
!!!               initialization with LUX and INT.  The restarting  ++
!!!               skips over  K1+K2*E9   numbers, so it can be long.++
!!!   A more efficient but less convenient way of restarting is by: ++
!!!      CALL RLUXIN(ISVEC)    restarts the generator from vector   ++
!!!                   ISVEC of 25 32-bit integers (see RLUXUT)      ++
!!!      CALL RLUXUT(ISVEC)    outputs the current values of the 25 ++
!!!                 32-bit integer seeds, to be used for restarting ++
!!!      ISVEC must be dimensioned 25 in the calling program        ++
!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
subroutine ranlux(rvec,lenv)

  use crcoall

  integer,          intent(in)  :: lenv
  real(kind=fPrec), intent(out) :: rvec(lenv)

  ! NOTYET is .TRUE. if no initialization has been performed yet.
  !             Default Initialization by Multiplicative Congruential
  if(notyet) then
    notyet = .false.
    jseed = jsdflt
    inseed = jseed
    write(lout,"(a,i0)") "RANLUX> Default initialization: ",jseed
    luxlev = lxdflt
    nskip  = ndskip(luxlev)
    lp     = nskip + 24
    in24   = 0
    kount  = 0
    mkount = 0
    twom24 = 1.0
    do i=1,24
      twom24 = twom24 * 0.5
      k = jseed/53668
      jseed = 40014*(jseed-k*53668) -k*12211
      if(jseed < 0) jseed = jseed+icons
      iseeds(i) = mod(jseed,itwo24)
    end do
    twom12 = twom24 * twop12
    do i=1,24
      seeds(i) = real(iseeds(i))*twom24
      next(i) = i-1
    end do
    next(1) = 24
    i24     = 24
    j24     = 10
    carry   = 0.0
    if (seeds(24) == 0.0) carry = twom24
  end if

  ! The Generator proper: "Subtract-with-borrow",
  ! as proposed by Marsaglia and Zaman,
  ! Florida State University, March, 1989

  do ivec=1,lenv
    uni = seeds(j24) - seeds(i24) - carry
    if(uni < 0.0) then
      uni = uni + 1.0
      carry = twom24
    else
      carry = 0.0
    end if
    seeds(i24) = uni
    i24 = next(i24)
    j24 = next(j24)
    rvec(ivec) = uni

    ! small numbers (with less than 12 "significant" bits) are "padded".
    if(uni < twom12) then
      rvec(ivec) = rvec(ivec) + twom24*seeds(j24)
      ! and zero is forbidden in case someone takes a logarithm
      if(rvec(ivec) == 0.0) rvec(ivec) = twom24*twom24
    end if

    ! Skipping to luxury.  As proposed by Martin Luscher.
    in24 = in24 + 1
    if(in24 == 24) then
      in24 = 0
      kount = kount + nskip
      do isk=1,nskip
        uni = seeds(j24) - seeds(i24) - carry
        if(uni < 0.0) then
          uni = uni + 1.0
          carry = twom24
        else
          carry = 0.0
        end if
        seeds(i24) = uni
        i24 = next(i24)
        j24 = next(j24)
      end do
    end if
  end do

  kount = kount + lenv
  if(kount >= igiga) then
    mkount = mkount + 1
    kount = kount - igiga
  end if

end subroutine ranlux

! Entry to input and float integer seeds from previous run
subroutine rluxin(isdext_tmp)

  use crcoall

  integer, intent(in) :: isdext_tmp(25)

  isdext = isdext_tmp
  notyet = .false.
  twom24 = 1.0
  do i=1,24
    next(i) = i-1
    twom24 = twom24 * 0.5
  end do
  next(1) = 24
  twom12 = twom24 * twop12
  write(lout,"(a)")       "RANLUX> Full initialisation of ranlux with 25 integers: "
! write(lout,"(a,25i12)") "RANLUX> ",isdext
  do i=1,24
    seeds(i) = real(isdext(i))*twom24
  end do

  carry = 0.0
  if(isdext(25) < 0) carry = twom24
  isd = iabs(isdext(25))
  i24 = mod(isd,100)
  isd = isd/100
  j24 = mod(isd,100)
  isd = isd/100
  in24 = mod(isd,100)
  isd = isd/100
  luxlev = isd
  if(luxlev <= maxlev) then
    nskip = ndskip(luxlev)
    write(lout,"(a,i0)") "RANLUX> Luxury level set by rluxin to ",luxlev
  else if(luxlev >= 24) then
    nskip = luxlev - 24
    write(lout,"(a,i0)") "RANLUX> P-value set by rluxin to ",luxlev
  else
    nskip = ndskip(maxlev)
    write(lout,"(a,i0)") "RANLUX> Illegal luxury rluxin ",luxlev
    luxlev = maxlev
  end if
  inseed = -1

end subroutine rluxin

! Entry to ouput seeds as integers
subroutine rluxut(isdext_tmp)

  integer, intent(out) :: isdext_tmp(25)

  do i=1,24
    isdext_tmp(i) = int(seeds(i)*twop12*twop12)
  end do
  isdext_tmp(25) = i24 + 100*j24 + 10000*in24 + 1000000*luxlev
  if(carry > 0.0) isdext_tmp(25) = -isdext_tmp(25)

end subroutine rluxut

! Entry to output the "convenient" restart point
subroutine rluxat(lout2,inout,k1,k2)

  integer, intent(out) :: lout2,inout,k1,k2

  lout2 = luxlev
  inout = inseed
  k1    = kount
  k2    = mkount

end subroutine rluxat

! Entry to initialize from one or three integers
subroutine rluxgo(lux,ins,k1,k2)

  use crcoall

  integer, intent(in) :: lux,ins,k1,k2

  if(lux < 0) then
    luxlev = lxdflt
  elseif(lux <= maxlev) then
    luxlev = lux
  elseif(lux < 24 .or. lux > 2000) then
    luxlev = maxlev
    write(lout,"(a,i0)") "RANLUX> Illegal luxury rluxgo ",lux
  else
    luxlev = lux
    do ilx=0,maxlev
      if(lux == ndskip(ilx)+24) luxlev = ilx
    end do
  end if

  if(luxlev <= maxlev) then
    nskip = ndskip(luxlev)
!    write(lout,"(a,i0,a,i0)") "RANLUX> Luxury level set by rluxgo: ",luxlev," P = ",nskip+24
  else
    nskip = luxlev - 24
    write(lout,"(a,i0)") "RANLUX> P-value set by rluxgo to ",luxlev
  end if

  in24 = 0

  if(ins < 0) write(lout,"(a)") "RANLUX> Illegal initialisation by RLUXGO, negative input seed"
  if(ins > 0) then
    jseed = ins
!    write(lout,"(a,3(1x,i0))") "RANLUX> Initialised by rluxgo from seeds ",jseed,k1,k2
  else
    jseed = jsdflt
!    write(lout,"(a)") "RANLUX> Initialised by rluxgo from default seed"
  end if

  inseed = jseed
  notyet = .false.
  twom24 = 1.0
  do i=1,24
    twom24 = twom24 * 0.5
    k = jseed/53668
    jseed = 40014*(jseed-k*53668) - k*12211
    if(jseed < 0) jseed = jseed+icons
    iseeds(i) = mod(jseed,itwo24)
  end do

  twom12 = twom24 * twop12
  do i=1,24
    seeds(i) = real(iseeds(i))*twom24
    next(i) = i-1
  end do

  next(1) = 24
  i24     = 24
  j24     = 10
  carry   = 0.0
  if(seeds(24) == 0.0) carry = twom24

  ! If restarting at a break point, skip K1 + IGIGA*K2
  ! Note that this is the number of numbers delivered to
  ! the user PLUS the number skipped (if luxury .GT. 0).
  kount = k1
  mkount = k2
  if(k1+k2 /= 0) then
    do iouter=1,k2+1
      inner = igiga
      if(iouter == k2+1) inner = k1
      do isk=1,inner
        uni = seeds(j24) - seeds(i24) - carry
        if(uni < 0.) then
          uni = uni + 1.0
          carry = twom24
        else
          carry = 0.0
        end if
        seeds(i24) = uni
        i24 = next(i24)
        j24 = next(j24)
      end do
    end do

    ! Get the right value of IN24 by direct calculation
    in24 = mod(kount, nskip+24)
    if(mkount > 0) then
      izip = mod(igiga, nskip+24)
      izip2 = mkount*izip + in24
      in24 = mod(izip2, nskip+24)
    end if

    ! Now IN24 had better be between zero and 23 inclusive
    if(in24 > 23) then
      write(lerr,"(a)")               "RANLUX> ERROR RESTARTING with RLUXGO:"
      write(lerr,"(a,3(1x,i0),a,i0)") "RANLUX>       The values",ins,k1,k2," cannot occur at luxury level ",luxlev
      in24 = 0
    end if
  end if

end subroutine rluxgo

function rndm4()

  integer len, in
  real(kind=fPrec) rndm4, a

  save in,a

  parameter ( len =  30000 )
  dimension a(len)
  data in/1/

  if(in == 1) then
    call ranlux(a,len)
!    call ranecu(a,len,-1)
    rndm4=a(1)
    in=2
  else
    rndm4=a(in)
    in=in+1
    if(in == len+1)in=1
  endif

end function rndm4

!ccccccccccccccccccccccccccccccccccccccc
!-TW-01/2007
! function rndm5(irnd) , irnd = 1 will reset
! inn counter => enables reproducible set of
! random unmbers
!cccccccccccccccccccccccccccccccccc
!
function rndm5(irnd)

  use mathlib_bouncer

  implicit none

  integer len, inn, irnd
  real(kind=fPrec) rndm5,a
  save

  parameter( len =  30000 )
  dimension a(len)
  data inn/1/
!
! reset inn to 1 enable reproducible random numbers
  if(irnd == 1) inn = 1

  if(inn == 1) then
    call ranlux(a,len)
!     call ranecu(a,len,-1)
    rndm5=a(1)
    inn=2
  else
    rndm5=a(inn)
    inn=inn+1
    if(inn == len+1) inn=1
  end if

end function rndm5

!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! function coll_rand()
! to be used for the collimation code with CR enabled.
! we get a fresh random number every call, so no need to have a 30k buffer here.
! Therefore this is the same as rndm5 with an argument of 1 every time
!!! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function coll_rand()

  use mathlib_bouncer

  implicit none

  integer len
  real(kind=fPrec) coll_rand,a
  save

  parameter( len =  1 )
  dimension a(len)

  call ranlux(a,len)
  coll_rand=a(1)

end function coll_rand


!*********************************************************************
!
! RAN_GAUSS - will generate a normal distribution from a uniform
!   distribution between [0,1].
!   See "Communications of the ACM", V. 15 (1972), p. 873.
!
! cut - real(kind=fPrec) - cut for distribution in units of sigma
!                the cut must be greater than 0.5
!
!*********************************************************************
real(kind=fPrec) function ran_gauss(cut)

  use mathlib_bouncer

  real(kind=fPrec), intent(in) :: cut

  logical :: flag = .true.
  real(kind=fPrec) :: x, u1, u2, r

  save

1 if (flag) then
    r  = rndm4()
    r  = max(r, half**32)
    r  = min(r, one-half**32)
    u1 = sqrt(-two*log_mb( r ))
    u2 = rndm4()
    x  = u1 * cos_mb(twopi*u2)
  else
    x  = u1 * sin_mb(twopi*u2)
  end if

  flag = .not. flag

  ! Cut the distribution if cut > 0.5
  if(cut > half .and. abs(x) > cut) goto 1

  ran_gauss = x

end function ran_gauss

!*********************************************************************
!
! ran_gauss2 - will generate a normal distribution from a uniform
!     distribution between [0,1].
!     See "Communications of the ACM", V. 15 (1972), p. 873.
!
!     cut - real(kind=fPrec) - cut for distribution in units of sigma
!     the cut must be greater than 0.5
!
!     changed rndm4 to rndm5(irnd) and defined flag as true
!
!*********************************************************************
real(kind=fPrec) function ran_gauss2(cut)

  use numerical_constants, only : twopi
  use mathlib_bouncer

  logical flag
  real(kind=fPrec) x, u1, u2, r,cut
  save

  flag = .true. !Does this initialize only once, or is it executed every pass?
                !See ran_gauss(cut)

1 if (flag) then
    r = real(rndm5(0),fPrec)
    r = max(r, half**32)
    r = min(r, one-half**32)
    u1 = sqrt(-two*log_mb( r ))
    u2 = real(rndm5(0),fPrec)
    x = u1 * cos_mb(twopi*u2)
  else
    x = u1 * sin_mb(twopi*u2)
  endif

  flag = .not. flag

  ! cut the distribution if cut > 0.5
  if(cut > half .and. abs(x) > cut) goto 1

  ran_gauss2 = x

end function ran_gauss2

end module mod_ranlux

module mod_funlux

  use floatPrecision
  use numerical_constants, only : zero, two

  implicit none

  real(kind=fPrec), private, save :: tftot

contains

!cccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine funlxp (func,xfcum,x2low,x2high)
!         F. JAMES,   Sept, 1994
!
!         Prepares the user function FUNC for FUNLUX
!         Inspired by and mostly copied from FUNPRE and FUNRAN
!         except that
!    1. FUNLUX uses RANLUX underneath,
!    2. FUNLXP expands the first and last bins to cater for
!              functions with long tails on left and/or right,
!    3. FUNLXP calls FUNPCT to do the actual finding of percentiles.
!    4. both FUNLXP and FUNPCT use RADAPT for Gaussian integration.
!
      use crcoall
      implicit none
      external func
      integer ifunc,ierr
      real(kind=fPrec) x2high,x2low,xfcum,rteps,xhigh,xlow,xrange,uncert,x2,tftot1,x3,tftot2,func
      dimension xfcum(200)
      parameter (rteps=0.0002)
      save ifunc
      data ifunc/0/
      ifunc = ifunc + 1
!         FIND RANGE WHERE FUNCTION IS NON-ZERO.
      call funlz(func,x2low,x2high,xlow,xhigh)
      xrange = xhigh-xlow
      if(xrange .le. 0.)  then
        write(lout,'(A,2G15.5)') ' FUNLXP finds function range .LE.0',xlow,xhigh
        go to 900
      endif
      call radapt(func,xlow,xhigh,1,rteps,zero,tftot ,uncert)
!      WRITE(6,1003) IFUNC,XLOW,XHIGH,TFTOT
! 1003 format(' FUNLXP: integral of USER FUNCTION', i3,' from ',e12.5,' to ',e12.5,' is ',e14.6)
!
!      WRITE (6,'(A,A)') ' FUNLXP preparing ',
!     + 'first the whole range, then left tail, then right tail.'
      call funpct(func,ifunc,xlow,xhigh,xfcum,1,99,tftot,ierr)
      if (ierr .gt. 0)  go to 900
      x2 = xfcum(3)
      call radapt(func,xlow,x2,1,rteps,zero,tftot1 ,uncert)
      call funpct(func,ifunc,xlow,x2 ,xfcum,101,49,tftot1,ierr)
      if (ierr .gt. 0)  go to 900
      x3 = xfcum(98)
      call radapt(func,x3,xhigh,1,rteps,zero,tftot2 ,uncert)
      call funpct(func,ifunc,x3,xhigh,xfcum,151,49,tftot2,ierr)
      if (ierr .gt. 0)  go to 900
!      WRITE(6,1001) IFUNC,XLOW,XHIGH
! 1001 format(' FUNLXP has prepared USER FUNCTION', i3, ' between',g12.3,' and',g12.3,' for FUNLUX')

      return
  900 continue
      write(lout,*) ' Fatal error in FUNLXP. FUNLUX will not work.'
end subroutine funlxp

subroutine funpct(func,ifunc,xlow,xhigh,xfcum,nlo,nbins,tftot,ierr)
!        Array XFCUM is filled from NLO to NLO+NBINS, which makes
!        the number of values NBINS+1, or the number of bins NBINS
      use crcoall
      implicit none
      external func
      integer ierr,nbins,nlo,ifunc,nz,ibin,maxz,iz,nitmax,ihome
      real(kind=fPrec) tftot,xhigh,xlow,func,xfcum,rteps,tpctil,tz,tzmax,x,f,tcum,  &
     &x1,f1,dxmax,fmin,fminz,xincr,tincr,xbest,dtbest,tpart,x2,precis,  &
     &refx,uncert,tpart2,dtpar2,dtabs,aberr
      dimension xfcum(*)
      parameter (rteps=0.005, nz=10, maxz=20, nitmax=6,precis=1e-6)
!      DOUBLE PRECISION TPCTIL, TZ, TCUM, XINCR, DTABS,
!     &  TINCR, TZMAX, XBEST, DTBEST, DTPAR2
!
      ierr = 0
      if (tftot .le. 0.) go to 900
      tpctil = tftot/real(nbins)
      tz = tpctil/real(nz)
      tzmax = tz * 2.
      xfcum(nlo) = xlow
      xfcum(nlo+nbins) = xhigh
      x = xlow
      f = func(x)
      if (f .lt. 0.) go to 900
!         Loop over percentile bins
      do 600 ibin = nlo, nlo+nbins-2
      tcum = 0.
      x1 = x
      f1 = f
      dxmax = (xhigh -x) / nz
      fmin = tz/dxmax
      fminz = fmin
!         Loop over trapezoids within a supposed percentil
      do 500 iz= 1, maxz
      xincr = tz/max(f1,fmin,fminz)
  350 x = x1 + xincr
      f = func(x)
      if (f .lt. 0.) go to 900
      tincr = ((x-x1) * 0.5) * (f+f1)
      if (tincr .lt. tzmax) go to 370
      xincr = xincr * 0.5
      go to 350
  370 continue
      tcum = tcum + tincr
      if (tcum .ge. tpctil*0.99) go to 520
      fminz = (tz*f)/ (tpctil-tcum)
      f1 = f
      x1 = x
  500 continue
      write(lout,*) ' FUNLUX:  WARNING. FUNPCT fails trapezoid.'
!         END OF TRAPEZOID LOOP
!         Adjust interval using Gaussian integration with
!             Newton corrections since F is the derivative
  520 continue
      x1 = xfcum(ibin)
      xbest = x
      dtbest = tpctil
      tpart = tpctil
!         Allow for maximum NITMAX more iterations on RADAPT
      do 550 ihome= 1, nitmax
  535 xincr = (tpctil-tpart) / max(f,fmin)
      x = xbest + xincr
      x2 = x
        if (ihome .gt. 1 .and. x2 .eq. xbest) then
        write(lout,'(A,G12.3)') ' FUNLUX: WARNING from FUNPCT: insufficient precision at X=',x
        go to 580
        endif
      refx = abs(x)+precis
      call radapt(func,x1,x2,1,rteps,zero,tpart2,uncert)
      dtpar2 = tpart2-tpctil
      dtabs = abs(dtpar2)
      if(abs(xincr)/refx .lt. precis) goto 545
      if(dtabs .lt. dtbest) goto 545
      xincr = xincr * 0.5
      goto 535
  545 dtbest = dtabs
      xbest = x
      tpart = tpart2
      f = func(x)
      if(f .lt. 0.) goto 900
      if(dtabs .lt. rteps*tpctil) goto 580
  550 continue
      write(lout,'(A,I4)') ' FUNLUX: WARNING from FUNPCT: cannot converge, bin',ibin

  580 continue
      xincr = (tpctil-tpart) / max(f,fmin)
      x = xbest + xincr
      xfcum(ibin+1) = x
      f = func(x)
      if(f .lt. 0.) goto 900
  600 continue
!         END OF LOOP OVER BINS
      x1 = xfcum((nlo+nbins)-1)
      x2 = xhigh
      call radapt(func,x1,x2,1,rteps,zero,tpart ,uncert)
      aberr = abs(tpart-tpctil)/tftot
!      WRITE(6,1001) IFUNC,XLOW,XHIGH
      if(aberr .gt. rteps)  write(lout,1002) aberr
      return
  900 write(lout,1000) x,f
      ierr = 1
      return
 1000 format(/' FUNLUX fatal error in FUNPCT: function negative:'/      &
&,' at X=',e15.6,', F=',e15.6/)
! 1001 FORMAT(' FUNPCT has prepared USER FUNCTION',I3,
!     + ' between',G12.3,' and',G12.3,' for FUNLUX.')
 1002 format(' WARNING: Relative error in cumulative distribution may be as big as',f10.7)

end subroutine funpct

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine funlux(array,xran,len)
!         Generation of LEN random numbers in any given distribution,
!         by 4-point interpolation in the inverse cumulative distr.
!         which was previously generated by FUNLXP
  use mod_ranlux
  implicit none
      integer len,ibuf,j,j1
      real(kind=fPrec) array,xran,gap,gapinv,tleft,bright,gaps,gapins,x,p,a,b
      dimension array(200)
      dimension xran(len)
!  Bin width for main sequence, and its inverse
      parameter (gap= 1./99.,  gapinv=99.)
!  Top of left tail, bottom of right tail (each tail replaces 2 bins)
      parameter (tleft= 2./99.,bright=97./99.)
!  Bin width for minor sequences (tails), and its inverse
      parameter (gaps=tleft/49.,  gapins=1./gaps)
!
!   The array ARRAY is assumed to have the following structure:
!        ARRAY(1-100) contains the 99 bins of the inverse cumulative
!                     distribution of the entire function.
!        ARRAY(101-150) contains the 49-bin blowup of main bins
!                       1 and 2 (left tail of distribution)
!        ARRAY(151-200) contains the 49-bin blowup of main bins
!                       98 and 99 (right tail of distribution)
!
      x = zero ! -Wmaybe-uninitialized
      call ranlux(xran,len)
!      call ranecu(xran,len,-1)

      do 500 ibuf= 1, len
      x = xran(ibuf)
      j = int(  x    *gapinv) + 1
      if (j .lt. 3)  then
         j1 = int( x *gapins)
             j = j1 + 101
             j = max(j,102)
             j = min(j,148)
         p = (   x -gaps*real(j1-1)) * gapins
         a = (p+1.0) * array(j+2) - (p-2.0)*array(j-1)
         b = (p-1.0) * array(j) - p * array(j+1)
      xran(ibuf) = ((a*p)*(p-1.0))*0.16666667 + ((b*(p+1.))*(p-2.))*0.5
      else if (j .gt. 97)  then
         j1 = int((x-bright)*gapins)
             j = j1 + 151
             j = max(j,152)
             j = min(j,198)
         p = ((x -bright) -gaps*(j1-1)) * gapins
         a = (p+1.0) * array(j+2) - (p-2.0)*array(j-1)
         b = (p-1.0) * array(j) - p * array(j+1)
      xran(ibuf) = ((a*p)*(p-1.0))*0.16666667 + ((b*(p+1.))*(p-2.))*0.5
      else
!      J = MAX(J,2)
!      J = MIN(J,98)
         p = (   x -gap*real(j-1)) * gapinv
         a = (p+1.) * array(j+2) - (p-2.)*array(j-1)
         b = (p-1.) * array(j) - p * array(j+1)
      xran(ibuf) = ((a*p)*(p-1.))*0.16666667 + ((b*(p+1.))*(p-2.))*0.5
      endif
  500 continue
      tftot = x
      return
end subroutine funlux

subroutine funlz(func,x2low,x2high,xlow,xhigh)
! FIND RANGE WHERE FUNC IS NON-ZERO.
! WRITTEN 1980, F. JAMES
! MODIFIED, NOV. 1985, TO FIX BUG AND GENERALIZE
! TO FIND SIMPLY-CONNECTED NON-ZERO REGION (XLOW,XHIGH)
! ANYWHERE WITHIN THE GIVEN REGION (X2LOW,H2HIGH).
!    WHERE 'ANYWHERE' MEANS EITHER AT THE LOWER OR UPPER
!    EDGE OF THE GIVEN REGION, OR, IF IN THE MIDDLE,
!    COVERING AT LEAST 1% OF THE GIVEN REGION.
! OTHERWISE IT IS NOT GUARANTEED TO FIND THE NON-ZERO REGION.
! IF FUNCTION EVERYWHERE ZERO, FUNLZ SETS XLOW=XHIGH=0.
      use crcoall
      implicit none
      external func
      integer logn,nslice,i,k
      real(kind=fPrec) xhigh,xlow,x2high,x2low,func,xmid,xh,xl,xnew
      xlow = x2low
      xhigh = x2high
!         FIND OUT IF FUNCTION IS ZERO AT ONE END OR BOTH
      xmid = xlow
      if (func(xlow) .gt. 0.) go to 120
      xmid = xhigh
      if (func(xhigh) .gt. 0.)  go to 50
!         FUNCTION IS ZERO AT BOTH ENDS,
!         LOOK FOR PLACE WHERE IT IS NON-ZERO.
      do 30 logn= 1, 7
      nslice = 2**logn
      do 20 i= 1, nslice, 2
      xmid = xlow + (real(i) * (xhigh-xlow)) / real(nslice)
      if (func(xmid) .gt. 0.)  go to 50
   20 continue
   30 continue
!         FALLING THROUGH LOOP MEANS CANNOT FIND NON-ZERO VALUE
      write(lout,554)
      write(lout,555) xlow, xhigh
      xlow = 0.
      xhigh = 0.
      go to 220
!
   50 continue
!         DELETE 'LEADING' ZERO RANGE
      xh = xmid
      xl = xlow
      do 70 k= 1, 20
      xnew = 0.5*(xh+xl)
      if (func(xnew) .eq. 0.) go to 68
      xh = xnew
      go to 70
   68 xl = xnew
   70 continue
      xlow = xl
      write(lout,555) x2low,xlow
  120 continue
      if (func(xhigh) .gt. 0.) go to 220
!         DELETE 'TRAILING' RANGE OF ZEROES
      xl = xmid
      xh = xhigh
      do 170 k= 1, 20
      xnew = 0.5*(xh+xl)
      if (func(xnew) .eq. 0.) go to 168
      xl = xnew
      go to 170
  168 xh = xnew
  170 continue
      xhigh = xh
      write(lout,555) xhigh, x2high
!
  220 continue
      return
  554 format('0CANNOT FIND NON-ZERO FUNCTION VALUE')
  555 format(' FUNCTION IS ZERO FROM X=',e12.5,' TO ',e12.5)
end subroutine funlz

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine radapt(f,a,b,nseg,reltol,abstol,res,err)

! RES = Estimated Integral of F from A to B,
! ERR = Estimated absolute error on RES.
! NSEG  specifies how the adaptation is to be done:
!    =0   means use previous binning,
!    =1   means fully automatic, adapt until tolerance attained.
!    =n>1 means first split interval into n equal segments,
!         then adapt as necessary to attain tolerance.
! The specified tolerances are:
!        relative: RELTOL ;  absolute: ABSTOL.
!    It stop s when one OR the other is satisfied, or number of
!    segments exceeds NDIM.  Either TOLA or TOLR (but not both!)
!    can be set to zero, in which case only the other is used.

      implicit none

      external f
      integer nseg,ndim,nter,nsegd,i,iter,ibig
      real(kind=fPrec) err,res,abstol,reltol,b,a,xlo,xhi,tval,ters,te,root,xhib,bin,xlob,bige,hf,xnew,r1,f
      real(kind=fPrec) tvals,terss

      parameter (ndim=100)
      parameter (r1 = 1., hf = r1/2.)

      dimension xlo(ndim),xhi(ndim),tval(ndim),ters(ndim)
      save xlo,xhi,tval,ters,nter
      data nter /0/

      if(nseg .le. 0)  then
       if(nter .eq. 0) then
        nsegd=1
        go to 2
       endif
       tvals=zero
       terss=zero
       do 1 i = 1,nter
       call rgs56p(f,xlo(i),xhi(i),tval(i),te)
       ters(i)=te**2
       tvals=tvals+tval(i)
       terss=terss+ters(i)
    1  continue
       root= sqrt(two*terss)
       go to 9
      endif
      nsegd=min(nseg,ndim)
    2 xhib=a
      bin=(b-a)/real(nsegd,fPrec)
      do 3 i = 1,nsegd
      xlo(i)=xhib
      xlob=xlo(i)
      xhi(i)=xhib+bin
      if(i .eq. nsegd) xhi(i)=b
      xhib=xhi(i)
      call rgs56p(f,xlob,xhib,tval(i),te)
      ters(i)=te**2
    3 continue
      nter=nsegd
      do 4 iter = 1,ndim
      tvals=tval(1)
      terss=ters(1)
      do 5 i = 2,nter
      tvals=tvals+tval(i)
      terss=terss+ters(i)
    5 continue
      root=sqrt(two*terss)

      if(root .le. abstol .or. root .le. reltol*abs(tvals)) then
        goto 9
      end if

      if(nter .eq. ndim) go to 9
      bige=ters(1)
      ibig=1
      do 6 i = 2,nter
      if(ters(i) .gt. bige) then
       bige=ters(i)
       ibig=i
      endif
    6 continue
      nter=nter+1
      xhi(nter)=xhi(ibig)
      xnew=hf*(xlo(ibig)+xhi(ibig))
      xhi(ibig)=xnew
      xlo(nter)=xnew
      call rgs56p(f,xlo(ibig),xhi(ibig),tval(ibig),te)
      ters(ibig)=te**2
      call rgs56p(f,xlo(nter),xhi(nter),tval(nter),te)
      ters(nter)=te**2
    4 continue
    9 res=tvals
      err=root
      return
end subroutine radapt

!cccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine rgs56p(f,a,b,res,err)

  implicit none

  integer i
  real(kind=fPrec) err,res,b,a,f,w6,x6,w5,x5,rang,r1,hf
  real(kind=fPrec) e5,e6

  parameter (r1 = 1., hf = r1/2.)
  dimension x5(5),w5(5),x6(6),w6(6)

  data (x5(i),w5(i),i=1,5)                                          &
 &/4.6910077030668004e-02, 1.1846344252809454e-01,                  &
 &2.3076534494715846e-01, 2.3931433524968324e-01,                   &
 &5.0000000000000000e-01, 2.8444444444444444e-01,                   &
 &7.6923465505284154e-01, 2.3931433524968324e-01,                   &
 &9.5308992296933200e-01, 1.1846344252809454e-01/

  data (x6(i),w6(i),i=1,6)                                          &
 &/3.3765242898423989e-02, 8.5662246189585178e-02,                  &
 &1.6939530676686775e-01, 1.8038078652406930e-01,                   &
 &3.8069040695840155e-01, 2.3395696728634552e-01,                   &
 &6.1930959304159845e-01, 2.3395696728634552e-01,                   &
 &8.3060469323313225e-01, 1.8038078652406930e-01,                   &
 &9.6623475710157601e-01, 8.5662246189585178e-02/

  rang=b-a
  e5=zero
  e6=zero
  do i = 1,5
    e5=e5+dble(w5(i)*f(a+rang*x5(i)))
    e6=e6+dble(w6(i)*f(a+rang*x6(i)))
  end do

  e6=e6+dble(w6(6)*f(a+rang*x6(6)))
  res=real((dble(hf)*(e6+e5))*dble(rang))
  err=real(abs((e6-e5)*dble(rang)))
  return
end subroutine rgs56p

end module mod_funlux

! =================================================================================================
!  Mathlib Bouncer
!  Last modified: 2018-10-23
! =================================================================================================
module mathlib_bouncer

  use floatPrecision

  implicit none
  private

  public :: sin_mb, asin_mb, sinh_mb, cos_mb, acos_mb, cosh_mb
  public :: tan_mb, atan_mb, atan2_mb, exp_mb, log_mb, log10_mb, isnan_mb

  ! For linking with 1


  private :: acos_rn, asin_rn, atan2_rn

  ! Interface definitions for the other functions in 1
  interface

    real(kind=c_double) pure function exp_rn(arg) bind(C,name="exp_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function exp_rn

    real(kind=c_double) pure function log_rn(arg) bind(C,name="log_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function log_rn

    real(kind=c_double) pure function log10_rn(arg) bind(C,name="log10_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function log10_rn

    real(kind=c_double) pure function atan_rn(arg) bind(C,name="atan_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function atan_rn

    real(kind=c_double) pure function tan_rn(arg) bind(C,name="tan_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function tan_rn

    real(kind=c_double) pure function sin_rn(arg) bind(C,name="sin_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function sin_rn

    real(kind=c_double) pure function cos_rn(arg) bind(C,name="cos_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function cos_rn

    real(kind=c_double) pure function sinh_rn(arg) bind(C,name="sinh_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function sinh_rn

    real(kind=c_double) pure function cosh_rn(arg) bind(C,name="cosh_rn")
      use, intrinsic :: iso_c_binding, only : c_double
      real(kind=c_double), intent(in), value :: arg
    end function cosh_rn




  end interface

contains

  ! ========================================================================== !
  !  Definition of the MathlibBouncer (_mb) callable functions
  ! ========================================================================== !

  logical pure elemental function isnan_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    isnan_mb = arg /= arg
  end function isnan_mb

  real(kind=fPrec) pure function sin_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    sin_mb=sin_rn(arg)
  end function sin_mb

  real(kind=fPrec) pure function asin_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    asin_mb=asin_rn(arg)
  end function asin_mb

  real(kind=fPrec) pure function sinh_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    sinh_mb=sinh_rn(arg)
  end function sinh_mb

  real(kind=fPrec) pure function cos_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    cos_mb=cos_rn(arg)
  end function cos_mb

  real(kind=fPrec) pure function acos_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    acos_mb=acos_rn(arg)
  end function acos_mb

  real(kind=fPrec) pure function cosh_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    cosh_mb=cosh_rn(arg)
  end function cosh_mb

  real(kind=fPrec) pure function tan_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    tan_mb=tan_rn(arg)
  end function tan_mb

  real(kind=fPrec) pure function atan_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    atan_mb=atan_rn(arg)
  end function atan_mb

  real(kind=fPrec) pure function atan2_mb(y,x)
    real(kind=fPrec), intent(in) :: y,x
    atan2_mb=atan2_rn(y,x)
  end function atan2_mb

  real(kind=fPrec) pure function exp_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    exp_mb=exp_rn(arg)
  end function exp_mb

  real(kind=fPrec) pure function log_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    log_mb=log_rn(arg)
  end function log_mb

  real(kind=fPrec) pure function log10_mb(arg)
    real(kind=fPrec), intent(in) :: arg
    log10_mb=log10_rn(arg)
  end function log10_mb


  ! ========================================================================== !
  !  ROUND NEAR SPEACIAL FUNCTIONS
  ! ========================================================================== !

  real(kind=real64) pure function acos_rn(x)
    use, intrinsic :: iso_fortran_env, only : real64
    use numerical_constants, only : pi, pi2
    real(kind=real64), intent(in) :: x
    if(x /= x) then ! Check if NaN
      acos_rn=x
    elseif(abs(x) == 0.0d0) then
      acos_rn=pi2
    else
      ! Try using (1-x)*(1+x) in case x is very small or close to 1. Write a test program?
      acos_rn=atan_rn(sqrt((1.0d0-x)*(1.0d0+x))/x)
      if(x < 0d0) then
        acos_rn=pi+acos_rn
      end if
    end if
  end function acos_rn

  real(kind=real64) pure function asin_rn(x)
    use, intrinsic :: iso_fortran_env, only : real64
    use numerical_constants, only : pi, pi2
    real(kind=real64), intent(in) :: x
    if(x /= x) then ! Check if NaN
      asin_rn=x
      return
    end if
    if(abs(x) == 1.0d0) then
      asin_rn=sign(pi2,x)
    else
      ! Try using (1-x)*(1+x) in case x is very small or close to 1. Write a test program?
      asin_rn=atan_rn(x/sqrt((1.0d0-x)*(1.0d0+x)))
    end if
  end function asin_rn

  real(kind=real64) pure function atan2_rn(y,x)
    use, intrinsic :: iso_fortran_env, only : real64
    use numerical_constants, only : pi, pi2
    real(kind=real64), intent(in) :: x,y
    if(x == 0d0) then
      if(y == 0d0) then
        ! Let the internal atan2 handle this case according to ieee
        atan2_rn=atan2(y,x)
      else
        atan2_rn=sign(pi2,y)
      end if
    else
      if(y == 0d0) then
        if(x > 0d0) then
          ! Let the internal atan2 handle this case according to ieee
          atan2_rn=atan2(y,x)
        else
          atan2_rn=pi
        end if
      else
        atan2_rn=atan_rn(y/x)
        if(x < 0d0) then
          atan2_rn=sign(pi,y)+atan2_rn
        end if
      end if
    end if
  end function atan2_rn

  ! ========================================================================== !
  !  ROUND UP SPEACIAL FUNCTIONS
  ! ========================================================================== !


  ! ========================================================================== !
  !  ROUND DOWN SPEACIAL FUNCTIONS
  ! ========================================================================== !


  ! ========================================================================== !
  !  ROUND ZERO SPEACIAL FUNCTIONS
  ! ========================================================================== !



end module mathlib_bouncer

! ================================================================================================ !
!  SixTrack Array Alloc Module
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!  J. Molson, K.N. Sjobak, V.K. Berglyd Olsen, BE-ABP-HSS
!  Last Modified: 2018-12-17
! ================================================================================================ !

module mod_alloc

  use, intrinsic :: iso_fortran_env
  use crcoall

  implicit none





  ! The total quantity of memory allocated (bits)
  integer(kind=int64) :: allocated_bits = 0

  ! The maximum quantity of memory allocated (bits)
  integer(kind=int64) :: maximum_bits = 0
  integer(kind=int32) :: alloc_count  = 0

  integer(kind=int64), parameter :: mbyte = 1024*1024*8
  integer(kind=int64), parameter :: kbyte = 1024*8
  integer(kind=int64), parameter :: byte  = 8

  integer, parameter :: size_of_logical = 32 ! Unless specific flags are set, a logical is stored as an int32

  interface alloc

    module procedure alloc1di16  ! 1D int16
    module procedure alloc2di16  ! 2D int16
    module procedure alloc3di16  ! 3D int16

    module procedure alloc1di32  ! 1D int32
    module procedure alloc2di32  ! 2D int32
    module procedure alloc3di32  ! 3D int32

    module procedure alloc1di64  ! 1D int64
    module procedure alloc2di64  ! 2D int64
    module procedure alloc3di64  ! 3D int64

    module procedure alloc1dr32  ! 1D real32
    module procedure alloc2dr32  ! 2D real32
    module procedure alloc3dr32  ! 3D real32
    module procedure alloc4dr32  ! 4D real32

    module procedure alloc1dr64  ! 1D real64
    module procedure alloc2dr64  ! 2D real64
    module procedure alloc3dr64  ! 3D real64
    module procedure alloc4dr64  ! 4D real64

    module procedure alloc1dr128 ! 1D real128
    module procedure alloc2dr128 ! 2D real128
    module procedure alloc3dr128 ! 3D real128
    module procedure alloc4dr128 ! 4D real128

    module procedure alloc1dc    ! 1D character
    module procedure alloc2dc    ! 2D character

    module procedure alloc1ds    ! 1D string

    module procedure alloc1dl    ! 1D logical
    module procedure alloc2dl    ! 2D logical

  end interface alloc

  interface dealloc

    module procedure dealloc1di16  ! 1D int16
    module procedure dealloc2di16  ! 2D int16
    module procedure dealloc3di16  ! 3D int16

    module procedure dealloc1di32  ! 1D int32
    module procedure dealloc2di32  ! 2D int32
    module procedure dealloc3di32  ! 3D int32

    module procedure dealloc1di64  ! 1D int64
    module procedure dealloc2di64  ! 2D int64
    module procedure dealloc3di64  ! 3D int64

    module procedure dealloc1dr32  ! 1D real32
    module procedure dealloc2dr32  ! 2D real32
    module procedure dealloc3dr32  ! 3D real32
    module procedure dealloc4dr32  ! 4D real32

    module procedure dealloc1dr64  ! 1D real64
    module procedure dealloc2dr64  ! 2D real64
    module procedure dealloc3dr64  ! 3D real64
    module procedure dealloc4dr64  ! 4D real64

    module procedure dealloc1dr128 ! 1D real128
    module procedure dealloc2dr128 ! 2D real128
    module procedure dealloc3dr128 ! 3D real128
    module procedure dealloc4dr128 ! 4D real128

    module procedure dealloc1dc    ! 1D character
    module procedure dealloc2dc    ! 2D character

    module procedure dealloc1dl    ! 1D logical
    module procedure dealloc2dl    ! 2D logical

  end interface dealloc

  private :: alloc1di16,alloc2di16,alloc3di16
  private :: alloc1di32,alloc2di32,alloc3di32
  private :: alloc1di64,alloc2di64,alloc3di64
  private :: alloc1dr32,alloc2dr32,alloc3dr32,alloc4dr32
  private :: alloc1dr64,alloc2dr64,alloc3dr64,alloc4dr64
  private :: alloc1dr128,alloc2dr128,alloc3dr128,alloc4dr128
  private :: alloc1dc,alloc2dc
  private :: alloc1ds
  private :: alloc1dl,alloc2dl

  private :: dealloc1di16,dealloc2di16,dealloc3di16
  private :: dealloc1di32,dealloc2di32,dealloc3di32
  private :: dealloc1di64,dealloc2di64,dealloc3di64
  private :: dealloc1dr32,dealloc2dr32,dealloc3dr32,dealloc4dr32
  private :: dealloc1dr64,dealloc2dr64,dealloc3dr64,dealloc4dr64
  private :: dealloc1dr128,dealloc2dr128,dealloc3dr128,dealloc4dr128
  private :: dealloc1dc,dealloc2dc
  private :: dealloc1dl,dealloc2dl

contains

subroutine alloc_init



  return

end subroutine alloc_init

subroutine alloc_error(ename, error, requested_bits)

  implicit none

  character(len=*),    intent(in) :: ename          ! The variable name we are allocating
  integer(kind=int64), intent(in) :: requested_bits ! The requested allocation size
  integer,             intent(in) :: error          ! The error code

  write(lerr,"(a)")      "ALLOC> ERROR Memory allocation error for array "//ename
  write(lerr,"(a,i0,a)") "ALLOC>       Current allocation is:    ",allocated_bits," bits"
  write(lerr,"(a,i0,a)") "ALLOC>       Requested allocation is:  ",requested_bits," bits"
  write(lerr,"(a,i0)")   "ALLOC        Allocation error code is: ",error
  write(lerr,"(a)")      "ALLOC>       Exiting!"
  stop 1

end subroutine alloc_error

subroutine print_alloc(ename, type, requested_bits)

  use numerical_constants, only : one

  character(len=*), intent(in) :: ename, type
  integer(kind=int64) :: requested_bits


  alloc_count = alloc_count + 1
  if(allocated_bits > maximum_bits) then
    maximum_bits = allocated_bits
  end if

end subroutine print_alloc

! ================================================================================================ !
!  Allocation and Resizing
! ~~~~~~~~~~~~~~~~~~~~~~~~~
!  Inputs:
!    ename   :: The name of the variable being assigned,for error printing
!    eIdx    :: The new end index (size) that the array should be set to
!    initial :: The inital value for the array to be set to
!    input   :: The input variable to allocated
!    fIdx    :: The index of the first element
! ================================================================================================ !

! ================================================================================================ !
!  INTEGERS
! ================================================================================================ !

! 1D int16 Array
subroutine alloc1di16(input, eIdx, initial, ename, fIdxIn)

  implicit none

  integer(kind=int16), allocatable, intent(inout) :: input(:)
  integer,                          intent(in)    :: eIdx
  integer(kind=int16),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn

  integer(kind=int16), allocatable :: buffer(:)   ! Buffer array
  integer                          :: fIdx        ! First index
  integer                          :: oIdx        ! Old end index
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(int16)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(int16)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D int16",request)

end subroutine alloc1di16

! 2D int16 Array
subroutine alloc2di16(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  integer(kind=int16), allocatable, intent(inout) :: input(:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2
  integer(kind=int16),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2

  integer(kind=int16), allocatable :: buffer(:,:) ! Buffer array
  integer                          :: fIdx1,fIdx2 ! First indices
  integer                          :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(int16)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * storage_size(int16)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D int16",request)

end subroutine alloc2di16

! 3D int16 Array
subroutine alloc3di16(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  integer(kind=int16), allocatable, intent(inout) :: input(:,:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2,eIdx3
  integer(kind=int16),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  integer(kind=int16), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                          :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                          :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)              :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(int16)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(int16)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D int16",request)

end subroutine alloc3di16

! 1D int32 Array
subroutine alloc1di32(input, eIdx, initial, ename, fIdxIn)

  implicit none

  integer(kind=int32), allocatable, intent(inout) :: input(:)
  integer,                          intent(in)    :: eIdx
  integer(kind=int32),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn

  integer(kind=int32), allocatable :: buffer(:)   ! Buffer array
  integer                          :: fIdx        ! First index
  integer                          :: oIdx        ! Old end index
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(int32)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(int32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D int32",request)

end subroutine alloc1di32

! 2D int32 Array
subroutine alloc2di32(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  integer(kind=int32), allocatable, intent(inout) :: input(:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2
  integer(kind=int32),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2

  integer(kind=int32), allocatable :: buffer(:,:) ! Buffer array
  integer                          :: fIdx1,fIdx2 ! First indices
  integer                          :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(int32)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * storage_size(int32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D int32",request)

end subroutine alloc2di32

! 3D int32 Array
subroutine alloc3di32(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  integer(kind=int32), allocatable, intent(inout) :: input(:,:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2,eIdx3
  integer(kind=int32),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  integer(kind=int32), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                          :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                          :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)              :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(int32)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(int32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D int32",request)

end subroutine alloc3di32

! 1D int64 Array
subroutine alloc1di64(input, eIdx, initial, ename, fIdxIn)

  implicit none

  integer(kind=int64), allocatable, intent(inout) :: input(:)
  integer,                          intent(in)    :: eIdx
  integer(kind=int64),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn

  integer(kind=int64), allocatable :: buffer(:)   ! Buffer array
  integer                          :: fIdx        ! First index
  integer                          :: oIdx        ! Old end index
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(int64)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx, eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(int64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D int64",request)

end subroutine alloc1di64

! 2D int64 Array
subroutine alloc2di64(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  integer(kind=int64), allocatable, intent(inout) :: input(:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2
  integer(kind=int64),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2

  integer(kind=int64), allocatable :: buffer(:,:) ! Buffer array
  integer                          :: fIdx1,fIdx2 ! First indices
  integer                          :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)              :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(int64)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * storage_size(int64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D int64",request)

end subroutine alloc2di64

! 3D int64 Array
subroutine alloc3di64(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  integer(kind=int64), allocatable, intent(inout) :: input(:,:,:)
  integer,                          intent(in)    :: eIdx1,eIdx2,eIdx3
  integer(kind=int64),              intent(in)    :: initial
  character(len=*),                 intent(in)    :: ename
  integer,             optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  integer(kind=int64), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                          :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                          :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)              :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(int64)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(int64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D int64",request)

end subroutine alloc3di64

! ================================================================================================ !
!  REALS
! ================================================================================================ !

! 1D real32 Array
subroutine alloc1dr32(input, eIdx, initial, ename, fIdxIn)

  implicit none

  real(kind=real32), allocatable, intent(inout) :: input(:)
  integer,                        intent(in)    :: eIdx
  real(kind=real32),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn

  real(kind=real32), allocatable :: buffer(:)   ! Buffer array
  integer                        :: fIdx        ! First index
  integer                        :: oIdx        ! Old end index
  integer(kind=int64)            :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(real32)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(real32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D real32",request)

end subroutine alloc1dr32

! 2D real32 Array
subroutine alloc2dr32(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  real(kind=real32), allocatable, intent(inout) :: input(:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2
  real(kind=real32),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2

  real(kind=real32), allocatable :: buffer(:,:) ! Buffer array
  integer                        :: fIdx1,fIdx2 ! First indices
  integer                        :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)            :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(real32)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * storage_size(real32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D real32",request)

end subroutine alloc2dr32

! 3D real32 Array
subroutine alloc3dr32(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  real(kind=real32), allocatable, intent(inout) :: input(:,:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2,eIdx3
  real(kind=real32),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  real(kind=real32), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                        :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                        :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)            :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(real32)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(real32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D real32",request)

end subroutine alloc3dr32

! 4D real32 Array
subroutine alloc4dr32(input, eIdx1, eIdx2, eIdx3, eIdx4, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3, fIdxIn4)

  implicit none

  real(kind=real32), allocatable, intent(inout) :: input(:,:,:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2,eIdx3,eIdx4
  real(kind=real32),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3,fIdxIn4

  real(kind=real32), allocatable :: buffer(:,:,:,:)         ! Buffer array
  integer                        :: fIdx1,fIdx2,fIdx3,fIdx4 ! First indices
  integer                        :: oIdx1,oIdx2,oIdx3,oIdx4 ! Old end indices
  integer(kind=int64)            :: request                 ! Requested size addition

  integer i, j, k, l, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if
  if(present(fIdxIn4)) then
    fIdx4 = fIdxIn4
  else
    fIdx4 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1) * storage_size(real32)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            input(l,k,j,i) = initial
          end do
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    oIdx4   = size(input,4)+fIdx4-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)*(oIdx4-fIdx4+1)) * storage_size(real32)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            buffer(l,k,j,i) = initial
          end do
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3
    if(oIdx4 > eIdx4) oIdx4 = eIdx4

    do i=fIdx4,oIdx4
      do j=fIdx3,oIdx3
        do k=fIdx2,oIdx2
          do l=fIdx1,oIdx1
            buffer(l,k,j,i) = input(l,k,j,i)
          end do
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"4D real32",request)

end subroutine alloc4dr32

! 1D real64 Array
subroutine alloc1dr64(input, eIdx, initial, ename, fIdxIn)

  implicit none

  real(kind=real64), allocatable, intent(inout) :: input(:)
  integer,                        intent(in)    :: eIdx
  real(kind=real64),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn

  real(kind=real64), allocatable :: buffer(:)   ! Buffer array
  integer                        :: fIdx        ! First index
  integer                        :: oIdx        ! Old end index
  integer(kind=int64)            :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(real64)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx   = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(real64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D real64",request)

end subroutine alloc1dr64

! 2D real64 Array
subroutine alloc2dr64(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  real(kind=real64), allocatable, intent(inout) :: input(:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2
  real(kind=real64),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2

  real(kind=real64), allocatable :: buffer(:,:) ! Buffer array
  integer                        :: fIdx1,fIdx2 ! First indices
  integer                        :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)            :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(real64)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * storage_size(real64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D real64",request)

end subroutine alloc2dr64

! 3D real64 Array
subroutine alloc3dr64(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  real(kind=real64), allocatable, intent(inout) :: input(:,:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2,eIdx3
  real(kind=real64),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  real(kind=real64), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                        :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                        :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)            :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(real64)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(real64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D real64",request)

end subroutine alloc3dr64

! 4d real64 array
subroutine alloc4dr64(input, eIdx1, eIdx2, eIdx3, eIdx4, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3, fIdxIn4)

  implicit none

  real(kind=real64), allocatable, intent(inout) :: input(:,:,:,:)
  integer,                        intent(in)    :: eIdx1,eIdx2,eIdx3,eIdx4
  real(kind=real64),              intent(in)    :: initial
  character(len=*),               intent(in)    :: ename
  integer,           optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3,fIdxIn4

  real(kind=real64), allocatable :: buffer(:,:,:,:)         ! Buffer array
  integer                        :: fIdx1,fIdx2,fIdx3,fIdx4 ! First indices
  integer                        :: oIdx1,oIdx2,oIdx3,oIdx4 ! Old end indices
  integer(kind=int64)            :: request                 ! Requested size addition

  integer i, j, k, l, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if
  if(present(fIdxIn4)) then
    fIdx4 = fIdxIn4
  else
    fIdx4 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1) * storage_size(real64)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            input(l,k,j,i) = initial
          end do
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    oIdx4   = size(input,4)+fIdx4-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)*(oIdx4-fIdx4+1)) * storage_size(real64)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            buffer(l,k,j,i) = initial
          end do
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3
    if(oIdx4 > eIdx4) oIdx4 = eIdx4

    do i=fIdx4,oIdx4
      do j=fIdx3,oIdx3
        do k=fIdx2,oIdx2
          do l=fIdx1,oIdx1
            buffer(l,k,j,i) = input(l,k,j,i)
          end do
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"4D real64",request)

end subroutine alloc4dr64

! 1D real128 Array
subroutine alloc1dr128(input, eIdx, initial, ename, fIdxIn)

  implicit none

  real(kind=real128), allocatable, intent(inout) :: input(:)
  integer,                         intent(in)    :: eIdx
  real(kind=real128),              intent(in)    :: initial
  character(len=*),                intent(in)    :: ename
  integer,            optional,    intent(in)    :: fIdxIn

  real(kind=real128), allocatable :: buffer(:)   ! Buffer array
  integer                         :: fIdx        ! First index
  integer                         :: oIdx        ! Old end index
  integer(kind=int64)             :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * storage_size(real128)

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx   = size(input)+fIdx-1
    request = (eIdx-oIdx) * storage_size(real128)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D real128",request)

end subroutine alloc1dr128

! 2D real128 Array
subroutine alloc2dr128(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  real(kind=real128), allocatable, intent(inout) :: input(:,:)
  integer,                         intent(in)    :: eIdx1,eIdx2
  real(kind=real128),              intent(in)    :: initial
  character(len=*),                intent(in)    :: ename
  integer,            optional,    intent(in)    :: fIdxIn1,fIdxIn2

  real(kind=real128), allocatable :: buffer(:,:) ! Buffer array
  integer                         :: fIdx1,fIdx2 ! First indices
  integer                         :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)             :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * storage_size(real128)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1) * (eIdx2-fIdx2+1) - &
               (eIdx1-oIdx1)  * (eIdx2-oIdx2)) * storage_size(real128)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D real128",request)

end subroutine alloc2dr128

! 3D real128 Array
subroutine alloc3dr128(input, eIdx1, eIdx2, eIdx3, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3)

  implicit none

  real(kind=real128), allocatable, intent(inout) :: input(:,:,:)
  integer,                         intent(in)    :: eIdx1,eIdx2,eIdx3
  real(kind=real128),              intent(in)    :: initial
  character(len=*),                intent(in)    :: ename
  integer,            optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3

  real(kind=real128), allocatable :: buffer(:,:,:)     ! Buffer array
  integer                         :: fIdx1,fIdx2,fIdx3 ! First indices
  integer                         :: oIdx1,oIdx2,oIdx3 ! Old end indices
  integer(kind=int64)             :: request           ! Requested size addition

  integer i, j, k, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1) * storage_size(real128)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          input(k,j,i) = initial
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)) * storage_size(real128)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx3,eIdx3
      do j=fIdx2,eIdx2
        do k=fIdx1,eIdx1
          buffer(k,j,i) = initial
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3

    do i=fIdx3,oIdx3
      do j=fIdx2,oIdx2
        do k=fIdx1,oIdx1
          buffer(k,j,i) = input(k,j,i)
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"3D real128",request)

end subroutine alloc3dr128

! 4D real128 Array
subroutine alloc4dr128(input, eIdx1, eIdx2, eIdx3, eIdx4, initial, ename, fIdxIn1, fIdxIn2, fIdxIn3, fIdxIn4)

  implicit none

  real(kind=real128), allocatable, intent(inout) :: input(:,:,:,:)
  integer,                         intent(in)    :: eIdx1,eIdx2,eIdx3,eIdx4
  real(kind=real128),              intent(in)    :: initial
  character(len=*),                intent(in)    :: ename
  integer,            optional,    intent(in)    :: fIdxIn1,fIdxIn2,fIdxIn3,fIdxIn4

  real(kind=real128), allocatable :: buffer(:,:,:,:)         ! Buffer array
  integer                         :: fIdx1,fIdx2,fIdx3,fIdx4 ! First indices
  integer                         :: oIdx1,oIdx2,oIdx3,oIdx4 ! Old end indices
  integer(kind=int64)             :: request                 ! Requested size addition

  integer i, j, k, l, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if
  if(present(fIdxIn3)) then
    fIdx3 = fIdxIn3
  else
    fIdx3 = 1
  end if
  if(present(fIdxIn4)) then
    fIdx4 = fIdxIn4
  else
    fIdx4 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1) * storage_size(real128)

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            input(l,k,j,i) = initial
          end do
        end do
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    oIdx3   = size(input,3)+fIdx3-1
    oIdx4   = size(input,4)+fIdx4-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)*(eIdx3-fIdx3+1)*(eIdx4-fIdx4+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)*(oIdx3-fIdx3+1)*(oIdx4-fIdx4+1)) * storage_size(real128)

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2,fIdx3:eIdx3,fIdx4:eIdx4), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx4,eIdx4
      do j=fIdx3,eIdx3
        do k=fIdx2,eIdx2
          do l=fIdx1,eIdx1
            buffer(l,k,j,i) = initial
          end do
        end do
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2
    if(oIdx3 > eIdx3) oIdx3 = eIdx3
    if(oIdx4 > eIdx4) oIdx4 = eIdx4

    do i=fIdx4,oIdx4
      do j=fIdx3,oIdx3
        do k=fIdx2,oIdx2
          do l=fIdx1,oIdx1
            buffer(l,k,j,i) = input(l,k,j,i)
          end do
        end do
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"4D real128",request)

end subroutine alloc4dr128

! ================================================================================================ !
!  CHARACTERS
! ================================================================================================ !

! 1D character Array
subroutine alloc1dc(input, strlen, eIdx, initial, ename, fIdxIn)

  implicit none

  character(len=:), allocatable, intent(inout) :: input(:)
  integer,                       intent(in)    :: strlen
  integer,                       intent(in)    :: eIdx
  character(len=*),              intent(in)    :: initial
  character(len=*),              intent(in)    :: ename
  integer,          optional,    intent(in)    :: fIdxIn

  character(len=:), allocatable :: buffer(:)   ! Buffer array
  integer                       :: fIdx        ! First index
  integer                       :: oIdx        ! Old end index
  integer(kind=int64)           :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * strlen * CHARACTER_STORAGE_SIZE

    allocate(character(strlen) :: input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = (eIdx-oIdx) * strlen * CHARACTER_STORAGE_SIZE

    if(request == 0.0) then
      return
    end if

    allocate(character(strlen) :: buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D character",request)

end subroutine alloc1dc

! 2D character Array
subroutine alloc2dc(input, strlen, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  character(len=:), allocatable, intent(inout) :: input(:,:)
  integer,                       intent(in)    :: strlen
  integer,                       intent(in)    :: eIdx1,eIdx2
  character(len=*),              intent(in)    :: initial
  character(len=*),              intent(in)    :: ename
  integer,          optional,    intent(in)    :: fIdxIn1,fIdxIn2

  character(len=:), allocatable :: buffer(:,:) ! Buffer array
  integer                       :: fIdx1,fIdx2 ! First index
  integer                       :: oIdx1,oIdx2 ! Old end index
  integer(kind=int64)           :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * strlen * CHARACTER_STORAGE_SIZE

    allocate(character(strlen) :: input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1)  - &
               (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1)) * strlen * CHARACTER_STORAGE_SIZE

    if(request == 0.0) then
      return
    end if

    allocate(character(strlen) :: buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D character",request)

end subroutine alloc2dc

! ==================================================================== !
!  STRINGS
! ==================================================================== !

subroutine alloc1ds(input, eIdx, initial, ename, fIdxIn)

  use strings

  implicit none

  type(string), allocatable, intent(inout) :: input(:)
  integer,                   intent(in)    :: eIdx
  type(string),              intent(in)    :: initial
  character(len=*),          intent(in)    :: ename
  integer,      optional,    intent(in)    :: fIdxIn

  type(string), allocatable :: buffer(:)   ! Buffer array
  integer                   :: fIdx        ! First index
  integer                   :: oIdx        ! Old end index
  integer(kind=int64)       :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = eIdx-fIdx+1

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = eIdx-oIdx

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D string",request)

end subroutine alloc1ds

! ================================================================================================ !
!  LOGICALS
! ================================================================================================ !

! 1D logical Array
subroutine alloc1dl(input, eIdx, initial, ename, fIdxIn)

  implicit none

  logical, allocatable, intent(inout) :: input(:)
  integer,              intent(in)    :: eIdx
  logical,              intent(in)    :: initial
  character(len=*),     intent(in)    :: ename
  integer, optional,    intent(in)    :: fIdxIn

  logical, allocatable :: buffer(:)   ! Buffer array
  integer              :: fIdx        ! First index
  integer              :: oIdx        ! Old end index
  integer(kind=int64)  :: request     ! Requested size addition

  integer i, error

  if(present(fIdxIn)) then
    fIdx = fIdxIn
  else
    fIdx = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx-fIdx+1) * size_of_logical

    allocate(input(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      input(i) = initial
    end do

  else

    oIdx    = size(input)+fIdx-1
    request = eIdx-oIdx

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx:eIdx), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx,eIdx
      buffer(i) = initial
    end do

    if(oIdx > eIdx) oIdx = eIdx
    do i=fIdx,oIdx
      buffer(i) = input(i)
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"1D logical",request)

end subroutine alloc1dl

! 2D logical Array
subroutine alloc2dl(input, eIdx1, eIdx2, initial, ename, fIdxIn1, fIdxIn2)

  implicit none

  logical, allocatable, intent(inout) :: input(:,:)
  integer,              intent(in)    :: eIdx1,eIdx2
  logical,              intent(in)    :: initial
  character(len=*),     intent(in)    :: ename
  integer, optional,    intent(in)    :: fIdxIn1,fIdxIn2

  logical, allocatable :: buffer(:,:) ! Buffer array
  integer              :: fIdx1,fIdx2 ! First indices
  integer              :: oIdx1,oIdx2 ! Old end indices
  integer(kind=int64)  :: request     ! Requested size addition

  integer i, j, error

  if(present(fIdxIn1)) then
    fIdx1 = fIdxIn1
  else
    fIdx1 = 1
  end if
  if(present(fIdxIn2)) then
    fIdx2 = fIdxIn2
  else
    fIdx2 = 1
  end if

  if(.not. allocated(input)) then

    request = (eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) * size_of_logical

    allocate(input(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        input(j,i) = initial
      end do
    end do

  else

    oIdx1   = size(input,1)+fIdx1-1
    oIdx2   = size(input,2)+fIdx2-1
    request = ((eIdx1-fIdx1+1)*(eIdx2-fIdx2+1) - (oIdx1-fIdx1+1)*(oIdx2-fIdx2+1))

    if(request == 0.0) then
      return
    end if

    allocate(buffer(fIdx1:eIdx1,fIdx2:eIdx2), stat=error)
    if(error /= 0) call alloc_error(ename, error, request)

    do i=fIdx2,eIdx2
      do j=fIdx1,eIdx1
        buffer(j,i) = initial
      end do
    end do

    if(oIdx1 > eIdx1) oIdx1 = eIdx1
    if(oIdx2 > eIdx2) oIdx2 = eIdx2

    do i=fIdx2,oIdx2
      do j=fIdx1,oIdx1
        buffer(j,i) = input(j,i)
      end do
    end do

    call move_alloc(buffer,input)

  end if

  allocated_bits = allocated_bits + request
  call print_alloc(ename,"2D logical",request)

end subroutine alloc2dl

! ================================================================================================ !
!  DEALLOCTIONS
! ~~~~~~~~~~~~~~
!  These exist to keep track of the total allocated memory
! ================================================================================================ !

! 1D int16 Array
subroutine dealloc1di16(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int16), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(int16))
  deallocate(input)
end subroutine dealloc1di16

! 2D int16 Array
subroutine dealloc2di16(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int16), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(int16))
  deallocate(input)
end subroutine dealloc2di16

! 3D int16 Array
subroutine dealloc3di16(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int16), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(int16))
  deallocate(input)
end subroutine dealloc3di16

! 1D int32 Array
subroutine dealloc1di32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int32), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(int32))
  deallocate(input)
end subroutine dealloc1di32

! 2D int32 Array
subroutine dealloc2di32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int32), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(int32))
  deallocate(input)
end subroutine dealloc2di32

! 3D int32 Array
subroutine dealloc3di32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int32), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(int32))
  deallocate(input)
end subroutine dealloc3di32

! 1D int64 Array
subroutine dealloc1di64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int64), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(int64))
  deallocate(input)
end subroutine dealloc1di64

! 2D int64 Array
subroutine dealloc2di64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int64), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(int64))
  deallocate(input)
end subroutine dealloc2di64

! 3D int64 Array
subroutine dealloc3di64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  integer(kind=int64), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(int64))
  deallocate(input)
end subroutine dealloc3di64

! 1D real32 Array
subroutine dealloc1dr32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real32), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(real32))
  deallocate(input)
end subroutine dealloc1dr32

! 2D real32 Array
subroutine dealloc2dr32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real32), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(real32))
  deallocate(input)
end subroutine dealloc2dr32

! 3D real32 Array
subroutine dealloc3dr32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real32), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(real32))
  deallocate(input)
end subroutine dealloc3dr32

! 4D real32 Array
subroutine dealloc4dr32(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real32), allocatable, intent(inout) :: input(:,:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*size(input,4)*storage_size(real32))
  deallocate(input)
end subroutine dealloc4dr32

! 1D real64 Array
subroutine dealloc1dr64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real64), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(real64))
  deallocate(input)
end subroutine dealloc1dr64

! 2D real64 Array
subroutine dealloc2dr64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real64), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(real64))
  deallocate(input)
end subroutine dealloc2dr64

! 3D real64 Array
subroutine dealloc3dr64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real64), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(real64))
  deallocate(input)
end subroutine dealloc3dr64

! 4D real64 Array
subroutine dealloc4dr64(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real64), allocatable, intent(inout) :: input(:,:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*size(input,4)*storage_size(real64))
  deallocate(input)
end subroutine dealloc4dr64

! 1D real128 Array
subroutine dealloc1dr128(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real128), allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*storage_size(real128))
  deallocate(input)
end subroutine dealloc1dr128

! 2D real128 Array
subroutine dealloc2dr128(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real128), allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*storage_size(real128))
  deallocate(input)
end subroutine dealloc2dr128

! 3D real128 Array
subroutine dealloc3dr128(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real128), allocatable, intent(inout) :: input(:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*storage_size(real128))
  deallocate(input)
end subroutine dealloc3dr128

! 4D real128 Array
subroutine dealloc4dr128(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  real(kind=real128), allocatable, intent(inout) :: input(:,:,:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*size(input,3)*size(input,4)*storage_size(real128))
  deallocate(input)
end subroutine dealloc4dr128

! 1D character Array
subroutine dealloc1dc(input, strlen, ename)
  implicit none
  character(len=*), intent(in) :: ename
  character(len=:), allocatable, intent(inout) :: input(:)
  integer, intent(in) :: strlen

  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  !TODO: Check what size(input) actually does
  allocated_bits = allocated_bits - (size(input,1)*strlen * CHARACTER_STORAGE_SIZE)
  deallocate(input)
end subroutine dealloc1dc

! 2D character Array
subroutine dealloc2dc(input, strlen, ename)
  implicit none
  character(len=*), intent(in) :: ename
  character(len=:), allocatable, intent(inout) :: input(:,:)
  integer, intent(in) :: strlen

  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  !TODO: Check what size(input) actually does
  allocated_bits = allocated_bits - (size(input,1)*size(input,2)*strlen * CHARACTER_STORAGE_SIZE)
  deallocate(input)
end subroutine dealloc2dc

! 1D logical Array
subroutine dealloc1dl(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  logical, allocatable, intent(inout) :: input(:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - size(input,1)*size_of_logical
  deallocate(input)
end subroutine dealloc1dl

! 2D logical Array
subroutine dealloc2dl(input, ename)
  implicit none
  character(len=*), intent(in) :: ename
  logical, allocatable, intent(inout) :: input(:,:)
  !Check that we are already allocated
  if(.not. allocated(input)) then
    write(lerr,"(a)") "ALLOC> ERROR Trying to deallocate a NULL pointer: '"//ename//"'"
    stop
  end if
  allocated_bits = allocated_bits - size(input,1)*size(input,2)*size_of_logical
  deallocate(input)
end subroutine dealloc2dl

end module mod_alloc

module mod_fluka

  use floatPrecision
  use numerical_constants
  use mod_alloc

  ! A.Mereghetti and D.Sinuela Pastor, for the FLUKA Team
  ! last modified: 18-01-2016
  ! fortran 90 module for coupling SixTrack to FLUKA
  ! NOTA BENE:
  !    napx  (SixTrack) -> npart     (mod_fluka)
  !    npart (SixTrack) -> max_npart (mod_fluka)

  implicit none
  private

  public :: fluka_mod_init
  public :: fluka_mod_expand_arrays
  public :: fluka_mod_end

  public :: fluka_connect
  public :: fluka_end

  public :: fluka_send_receive
  public :: fluka_send
  public :: fluka_receive
  public :: fluka_shuffleLostParticles
  public :: fluka_set_synch_part
  public :: fluka_init_max_uid
  public :: fluka_is_running

  public :: fluka_close

  ! HION variables that are only used for FLUKA
  ! ien0,ien1: ion energy entering/leaving the collimator
  real(kind=8),    public :: ien0, ien1
  integer(kind=4), public :: nnuc0,nnuc1

  ! FlukaIO Connection parameters
  character(len = 255), public  :: fluka_host
  integer, public :: fluka_port
  character(len = 255), parameter :: fluka_net_nfo_file = 'network.nfo'

  ! FlukaIO interface
  external ntinit, ntconnect, ntend
  external ntsendp,     &
           ntsendeob,   &
           ntsendeoc,   &
           ntsendipt,   &
           ntrecv,      &
           ntwait,      &
           ntsendnpart, &
           ntsendbrhono
  external ntrtimeout, ntwtimeout

  integer(kind=4) :: ntconnect,   &
                     ntsendp,     &
                     ntsendeob,   &
                     ntsendeoc,   &
                     ntsendipt,   &
                     ntrecv,      &
                     ntwait,      &
                     ntsendnpart, &
                     ntsendbrhono,&
                     ntend
  integer(kind=4) :: ntrtimeout, ntwtimeout

  ! FlukaIO Message types
  integer(kind=1), parameter :: FLUKA_PART = 1, &
                                FLUKA_EOB  = 2, &
                                FLUKA_EOC  = 3, &
                                FLUKA_CONF = 4, &
                                FLUKA_IPT  = 5, &
                                FLUKA_HSK  = 6, &
                                FLUKA_NPART= 7, &
                                FLUKA_BRHO = 8
  ! connection ID
  integer(kind=4) :: fluka_cid

  ! FLUKA input block
  logical, public :: fluka_enable    = .false.         ! enable coupling
  logical, public :: fluka_connected = .false.         ! fluka is connected
  integer, public :: fluka_debug_level = 1             ! write debug messages
  character(len = 255), public :: pyfluka_log  = "pyfluka.log"
  integer, public :: unit_pyfluka = -1

  ! fluka insertions
  logical, public :: fluka_inside = .false.                    ! Are we in a fluka insertion?
  integer(kind=4), public, allocatable :: fluka_type(:)        ! type of insertion (one per SINGLE ELEMENT)
  integer(kind=4), public, allocatable :: fluka_geo_index(:)   ! index of insertion (one per SINGLE ELEMENT)
  real(kind=8), public, allocatable :: fluka_synch_length(:)   ! length of insertion [m] (one per SINGLE ELEMENT)
  ! current fluka insertion:
  integer :: fluka_i=-1              ! lattice entry (FLUKA_ELEMENT/FLUKA_EXIT)
  integer :: fluka_ix=-1             ! single element entry (FLUKA_ELEMENT/FLUKA_EXIT)
  integer :: fluka_nturn=-1          ! turn
  integer :: fluka_last_sent_mess=-1 ! last sent message
  integer :: fluka_last_rcvd_mess=-1 ! last received message
  ! recognised insertion types
  integer(kind=4), parameter, public :: FLUKA_NONE    = 0, & ! no insertion
                                        FLUKA_ELEMENT = 1, & ! insertion covers only the present SINGLE ELEMENT
                                        FLUKA_ENTRY   = 2, & ! SINGLE ELEMENT marking the start of the insertion
                                        FLUKA_EXIT    = 3    ! SINGLE ELEMENT marking the end   of the insertion
  ! ancillary tracking values
  integer(kind=4), public :: fluka_max_npart                          ! Maximum number of particles (array size)
  integer,          public, allocatable    :: pids(:)         ! Particle ID moved from hisixtrack, to be harmonised

  ! Useful values
  integer :: fluka_nsent     ! Temporary count of sent particles
  integer :: fluka_nrecv     ! Temporary count of received particles
  real(kind=8), public :: fluka_clight ! [m/s]

  ! Reference particle
  real(kind=8), public :: fluka_e0     ! [GeV]
  real(kind=8), public :: fluka_pc0    ! [GeV/c]
  real(kind=8), public :: fluka_mass0  ! [GeV/c2]
  real(kind=8), public :: fluka_brho0  ! [Tm]
  integer(kind=4),          public :: fluka_chrg0  ! []
  integer(kind=4),          public :: fluka_a0     ! nucelon number (hisix)
  integer(kind=4),          public :: fluka_z0     ! nuclear charge

  save

contains

  !----------------------------------------------------------------------------
  ! set the module up
  subroutine fluka_mod_init(npart, nele, clight)

    use mod_units
    use mod_common, only : fort208, unit208
    implicit none

    ! interface variables
    integer :: npart, nele
    real(kind=8) :: clight

    ! temporary variables
    integer :: j

    if(unit_pyfluka == -1) then
      call f_requestUnit(pyfluka_log,unit_pyfluka)
      call f_open(unit=unit_pyfluka,file=pyfluka_log,formatted=.true.,mode="w")
    end if

    if(fluka_debug_level > 1) then
       write(unit_pyfluka,*) "fluka_mod_init npart=", npart, ", nele=", nele, ", clight=", clight
       flush(unit_pyfluka)
    end if

    fluka_max_npart = npart
    fluka_clight    = clight

    call alloc(pids,               npart, 0, "pids")
    call alloc(fluka_type,         nele, FLUKA_NONE, 'fluka_type')
    call alloc(fluka_geo_index,    nele, 0, 'fluka_geo_index')
    call alloc(fluka_synch_length, nele, zero, 'fluka_synch_length')

    if(unit208 == -1) then
      call f_requestUnit(fort208,unit208)
      call f_open(unit=unit208,file=fort208,formatted=.true.,mode="w")
    end if

  end subroutine fluka_mod_init

  subroutine fluka_mod_expand_arrays(npart_new, nele_new)

    use parpro, only : npart

    implicit none

    integer :: npart_new, nele_new, j

    call alloc(pids,               npart_new, 0, "pids")
    call alloc(fluka_type,         nele_new, FLUKA_NONE, 'fluka_type')
    call alloc(fluka_geo_index,    nele_new, 0, 'fluka_geo_index')
    call alloc(fluka_synch_length, nele_new, zero, 'fluka_synch_length')

    fluka_max_npart = npart_new

  end subroutine fluka_mod_expand_arrays

  !----------------------------------------------------------------------------
  ! un-set the module
  subroutine fluka_mod_end()
    implicit none
    call dealloc(pids,"pids")
    call dealloc(fluka_type,'fluka_type')
    call dealloc(fluka_geo_index,'fluka_geo_index')
    call dealloc(fluka_synch_length,'fluka_synch_length')
  end subroutine fluka_mod_end

  !----------------------------------------------------------------------------
  ! acquire info for network communication
  subroutine fluka_read_config(net_nfo_file, host, port)

    use mod_units

    implicit none

    ! interface variables
    character(len=255) :: net_nfo_file
    character(len=255) :: host
    integer :: port
    integer :: net_nfo_unit
    integer :: ios

    call f_requestUnit(net_nfo_file, net_nfo_unit)
    call f_open(net_nfo_unit, file=net_nfo_file, formatted=.true., mode="rw", status='old')
    read(unit=net_nfo_unit, fmt=*, iostat=ios) host
    if(ios .ne. 0) then
      write(lout,'(A)') 'FLUKA> ERROR Could not read the host name from network.nfo'
      ERROR STOP 'ENDED WITH ERROR.'
    end if

    read(unit=net_nfo_unit, fmt=*, iostat=ios) port
    if(ios .ne. 0) then
      write(lout,'(A)') 'FLUKA> ERROR Could not read the port number from network.nfo'
      write(lout,'(A)') 'FLUKA>       Is the FLUKA server running and has it had time to write the port number?'
      ERROR STOP 'ENDED WITH ERROR.'
    end if

    if(fluka_debug_level > 1) then
       write(unit_pyfluka,*) "FLUKA>   host=", host, " port=", port
       flush(unit_pyfluka)
    end if

    call f_close(net_nfo_unit)

  end subroutine fluka_read_config

  !----------------------------------------------------------------------------
  ! start communication with fluka
  integer function fluka_connect(timeout_sec)
    implicit none

    integer(kind=4) :: timeout_sec
    integer :: rtimeout
    integer :: wtimeout

    call fluka_read_config(fluka_net_nfo_file, fluka_host, fluka_port)
    call ntinit()
    fluka_cid = ntconnect(fluka_host, fluka_port)
    fluka_connect = fluka_cid

    rtimeout = ntrtimeout(fluka_cid, timeout_sec)
    wtimeout = ntwtimeout(fluka_cid, timeout_sec)

  end function fluka_connect

  !----------------------------------------------------------------------------
  ! close communication with fluka
  subroutine fluka_end()
    implicit none

    ! Finish connection
    integer(kind=4) :: n

    ! Fluka I/O parameters
    integer(kind=4)         :: flid, flgen
    real(kind=8)  :: flwgt, flx, fly, flz, flxp, flyp, flzp, flpc, flm, flt
    integer(kind=4)         :: flaa, flzz
    integer(kind=2)         :: flq
    integer(kind=1)          :: mtype

    integer(kind=4)         :: flpdgid
    real(kind=8)            :: flsx, flsy, flsz

    if(fluka_debug_level > 0) then
        write(unit_pyfluka,'(A)') 'FlukaIO> Sending End of Computation signal'
        flush(unit_pyfluka)
    end if

    ! Send end of computation
    n = ntsendeoc(fluka_cid)
    if(n.lt.0) then
      write(lout,'(A,i0,A)') "FlukaIO> ERROR ", n, " - Error sending End of Computation"
      flush(lout)
      return
    end if

    ! Wait end of comp
    n = ntwait(fluka_cid, mtype, &
          flid, flgen, flwgt, flx, fly, flz, flxp, flyp, flzp, &
          flm, flpc, flt, flpdgid, flq, flsx, flsy, flsz)
    if(n.lt.0) then
      write(lout,'(A,i0,A)') "FlukaIO> ERROR ", n, " - Server timed out while waiting End of Computation"
      flush(lout)
      return
    end if
    if(mtype.ne.FLUKA_EOC) then
      write(lout,*) "FlukaIO> WARNING Received unexpected message at shutdown"
      flush(lout)
    end if

    ! At this point both ends agreed to disconnect

    ! Close connection
    n = ntend(fluka_cid)

    return
  end subroutine fluka_end

  !----------------------------------------------------------------------------
  ! send and receive particles from Fluka
  integer function fluka_send_receive(turn, ipt, el, npart, max_part, xv1, xv2, yv1, yv2, s, etot, aa, zz, mass, qq, pdg_id, &
                   partID, parentID, partWeight, spinx, spiny, spinz)
    implicit none

    ! Parameters
    integer(kind=4) :: turn
    integer(kind=2) :: ipt
    integer         :: npart
    integer         :: max_part
    real(kind=8)    :: el

    real(kind=8) :: xv1(max_part)
    real(kind=8) :: yv1(max_part)
    real(kind=8) :: xv2(max_part)
    real(kind=8) :: yv2(max_part)
    real(kind=8) :: s(max_part)
    real(kind=8) :: etot(max_part)

    real(kind=8) :: mass(max_part)
    integer(kind=4) :: aa(max_part)
    integer(kind=4) :: zz(max_part)
    integer(kind=2) :: qq(max_part)
    integer(kind=4) :: pdg_id(max_part)
    integer(kind=4) :: partID(max_part)
    integer(kind=4) :: parentID(max_part)
    real(kind=8) :: partWeight(max_part)
    real(kind=8) :: spinx(max_part)
    real(kind=8) :: spiny(max_part)
    real(kind=8) :: spinz(max_part)

    fluka_send_receive = fluka_send(turn, ipt, el, npart, max_part, &
         xv1, xv2, yv1, yv2, s, etot, aa, zz, mass, qq, pdg_id, &
         partID, parentID, partWeight, spinx, spiny, spinz)
    if(fluka_debug_level > 1) then
        write(unit_pyfluka,*) "    Sent all particles (return code ", fluka_send_receive, ")"
        flush(unit_pyfluka)
    end if
    if(fluka_send_receive.lt.0) return

    fluka_send_receive = fluka_receive(turn, ipt, el, npart, max_part, &
         xv1, xv2, yv1, yv2, s, etot, aa, zz, mass, qq, pdg_id, &
         partID, parentID, partWeight, spinx, spiny, spinz)
    if(fluka_debug_level > 1) then
        write(unit_pyfluka,*) "    Received all particles (return code ", fluka_send_receive, ")"
        flush(unit_pyfluka)
    end if
  end function fluka_send_receive

  !----------------------------------------------------------------------------
  ! just send particles to Fluka
  integer function fluka_send(turn, ipt, el, npart, max_part, xv1, xv2, yv1, yv2, s, etot, aa, zz, mass, qq, pdg_id, &
                   partID, parentID, partWeight, spinx, spiny, spinz)
    implicit none

    ! Interface variables
    integer(kind=4) :: turn
    integer(kind=2) :: ipt
    integer         :: npart
    integer         :: max_part
    real(kind=8)    :: el

    real(kind=8) :: xv1(max_part)
    real(kind=8) :: yv1(max_part)
    real(kind=8) :: xv2(max_part)
    real(kind=8) :: yv2(max_part)
    real(kind=8) :: s(max_part)
    real(kind=8) :: etot(max_part)

    real(kind=8) :: mass(max_part)
    integer(kind=4) :: aa(max_part)
    integer(kind=4) :: zz(max_part)
    integer(kind=2) :: qq(max_part)
    integer(kind=4) :: pdg_id(max_part)
    integer(kind=4) :: partID(max_part)
    integer(kind=4) :: parentID(max_part)
    real(kind=8) :: partWeight(max_part)
    real(kind=8) :: spinx(max_part)
    real(kind=8) :: spiny(max_part)
    real(kind=8) :: spinz(max_part)

    ! Fluka I/O parameters
    integer(kind=4) :: flid, flgen
    real(kind=8)    :: flwgt, flx, fly, flz, flxp, flyp, flzp, flet, flm, flt
    integer(kind=4) :: flaa, flzz
    integer(kind=2) :: flq
    integer(kind=1)  :: mtype

    integer(kind=4) :: flpdgid
    real(kind=8)    :: flsx, flsy, flsz

    ! Auxiliary variables
    integer :: j
    integer(kind=4) :: n

    fluka_send = 0
    fluka_last_rcvd_mess = -1

    n = ntsendipt(fluka_cid, turn, ipt)
    if(n.lt.0) then
        write(lout,*) "FlukaIO> ERROR (return code ", n, ") - Error sending Insertion Point"
        fluka_cid = -1
        fluka_send = n
        return
    end if
    fluka_last_sent_mess=FLUKA_IPT
    if(fluka_debug_level > 1) then
        write(unit_pyfluka,*) "FLUKA> Sent insertion point (return code ", n, ")"
        flush(unit_pyfluka)
    end if

    fluka_nsent = 0
    fluka_nrecv = 0
    mtype = 0

    do j=1, npart

        flid  = partID(j)
        flgen = parentID(j)
        flwgt = partWeight(j)

        flx   = xv1(j) * c1m1  ! from [mm] to [cm]
        fly   = xv2(j) * c1m1  ! from [mm] to [cm]
        flz   = zero

        flxp  = yv1(j) * c1m3 ! from [1.0E-03] to [1.0]
        flyp  = yv2(j) * c1m3 ! from [1.0E-03] to [1.0]
        ! director cosines:
        ! full transformation:
        flzp = sqrt(one - flxp**2 - flyp**2)
        ! flzp  = sqrt( one / ( flxp**2 + flyp**2 + one ) )
        !      ! taylor expansion, for consistency with drifts in SixTrack:
        !      flzp  = 1d0 / ( 1d0 + ( flxp**2+flyp**2 )/2d0 )
        !flxp  = flxp * flzp
        !flyp  = flyp * flzp

        ! total energy:
        flet  = etot(j) * c1m3 ! from [MeV] to [GeV]
        ! longitudinal phase:
        flt   = -s(j) * c1m3 / ( (fluka_pc0/fluka_e0)*fluka_clight ) ! from [mm] to [s]


        ! Ion properties (PH for hiSix)
        flm   = mass(j) * c1m3      ! unit is [GeV]
        flaa  = aa(j)
        flzz  = zz(j)

        flpdgid = pdg_id(j)
        flq  = qq(j)
        flsx = spinx(j)
        flsy = spiny(j)
        flsz = spinz(j)

        if(fluka_debug_level > 2) then
            write(unit_pyfluka,*) "    Sending particle: ", flid, flgen, flwgt, flx, fly, flz, flxp, flyp, flzp, flm, flet, flt
            write(unit_pyfluka,*) flsx, flsy, flsz, flaa, flzz, flq, flpdgid
            flush(unit_pyfluka)
        end if

        ! Send particle         TODO: it seems flet should be pc!!
        n = ntsendp(fluka_cid, &
            flid, flgen, flwgt, &
            flx, fly, flz, &
            flxp, flyp, flzp, &
            flm, flet, flt, &
            flpdgid, flq, flsx, flsy, flsz)
        !      write(lout,*) "Sent particle: ", n, fluka_nsent, FLUKA_PART

        if(n.lt.0) then
            write(lout,*) "FlukaIO> ERROR (return code ", n, ") - Error sending Particle"
            fluka_cid = -1
            fluka_send = -1
            return
        end if

        fluka_nsent = fluka_nsent + 1
        fluka_last_sent_mess=FLUKA_PART

    end do

    ! Send end of batch
    n = ntsendeob(fluka_cid)

    if(n.lt.0) then
        write(lout,*) "FlukaIO> ERROR (return code ", n, ") - Error sending End of Batch"
        fluka_cid = -1
        fluka_send = -1
        return
    end if
    fluka_last_sent_mess=FLUKA_EOB

  end function fluka_send

  !----------------------------------------------------------------------------
  ! just receive particles from Fluka
  ! The call from fluka.s90 is:
  ! fluka_receive( nturn, fluka_geo_index(ix), eltot, napx, xv1(:), yv1(:), xv2(:), yv2(:), sigmv, ejv, naa(:), nzz(:), nucm(:))
  ! When the above arrays are made allocatable, the below variables will need updating - see mod_commonmn and mod_hions
  integer function fluka_receive(turn, ipt, el, napx, max_part, xv1, xv2, yv1, yv2, s, etot, aa, zz, mass, qq, pdg_id, &
                                 partID, parentID, partWeight, spinx, spiny, spinz)

    use parpro
    use mod_pdgid
    use mod_common_main, only : MaximumPartID

    implicit none

    ! Interface variables
    integer(kind=4) :: turn
    integer(kind=2) :: ipt
    integer         :: napx
    integer         :: max_part
    real(kind=8)    :: el

    real(kind=8) :: xv1(max_part)
    real(kind=8) :: yv1(max_part)
    real(kind=8) :: xv2(max_part)
    real(kind=8) :: yv2(max_part)
    real(kind=8) :: s(max_part)
    real(kind=8) :: etot(max_part)

    real(kind=8) :: mass(max_part)
    integer(kind=4) :: aa(max_part)
    integer(kind=4) :: zz(max_part)
    integer(kind=2) :: qq(max_part)
    integer(kind=4) :: pdg_id(max_part)
    integer(kind=4) :: partID(max_part)
    integer(kind=4) :: parentID(max_part)
    real(kind=8) :: partWeight(max_part)
    real(kind=8) :: spinx(max_part)
    real(kind=8) :: spiny(max_part)
    real(kind=8) :: spinz(max_part)

    ! Fluka I/O parameters
    integer(kind=4) :: flid, flgen
    real(kind=8)    :: flwgt, flx, fly, flz, flxp, flyp, flzp, flet, flm, flt
    integer(kind=4) :: flaa, flzz
    integer(kind=2) :: flq
    integer(kind=1) :: mtype

    integer(kind=4) :: flpdgid
    real(kind=8)    :: flsx, flsy, flsz

    ! Auxiliary variables
    integer(kind=4) :: n, j

    fluka_receive = 0
    fluka_last_sent_mess = -1

    fluka_nrecv = 0
    mtype = 0

    ! assign default values
    do j = 1, npart
        partID(j) = j
        parentID(j) = j

        partWeight(j) = one

        xv1 (j) = zero
        xv2 (j) = zero
        yv1 (j) = zero
        yv2 (j) = zero
        etot(j) = zero
        s   (j) = zero
        ! hisix: we should also parse m0,A0,Z0
        aa  (j) = 1
        zz  (j) = 1
        mass(j) = zero
        qq  (j) = 1
        pdg_id(j) = 0
        spinx = zero
        spiny = zero
        spinz = zero
    end do

    ! Wait until end of turn (Synchronize)
    do while(mtype.ne.FLUKA_EOB)
        n = ntwait(fluka_cid, mtype, &
              flid, flgen, flwgt, &
              flx, fly, flz, &
              flxp, flyp, flzp, &
              flm, flet, flt, &
              flpdgid, flq, flsx, flsy, flsz)
        if(n.lt.0) then
            write(lout,*) "FlukaIO> ERROR (return code ", n ,") - Server timed out while waiting for message"
            fluka_cid = -1
            fluka_receive = n
            return
        end if

        if(mtype.eq.FLUKA_PART) then

            fluka_nrecv = fluka_nrecv + 1
            fluka_last_rcvd_mess = FLUKA_PART

            if(fluka_nrecv .gt. npart) then
                write(lout,*) 'FlukaIO> ERROR - HIT END OF PARTICLE ARRAY'
                return
            end if

            call CalculateAZ(flpdgid, flaa, flzz)

            if(fluka_debug_level > 2) then
                write(unit_pyfluka,*) "    Received particle: ", flid, flgen, flwgt, flx, fly, flz, flxp, flyp, flzp, flm, flet, flt
                write(unit_pyfluka,*) flsx, flsy, flsz, flaa, flzz, flq, flpdgid
                flush(unit_pyfluka)
            end if

            partID(fluka_nrecv)      = flid
            parentID(fluka_nrecv)    = flgen
            if (partID(fluka_nrecv).gt.MaximumPartID) then
                MaximumPartID = partID(fluka_nrecv)
            end if

            partWeight(fluka_nrecv)  = flwgt
            xv1(fluka_nrecv)         = flx * c1e1   ! from [cm]  to [mm]
            xv2(fluka_nrecv)         = fly * c1e1   ! from [cm]  to [mm]
            yv1(fluka_nrecv)         = flxp * c1e3 ! from director cosine to x' [1.0E-03]
            yv2(fluka_nrecv)         = flyp * c1e3 ! from director cosine to x' [1.0E-03]
            etot(fluka_nrecv)         = flet * c1e3  ! from [GeV] to [MeV]
            s(fluka_nrecv)            = ( el - (fluka_pc0/fluka_e0)*(flt*fluka_clight) ) * c1e3 ! from [s] to [mm]
            aa(fluka_nrecv)           = flaa          !PH for hiSix
            zz(fluka_nrecv)           = flzz          !PH for hiSix
            mass(fluka_nrecv)         = flm  * c1e3  ! from [GeV] to [MeV]         !PH for hiSix
            qq(fluka_nrecv)           = flq
            pdg_id(fluka_nrecv)       = flpdgid
            spinx(fluka_nrecv)        = flsx
            spiny(fluka_nrecv)        = flsy
            spinz(fluka_nrecv)        = flsz

    !       The conversion is now done inside the coupling server
    !       call GetPDGid_fromFLUKA(-2, pdg_id(fluka_nrecv), flaa, flzz)
        end if

      !Finished waiting end of turn
    end do

    napx = fluka_nrecv
    fluka_last_rcvd_mess = FLUKA_EOB

    if(fluka_debug_level > 1) then
        write(unit_pyfluka,*) "FlukaIO> turn = ", turn, " ipt = ", ipt, " sent = ", fluka_nsent, &
                      " received = ", fluka_nrecv, " max_uid = ", MaximumPartID
        flush(unit_pyfluka)
    end if

  end function fluka_receive

  !----------------------------------------------------------------------------
  ! compact ancillary tracking arrays
  subroutine fluka_shuffleLostParticles(tnapx, j)

    integer, intent(in) :: tnapx
    integer, intent(in) :: j

    if(fluka_debug_level > 1) then
      write(unit_pyfluka, *) 'FLUKA> fluka_shuffleLostParticles called with napx (lnapx for SixTrack) = ', tnapx, ', j = ', j
      flush(unit_pyfluka)
    end if

  end subroutine fluka_shuffleLostParticles

  !----------------------------------------------------------------------------
  ! set reference particle properties (mainly for longitudinal dynamics)
  integer function fluka_set_synch_part( e0, pc0, mass0, a0, z0, q0 )
    implicit none

    ! interface variables
    real(kind=8) :: e0, pc0, mass0
    integer(kind=4) :: a0, z0, q0

    ! Auxiliary variables
    integer(kind=4) :: n

    fluka_set_synch_part = 0

    fluka_e0    = e0    *c1m3 ! from  [MeV]    to [GeV]
    fluka_pc0   = pc0   *c1m3 ! from  [MeV/c]  to [GeV/c]
    fluka_mass0 = mass0 *c1m3 ! from  [MeV/c2] to [GeV/c2]
    fluka_a0 = a0
    fluka_z0 = z0
    fluka_chrg0 = q0

    ! update magnetic rigidity, unless division by clight and 10^-9
    fluka_brho0 = fluka_pc0 / real(fluka_chrg0,real64)

    if(fluka_debug_level > 1) then
        write(unit_pyfluka,*) '    - total en        [GeV]:',fluka_e0
        write(unit_pyfluka,*) '    - momentum      [GeV/c]:',fluka_pc0
        write(unit_pyfluka,*) '    - mass         [GeV/c2]:',fluka_mass0
        write(unit_pyfluka,*) '    - A mass number      []:',fluka_a0
        write(unit_pyfluka,*) '    - Z number           []:',fluka_z0
        write(unit_pyfluka,*) '    - charge state      [e]:',fluka_chrg0
        write(unit_pyfluka,*) '    - rigidity     [Tm/0.3]:', fluka_brho0
        write(unit_pyfluka,*) '      in proper units  [Tm]:', fluka_brho0 / ( fluka_clight*c1m9 )
        flush(unit_pyfluka)
    end if

    ! inform Fluka about the new magnetic rigidity
    ! This step cannot be skipped!!!
    ! The fluka server is waiting for this message, so that BRHONO can be set.
    n = ntsendbrhono(fluka_cid, fluka_brho0)
    if (n .lt. 0) then
      fluka_set_synch_part = -1
      return
    end if

  end function fluka_set_synch_part

  !----------------------------------------------------------------------------
  ! set max ID
  integer function fluka_init_max_uid( npart )

    use mod_common_main, only : MaximumPartID

    implicit none

    ! interface variables
    integer(kind=4) :: npart

    ! Auxiliary variables
    integer(kind=4) :: n

    fluka_init_max_uid = 0

    MaximumPartID = npart

    n = ntsendnpart(fluka_cid, npart)
    if (n .lt. 0) then
      fluka_init_max_uid = -1
      return
    end if

  end function fluka_init_max_uid


  !----------------------------------------------------------------------------
  ! check if fluka is running, ie if it created the
  integer function fluka_is_running()
    use mod_units, only : units_resolve_path
    implicit none

    ! temporary variables
    logical :: lexist

    fluka_is_running = 0
    inquire(file=units_resolve_path(fluka_net_nfo_file), exist=lexist)

    if (.not.lexist) then
       write(lout,*) 'FLUKA> ERROR File containing network infos ', fluka_net_nfo_file, ' does not exist!!'
       flush(lout)
       fluka_is_running = -1
    endif

  end function fluka_is_running

!     A.Mereghetti and D.Sinuela Pastor, for the FLUKA Team
!     last modified: 17-07-2013
!     clean closure of communication with fluka and un-set mod_fluka
!     inserted in main code by the 'fluka' compilation flag
subroutine fluka_close

     use crcoall

     implicit none

     integer fluka_con

     if(fluka_debug_level > 0) then
         write(unit_pyfluka,'(A)') 'FLUKA> Call to fluka_close'
         flush(unit_pyfluka)
     end if
     if (fluka_enable) then
       if (fluka_last_sent_mess==FLUKA_EOB .and. fluka_last_rcvd_mess.eq.-1) then
         ! FLUKA is still crunching stuff
         if(fluka_debug_level > 0) then
             write(unit_pyfluka,'(A)') 'FLUKA> fluka_close called while particles are still on the Fluka side'
             write(unit_pyfluka,'(A)') 'FLUKA>    dummy wait to have a clean closure'
             flush(unit_pyfluka)
         end if
       end if
       fluka_con = fluka_is_running()
       if(fluka_con.eq.0) then
         if( .not. fluka_connected ) then
!              temporarily connect to fluka, to properly terminate the run
           fluka_con = fluka_connect(3600)
           if(fluka_con.lt.0) then
!                no hope to properly close the run
             write(lout,'(A)') 'FLUKA> ERROR Unable to connect to fluka while closing the simulation:'
             write(lout,'(A)') 'FLUKA>       please, manually kill all its instances'
             flush(lout)
             goto 1982
           endif
           if(fluka_debug_level > 0) then
               write(unit_pyfluka,'(A)') 'FLUKA> Successfully connected to Fluka server (only temporarily)'
               flush(unit_pyfluka)
           end if
         end if
         call fluka_end
       end if
     end if
1982 call fluka_mod_end
     flush(lout)
     if (unit_pyfluka /= -1) then
      close(unit_pyfluka)
      unit_pyfluka = -1
    end if
end subroutine fluka_close

end module mod_fluka

! ================================================================================================ !
!  Collimation Jaw Fit Module
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-08-01
!  Updated: 2019-09-10
! ================================================================================================ !
module coll_jawfit

  use floatPrecision
  use numerical_constants, only : zero, one

  implicit none

  integer, public, parameter :: jaw_fitNameLen = 16

  type, private :: type_fitParams
    character(len=jaw_fitNameLen) :: fitName                ! Fit name
    real(kind=fPrec)              :: fitParams(6) = zero    ! Fit parameters
  end type type_fitParams

  type, private :: type_sliceParams
    integer                       :: nSlices      = 0       ! The number of slices
    real(kind=fPrec)              :: fitLength    = zero    ! Slice length
    real(kind=fPrec), allocatable :: fitData(:,:)           ! Slice data
    real(kind=fPrec), allocatable :: fitTilt(:,:)           ! Slice tilt
  end type type_sliceParams

  type(type_fitParams),   allocatable, private, save :: jaw_fitData(:)     ! List of jaw fit parameters
  type(type_sliceParams), allocatable, private, save :: jaw_sliceData(:)   ! List of collimator fit slices
  integer,                             private, save :: jaw_nFitData   = 0 ! Count of jaw_fitData
  integer,                             private, save :: jaw_nSliceData = 0 ! Count of jaw_sliceData

contains

! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-08-01
!  Updated: 2019-09-10
!  Add a jaw fit model to the storage
! ================================================================================================ !
subroutine jaw_addJawFit(fitName, fitParams, fitID, fErr)

  use crcoall

  character(len=*), intent(in)    :: fitName
  real(kind=fPrec), intent(in)    :: fitParams(6)
  integer,          intent(out)   :: fitID
  logical,          intent(inout) :: fErr

  type(type_fitParams), allocatable :: jawTmp(:)

  if(allocated(jaw_fitData)) then
    allocate(jawTmp(jaw_nFitData+1))
    jawTmp(1:jaw_nFitData) = jaw_fitData(1:jaw_nFitData)
    call move_alloc(jawTmp, jaw_fitData)
    jaw_nFitData = jaw_nFitData + 1
  else
    allocate(jaw_fitData(1))
    jaw_nFitData = 1
  end if

  fitID = jaw_getFitID(fitName)
  if(fitID /= -1) then
    write(lerr,"(a)") "COLLJAW> ERROR Duplicate jaw fit name '"//trim(fitName)//"'"
    fErr = .true.
    return
  end if

  jaw_fitData(jaw_nFitData)%fitName   = fitName
  jaw_fitData(jaw_nFitData)%fitParams = fitParams

  fitID = jaw_nFitData

  write(lout,"(a)") "COLLJAW> Added jaw fit profile '"//trim(fitName)//"'"

end subroutine jaw_addJawFit

! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-08-01
!  Updated: 2019-09-10
!  Compute the fit parameters for a given collimator using a stored fit model.
!  Most of the fit code was extracted from the main collimation module.
!  Original comments from original authors have been preserved.
! ================================================================================================ !
subroutine jaw_computeFit(collName, fitID, nSlices, fitScale, reCentre, cLength, cTilt, cOffset, sliceID)

  use crcoall
  use mathlib_bouncer
  use numerical_constants

  character(len=*), intent(in)  :: collName
  integer,          intent(in)  :: fitID(2)
  integer,          intent(in)  :: nSlices
  real(kind=fPrec), intent(in)  :: fitScale(2)
  logical,          intent(in)  :: reCentre(2)
  real(kind=fPrec), intent(in)  :: cLength
  real(kind=fPrec), intent(in)  :: cTilt(2)
  real(kind=fPrec), intent(in)  :: cOffset
  integer,          intent(out) :: sliceID

  type(type_sliceParams), allocatable :: collTmp(:)
  real(kind=fPrec) sX(nSlices+1), sX1(nSlices+1), sX2(nSlices+1), sY1(nSlices+1), sY2(nSlices+1)
  real(kind=fPrec) angle1(nSlices), angle2(nSlices)
  real(kind=fPrec) fac1(6), fac2(6), scale1, scale2
  real(kind=fPrec) fitData(2,nSlices+1), fitTilt(2,nSlices)
  integer i

  if(allocated(jaw_sliceData)) then
    allocate(collTmp(jaw_nSliceData+1))
    collTmp(1:jaw_nSliceData) = jaw_sliceData(1:jaw_nSliceData)
    call move_alloc(collTmp, jaw_sliceData)
    jaw_nSliceData = jaw_nSliceData + 1
  else
    allocate(jaw_sliceData(1))
    jaw_nSliceData = 1
  end if

  fac1   = jaw_fitData(fitID(1))%fitParams
  fac2   = jaw_fitData(fitID(2))%fitParams
  scale1 = fitScale(1)
  scale2 = fitScale(2)

  sX(:)  = zero
  sX1(:) = zero
  sX2(:) = zero
  sY1(:) = zero
  sY2(:) = zero

  ! Calculate longitudinal positions of slices and corresponding heights and angles from the fit parameters.
  ! Note: here, take (nSlices+1) points in order to calculate the tilt angle of the last slice!

  do i=1,nSlices+1
    ! Deformation of the jaws scaled with length
    sX(i)  = (real(i-1,fPrec)*cLength)/real(nSlices,fPrec)
    sY1(i) = ((((fac1(1) + fac1(2)*sX(i)) + (fac1(3)/cLength)*sX(i)**2) + fac1(4)*sX(i)**3) + fac1(5)*sX(i)**4) + fac1(6)*sX(i)**5
    sY2(i) = ((((fac2(1) + fac2(2)*sX(i)) + (fac2(3)/cLength)*sX(i)**2) + fac2(4)*sX(i)**3) + fac2(5)*sX(i)**4) + fac2(6)*sX(i)**5

    ! Apply the slicing scaling factors
    sY1(i) =       scale1 * sY1(i)
    sY2(i) = -one*(scale2 * sY2(i))

    ! Coordinates rotated of the tilt
    sX1(i) =  sX(i)*cos_mb(cTilt(1)) - sY1(i)*sin_mb(cTilt(1))
    sX2(i) =  sX(i)*cos_mb(cTilt(2)) - sY2(i)*sin_mb(cTilt(2))
    sY1(i) = sY1(i)*cos_mb(cTilt(1)) +  sX(i)*sin_mb(cTilt(1))
    sY2(i) = sY2(i)*cos_mb(cTilt(2)) +  sX(i)*sin_mb(cTilt(2))
  end do

  do i=1,nSlices
    ! Sign of the angle defined differently for the two jaws
    angle1(i) = ((sY1(i+1) - sY1(i)) / (sX1(i+1)-sX1(i)))
    angle2(i) = ((sY2(i+1) - sY2(i)) / (sX2(i+1)-sX2(i)))
  end do

  ! For both jaws, look for the 'deepest' point (closest point to beam)
  ! Then, shift the vectors such that this closest point defines the nominal aperture
  ! Index here must go up to (nSlices+1) in case the last point is the
  ! closest (and also for the later calculation of 'a_tmp1' and 'a_tmp2')
  ! The recentring flag, as given in 'fort.3' chooses whether we recentre the deepest point or not
  if(reCentre(1)) then
    sY1 = sY1 - minval(sY1)
  end if
  if(reCentre(2)) then
    sY2 = sY2 - maxval(sY2)
  end if

  fitData(1,:) = sY1(:)
  fitData(2,:) = sY2(:)
  fitTilt(1,:) = angle1(:)
  fitTilt(2,:) = angle2(:)

  jaw_sliceData(jaw_nSliceData)%nSlices   = nSlices
  jaw_sliceData(jaw_nSliceData)%fitLength = cLength/real(nSlices,fPrec)
  jaw_sliceData(jaw_nSliceData)%fitData   = fitData
  jaw_sliceData(jaw_nSliceData)%fitTilt   = fitTilt

  sliceID = jaw_nSliceData

  write(lout,"(a,i0,a)") "COLLJAW> Collimator '"//trim(collName)//"' sliced in ",nSlices," slices"

end subroutine jaw_computeFit

! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-08-01
!  Updated: 2019-08-02
!  Return the adjusted length, aperture and offset for a specific collimator slice
! ================================================================================================ !
subroutine jaw_getFitSliceValues(sliceID, iSlice, cLength, cAperture, cOffset, cTilt)

  use numerical_constants

  integer,          intent(in)    :: sliceID
  integer,          intent(in)    :: iSlice
  real(kind=fPrec), intent(out)   :: cLength
  real(kind=fPrec), intent(inout) :: cAperture
  real(kind=fPrec), intent(inout) :: cOffset
  real(kind=fPrec), intent(out)   :: cTilt(2)

  real(kind=fPrec) val1, val2

  cLength  = jaw_sliceData(sliceID)%fitLength
  cTilt(:) = jaw_sliceData(sliceID)%fitTilt(:,iSlice)

  if(cTilt(1) > zero) then
    val1 = jaw_sliceData(sliceID)%fitData(1,iSlice)
  else
    val1 = jaw_sliceData(sliceID)%fitData(1,iSlice+1)
  end if

  if(cTilt(2) < zero) then
    val2 = jaw_sliceData(sliceID)%fitData(2,iSlice)
  else
    val2 = jaw_sliceData(sliceID)%fitData(2,iSlice+1)
  end if

  val1 = val1 + half*cAperture
  val2 = val2 - half*cAperture

  cAperture = val1 - val2
  cOffset   = half*(val1 + val2) + cOffset

end subroutine jaw_getFitSliceValues

! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-08-01
!  Updated: 2019-09-10
!  Return the number of slices for a given jaw fit
! ================================================================================================ !
integer function jaw_getSliceCount(sliceID)
  integer, intent(in) :: sliceID
  if(sliceID < 1 .or. sliceID > jaw_nSliceData) then ! Invalid index
    jaw_getSliceCount = -1
    return
  end if
  jaw_getSliceCount = jaw_sliceData(sliceID)%nSlices
end function jaw_getSliceCount

! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-09-10
!  Updated: 2019-09-10
!  Return the index of a fit by name
! ================================================================================================ !
integer function jaw_getFitID(fitName)

  character(len=*), intent(in) :: fitName

  integer i, fitID

  fitID = -1
  do i=1,jaw_nFitData
    if(jaw_fitData(i)%fitName == fitName) then
      fitID = i
      exit
    end if
  end do
  jaw_getFitID = fitID

end function jaw_getFitID

end module coll_jawfit

subroutine pyk2_init(n_alloc, random_generator_seed)
  !use parpro ,           only : npart
  use mod_alloc ,        only : alloc      ! to allocate partID etc
  use mod_common ,       only : iexact, napx, unit208, aa0
  use mod_common_main ,  only : partID, parentID, pairID, naa
  use mod_ranlux ,       only : rluxgo     ! for ranlux init

  use coll_common ,      only : rnd_seed, rcx, rcxp, rcy, rcyp, rcp, rcs, &
                                coll_expandArrays
  !use coll_crystal

  implicit none

  integer, intent(in)          :: n_alloc
  integer, intent(in)          :: random_generator_seed

  rnd_seed = random_generator_seed

  ! Initialize random number generator
  !if(rnd_seed == 0) rnd_seed = time_getSysClock()
  if(rnd_seed <  0) rnd_seed = abs(rnd_seed)
  call rluxgo(3, rnd_seed, 0, 0)

  call coll_expandArrays(n_alloc)
  call alloc(naa, n_alloc, aa0, "naa")
  call alloc(partID, n_alloc, 0, "partID")
  call alloc(parentID, n_alloc, 0, "parentID")
  call alloc(pairID, 2, n_alloc, 0, "pairID")

end subroutine
 
subroutine pyk2_run(num_particles, x_particles, xp_particles, &
                y_particles, yp_particles, s_particles, &
                p_particles, part_hit, &
                part_abs, part_impact, &
                part_indiv, part_linteract, nhit_stage, nabs_type, linside, &
                run_exenergy, run_anuc, run_zatom, run_emr, run_rho, &
                run_hcut, run_bnref, run_csref0, run_csref1, &
                run_csref5, run_radl, run_dlri, run_dlyi, run_eum, run_ai, &
                run_collnt, &
                is_crystal, c_length, c_rotation, c_aperture, c_offset, &
                c_tilt, c_enom, onesided)

  use floatPrecision
  use numerical_constants

  use parpro ,           only : npart
  use mod_alloc ,        only : alloc      ! to allocate partID etc
  use mod_common ,       only : iexact, napx, unit208, aa0
  use mod_common_main ,  only : partID, parentID, pairID, naa
  use mod_ranlux ,       only : rluxgo     ! for ranlux init

  use coll_common ,      only : rnd_seed, rcx, rcxp, rcy, rcyp, rcp, rcs, coll_expandArrays
  use coll_k2 ,          only : k2coll_collimate        ! for scattering

  implicit none


  ! ############################
  ! ## variables declarations ##
  ! ############################

  integer,         intent(in)    :: num_particles
  real(kind=8),    intent(inout) :: x_particles(num_particles)
  real(kind=8),    intent(inout) :: xp_particles(num_particles)
  real(kind=8),    intent(inout) :: y_particles(num_particles)
  real(kind=8),    intent(inout) :: yp_particles(num_particles)
  real(kind=8),    intent(inout) :: s_particles(num_particles)
  real(kind=8),    intent(inout) :: p_particles(num_particles)

  integer(kind=4), intent(inout) :: part_hit(num_particles)
  integer(kind=4), intent(inout) :: part_abs(num_particles)
  real(kind=8),    intent(inout) :: part_impact(num_particles)
  real(kind=8),    intent(inout) :: part_indiv(num_particles)
  real(kind=8),    intent(inout) :: part_linteract(num_particles)
  integer(kind=4), intent(inout) :: nhit_stage(num_particles)
  integer(kind=4), intent(inout) :: nabs_type(num_particles)
  logical(kind=4), intent(inout) :: linside(num_particles)
  real(kind=8),    intent(in)    :: run_exenergy
  real(kind=8),    intent(in)    :: run_anuc
  real(kind=8),    intent(in)    :: run_zatom
  real(kind=8),    intent(in)    :: run_emr
  real(kind=8),    intent(in)    :: run_rho
  real(kind=8),    intent(in)    :: run_hcut
  real(kind=8),    intent(in)    :: run_bnref
  real(kind=8),    intent(in)    :: run_csref0
  real(kind=8),    intent(in)    :: run_csref1
  real(kind=8),    intent(in)    :: run_csref5
  real(kind=8),    intent(in)    :: run_radl
  real(kind=8),    intent(in)    :: run_dlri
  real(kind=8),    intent(in)    :: run_dlyi
  real(kind=8),    intent(in)    :: run_eum
  real(kind=8),    intent(in)    :: run_ai
  real(kind=8),    intent(in)    :: run_collnt
  logical(kind=4), intent(in)    :: is_crystal
  real(kind=8),    intent(in)    :: c_length
  real(kind=8),    intent(in)    :: c_rotation
  real(kind=8),    intent(in)    :: c_aperture
  real(kind=8),    intent(in)    :: c_offset
  real(kind=8),    intent(inout) :: c_tilt(2)
  real(kind=8),    intent(in)    :: c_enom
  logical(kind=4), intent(in)    :: onesided
  integer j



  ! ####################
  ! ## initialisation ##
  ! ####################
  !character(len=:),    allocatable   :: numpart
  !numpart="20000"
  !read(numpart,*) napx
  npart=num_particles

  do j=1,npart
    naa(j) = aa0
    partID(j)   = j
    parentID(j) = j
    pairID(1,j) = (j+1)/2    ! The pairID of particle j
    pairID(2,j) = 2-mod(j,2) ! Either particle 1 or 2 of the pair
  end do
  
  napx=npart  ! this decreases after absorptions!
  unit208=109

  do j=1,npart
    rcx(j) = x_particles(j)
    rcxp(j) = xp_particles(j)
    rcy(j) = y_particles(j)
    rcyp(j) = yp_particles(j)
    rcs(j) = s_particles(j)
    rcp(j) = p_particles(j)
  end do

  call k2coll_collimate( &
     run_exenergy, run_anuc, run_zatom, run_emr, run_rho, &
     run_hcut, run_bnref, run_csref0, run_csref1, &
     run_csref5, run_radl, run_dlri, run_dlyi, run_eum, run_ai, &
     run_collnt, &
     is_crystal, c_length, c_rotation, c_aperture, c_offset, c_tilt, &
     rcx, rcxp, rcy, rcyp, rcp, rcs, &
     c_enom*c1m3, part_hit, part_abs, &
     part_impact, part_indiv, part_linteract, &
     onesided, nhit_stage, 1, nabs_type, linside)

  do j=1,npart
     x_particles(j) = rcx(j)
     xp_particles(j) = rcxp(j)
     y_particles(j) = rcy(j)
     yp_particles(j) = rcyp(j)
     s_particles(j) = rcs(j)
     p_particles(j) = rcp(j)
  end do
end subroutine 


subroutine pyk2_startcry(c_length, new_length, c_rotation, cryTilt, cryBend, cryThick, cryXDim, &
                         cryYDim, cryOrient, cryMiscut)
  use coll_crystal, only: cry_startElement

  real(kind=8), intent(in)    :: c_length     ! Collimator length in m
  real(kind=8), intent(inout) :: new_length
  real(kind=8), intent(in)    :: c_rotation   ! Collimator rotation angle vs vertical in radians
  real(kind=8), intent(in)    :: cryTilt
  real(kind=8), intent(in)    :: cryBend
  real(kind=8), intent(in)    :: cryThick
  real(kind=8), intent(in)    :: cryXDim
  real(kind=8), intent(in)    :: cryYDim
  real(kind=8), intent(in)    :: cryOrient
  real(kind=8), intent(in)    :: cryMiscut
  
  call cry_startElement(c_length, new_length, c_rotation, cryTilt, cryBend, cryThick, cryXDim, &
                        cryYDim, cryOrient, cryMiscut)
end subroutine

! ================================================================================================ !
!  Collimation Common Variables
! ================================================================================================ !
module coll_common

  use floatPrecision
  use numerical_constants, only : zero

  implicit none

  ! Logical Flags
  logical, save :: coll_debug         = .true.
  logical, save :: dowrite_impact     = .false.
  logical, save :: dowrite_dist       = .false.
  logical, save :: dowrite_secondary  = .false.
  logical, save :: dowrite_amplitude  = .false.
  logical, save :: dowrite_tracks     = .false.
  logical, save :: dowrite_efficiency = .false.
  logical, save :: dowrite_crycoord   = .false.
  logical, save :: coll_hasCrystal    = .false.

  ! Various Variables
  integer, save :: rnd_seed   = 0

  ! Collimation Particle Arrays
  real(kind=fPrec), allocatable, save :: rcx(:)
  real(kind=fPrec), allocatable, save :: rcxp(:)
  real(kind=fPrec), allocatable, save :: rcy(:)
  real(kind=fPrec), allocatable, save :: rcyp(:)
  real(kind=fPrec), allocatable, save :: rcp(:)
  real(kind=fPrec), allocatable, save :: rcs(:)

  ! Process index for interaction with crystals
  integer, allocatable, save :: cry_proc(:)
  integer, allocatable, save :: cry_proc_prev(:)
  integer, allocatable, save :: cry_proc_tmp(:)

  ! Pencil Beam
  integer,          save :: ipencil       = 0
  integer,          save :: pencil_distr  = 0
  real(kind=fPrec), save :: pencil_offset = zero
  real(kind=fPrec), save :: pencil_rmsx   = zero
  real(kind=fPrec), save :: pencil_rmsy   = zero
  real(kind=fPrec), save :: xp_pencil0    = zero
  real(kind=fPrec), save :: yp_pencil0    = zero
  real(kind=fPrec), allocatable, save :: x_pencil(:)
  real(kind=fPrec), allocatable, save :: y_pencil(:)
  real(kind=fPrec), allocatable, save :: xp_pencil(:)
  real(kind=fPrec), allocatable, save :: yp_pencil(:)
  real(kind=fPrec), allocatable, save :: pencil_dx(:)

  ! Other Arrays
  integer,          allocatable, save :: cn_impact(:)
  integer,          allocatable, save :: cn_absorbed(:)
  real(kind=fPrec), allocatable, save :: caverage(:)
  real(kind=fPrec), allocatable, save :: csigma(:)
  real(kind=fPrec), allocatable, save :: gap_rms_error(:)
  real(kind=fPrec), allocatable, save :: csum(:)
  real(kind=fPrec), allocatable, save :: csqsum(:)

  ! Output File Names
  character(len=12), parameter :: coll_survivalFile   = "survival.dat"
  character(len=12), parameter :: coll_gapsFile       = "collgaps.dat"
  character(len=10), parameter :: coll_impactFile     = "impact.dat"
  character(len=11), parameter :: coll_tracksFile     = "tracks2.dat"
  character(len=17), parameter :: coll_positionsFile  = "CollPositions.dat"
  character(len=20), parameter :: coll_pencilFile     = "pencilbeam_distr.dat"
  character(len=16), parameter :: coll_ellipseFile    = "coll_ellipse.dat"
  character(len=15), parameter :: coll_allImpactFile  = "all_impacts.dat"
  character(len=19), parameter :: coll_allAbsorbFile  = "all_absorptions.dat"
  character(len=16), parameter :: coll_scatterFile    = "Coll_Scatter.dat"
  character(len=16), parameter :: coll_fstImpactFile  = "FirstImpacts.dat"
  character(len=17), parameter :: coll_flukImpFile    = "FLUKA_impacts.dat"
  character(len=21), parameter :: coll_flukImpAllFile = "FLUKA_impacts_all.dat"
  character(len=17), parameter :: coll_sigmaSetFile   = "sigmasettings.out"
  character(len=16), parameter :: coll_settingsFile   = "collsettings.dat"
  character(len=16), parameter :: coll_jawProfileFile = "jaw_profiles.dat"
  character(len=13), parameter :: coll_ampFile        = "amplitude.dat"
  character(len=17), parameter :: coll_orbitCheckFile = "orbitchecking.dat"
  character(len=16), parameter :: coll_summaryFile    = "coll_summary.dat"
  character(len=14), parameter :: coll_efficFile      = "efficiency.dat"
  character(len=19), parameter :: coll_efficDPFile    = "efficiency_dpop.dat"
  character(len=17), parameter :: coll_effic2DFile    = "efficiency_2d.dat"
  character(len=16), parameter :: coll_cryEntFile     = "cry_entrance.dat"
  character(len=12), parameter :: coll_cryExitFile    = "cry_exit.dat"
  character(len=19), parameter :: coll_cryInterFile   = "cry_interaction.dat"

  ! Output File Units
  integer, save :: outlun              = -1
  integer, save :: coll_survivalUnit   = -1
  integer, save :: coll_gapsUnit       = -1
  integer, save :: coll_impactUnit     = -1
  integer, save :: coll_tracksUnit     = -1
  integer, save :: coll_positionsUnit  = -1
  integer, save :: coll_pencilUnit     = -1
  integer, save :: coll_ellipseUnit    = -1
  integer, save :: coll_allImpactUnit  = -1
  integer, save :: coll_allAbsorbUnit  = -1
  integer, save :: coll_scatterUnit    = -1
  integer, save :: coll_fstImpactUnit  = -1
  integer, save :: coll_flukImpUnit    = -1
  integer, save :: coll_flukImpAllUnit = -1
  integer, save :: coll_sigmaSetUnit   = -1
  integer, save :: coll_settingsUnit   = -1
  integer, save :: coll_jawProfileUnit = -1
  integer, save :: coll_ampUnit        = -1
  integer, save :: coll_orbitCheckUnit = -1
  integer, save :: coll_summaryUnit    = -1
  integer, save :: coll_efficUnit      = -1
  integer, save :: coll_efficDPUnit    = -1
  integer, save :: coll_effic2DUnit    = -1
  integer, save :: coll_cryEntUnit     = -1
  integer, save :: coll_cryExitUnit    = -1
  integer, save :: coll_cryInterUnit   = -1



contains

subroutine coll_expandArrays(npart_new)

  use mod_alloc
  use numerical_constants

  integer, intent(in) :: npart_new

  call alloc(rcx,  npart_new, zero, "rcx")
  call alloc(rcxp, npart_new, zero, "rcxp")
  call alloc(rcy,  npart_new, zero, "rcy")
  call alloc(rcyp, npart_new, zero, "rcyp")
  call alloc(rcp,  npart_new, zero, "rcp")
  call alloc(rcs,  npart_new, zero, "rcs")

  call alloc(cry_proc, npart_new, -1, "cry_proc")
  call alloc(cry_proc_prev, npart_new, -1, "cry_proc_prev")
  call alloc(cry_proc_tmp, npart_new, -1, "cry_proc_tmp")

end subroutine coll_expandArrays

subroutine coll_expandNColl(nColl)

  use mod_alloc
  use numerical_constants

  integer, intent(in) :: nColl

  call alloc(cn_impact,     nColl, 0,    "cn_impact")
  call alloc(cn_absorbed,   nColl, 0,    "cn_absorbed")
  call alloc(caverage,      nColl, zero, "caverage")
  call alloc(csigma,        nColl, zero, "csigma")
  call alloc(gap_rms_error, nColl, zero, "gap_rms_error")
  call alloc(csum,          nColl, zero, "csum")
  call alloc(csqsum,        nColl, zero, "csqsum")
  call alloc(x_pencil,      nColl, zero, "x_pencil")
  call alloc(y_pencil,      nColl, zero, "y_pencil")
  call alloc(xp_pencil,     nColl, zero, "xp_pencil")
  call alloc(yp_pencil,     nColl, zero, "yp_pencil")
  call alloc(pencil_dx,     nColl, zero, "pencil_dx")

end subroutine coll_expandNColl

end module coll_common

! ================================================================================================ !
!  Collimator Material Variables
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!  Cross section inputs and material property database
! ================================================================================================ !
module coll_materials

  use floatPrecision
  use numerical_constants, only : zero, one, c1e10

  implicit none

  !integer, parameter :: nmat  = 16 ! Total number of materials
  !integer, parameter :: nrmat = 14 ! Number of real materials

  ! pp cross-sections and parameters for energy dependence
  real(kind=fPrec), parameter :: pptref = 0.04_fPrec
  real(kind=fPrec), parameter :: freeco = 1.618_fPrec

  ! Collimator Material Arrays
  !character(4),     public, save :: colmats(nmat)   ! Material Names
  !real(kind=fPrec), public, save :: exenergy(nmat)  ! Mean excitation energy [GeV]
  !real(kind=fPrec), public, save :: anuc(nmat)      ! Atomic mass
  !real(kind=fPrec), public, save :: zatom(nmat)     ! Atomic Z
  !real(kind=fPrec), public, save :: rho(nmat)       ! Density
  !real(kind=fPrec), public, save :: emr(nmat)       ! Nuclear radius
  !real(kind=fPrec), public, save :: hcut(nmat)      ! T cut (upper)
  !real(kind=fPrec), public, save :: radl(nmat)      ! Remaining length
  !real(kind=fPrec), public, save :: bnref(nmat)     ! Nuclear elastic slope from Schiz et al., PRD 21(3010)1980
  real(kind=fPrec), public, save :: csect(0:5) ! Cross section
  real(kind=fPrec), public, save :: xintl     ! Interaction length
  real(kind=fPrec), public, save :: bn        ! Nuclear elastic related
  real(kind=fPrec), public, save :: freep     ! Number of nucleons involved in single scattering
  real(kind=fPrec), public, save :: cgen(200)  ! Used by FUNLUX / Rutherford routine

  ! All cross-sections are in barns. Nuclear values from RPP at 20 GeV
  ! Coulomb is integerated above t=tLcut[Gev2] (+-1% out Gauss mcs)

  ! In Cs and CsRef,1st index: Cross-sections for processes
  ! 0:Total, 1:absorption, 2:nuclear elastic, 3:pp or pn elastic
  ! 4:Single Diffractive pp or pn, 5:Coulomb for t above mcs

  ! Claudia 2013: updated cross section values. Unit: Barn. New 2013:
  !real(kind=fPrec), public, parameter :: csref(0:5,nmat) = reshape([ &
  !  [0.271_fPrec, 0.192_fPrec, zero, zero, zero, 0.0035e-2_fPrec], & ! BE
  !  [0.643_fPrec, 0.418_fPrec, zero, zero, zero, 0.0340e-2_fPrec], & ! AL
  !  [1.253_fPrec, 0.769_fPrec, zero, zero, zero, 0.1530e-2_fPrec], & ! CU
  !  [2.765_fPrec, 1.591_fPrec, zero, zero, zero, 0.7680e-2_fPrec], & ! W
  !  [3.016_fPrec, 1.724_fPrec, zero, zero, zero, 0.9070e-2_fPrec], & ! PB
  !  [0.337_fPrec, 0.232_fPrec, zero, zero, zero, 0.0076e-2_fPrec], & ! C
  !  [0.337_fPrec, 0.232_fPrec, zero, zero, zero, 0.0076e-2_fPrec], & ! C2
  !  [0.664_fPrec, 0.430_fPrec, zero, zero, zero, 0.0390e-2_fPrec], & ! Si
  !  [1.388_fPrec, 0.844_fPrec, zero, zero, zero, 0.1860e-2_fPrec], & ! Ge
  !  [0.362_fPrec, 0.247_fPrec, zero, zero, zero, 0.0094e-2_fPrec], & ! MoGR
  !  [0.572_fPrec, 0.370_fPrec, zero, zero, zero, 0.0279e-2_fPrec], & ! CuCD
  !  [1.713_fPrec, 1.023_fPrec, zero, zero, zero, 0.2650e-2_fPrec], & ! Mo
  !  [1.246_fPrec, 0.765_fPrec, zero, zero, zero, 0.1390e-2_fPrec], & ! Glid
  !  [2.548_fPrec, 1.473_fPrec, zero, zero, zero, 0.5740e-2_fPrec], & ! Iner
  !  [       zero,        zero, zero, zero, zero,            zero], & ! VA
  !  [       zero,        zero, zero, zero, zero,            zero]  & ! BL
  !], shape=[6,nmat])

  ! Cprob to choose an interaction in iChoix
  real(kind=fPrec), public, save :: cprob(0:5) = [zero, zero, zero, zero, zero, one]

  ! Electron density and plasma energy
  real(kind=fPrec), public, save :: edens = zero
  real(kind=fPrec), public, save :: pleng = zero

contains


! ================================================================================================ !
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-09-16
!  Updated: 2019-09-16
!  Get collimator material number from name (case sensitive)
! ================================================================================================ !
!integer function collmat_getCollMatID(matName)
!
!  character(len=*), intent(in) :: matName
!  integer i, matID
!
!  matID = -1
!  do i=1,nmat
!    if(colmats(i) == matName) then
!      matID = i
!      exit
!    end if
!  end do
!  collmat_getCollMatID = matID
!
!end function collmat_getCollMatID

end module coll_materials

! ================================================================================================ !
!  SixTrack String Module
! ~~~~~~~~~~~~~~~~~~~~~~~~
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last Modified: 2018-04-26
!
!  Usage
! ~~~~~~~
!  Declaration:   type(string) aString
!  Get:           aString%get()                   => Returns chracater array
!  Set:           aString%set("foo")              => Returns string
!  Assignment:    aString = "foo"                 => Returns string
!  Addition:      aString = aString + "bar"       => Returns combined string "foobar"
!  Concatenation: write(*,*) "This is "//aString  => On-the-fly conversion to character array
!  Comparison:    aString == "foobar"             => Compares a string/char to a string/char
!  Comparison:    aString /= "barfoo"             => Compares a string/char to a string/char
!  Length:        len(aString)                    => Returns string length, like intrinsic len()
!  Trim:          trim(aString)                   => Returns char array without trailing spaces
!  Adjust:        adjust[lr](aString)             => Returns char array with l/r adjustment
!  Strip:         aString%strip()                 => Returns a string without lead/trail spaces
!  Strip Zero:    aString%strip(zero=.true.)      => As above, but first cuts at first \0 character
!  Upper Case:    aString%upper()                 => Returns a string, replacing [a-z] with [A-Z]
!  Lower Case:    aString%lower()                 => Returns a string, replacing [A-Z] with [a-z]
!
!  Note: gfortran 6.x shows some unexpected behaviour when comparing char arrays and string arrays.
!        This error is not reproducible in gfortran 7, and can be avoided by comparing
!        (aString%get() == "Something") instead of (aString == "Something").
! ================================================================================================ !
module strings

  implicit none

  type, public :: string

    character(len=:), allocatable, public :: chr

  contains

    procedure, public,  pass(this)  :: get     => getStr
    procedure, public,  pass(this)  :: set     => setStr
  ! procedure, public,  pass(this)  :: len     => lenStr
  ! procedure, public,  pass(this)  :: trim    => trimStr
  ! procedure, public,  pass(this)  :: adjustl => adjLStr
  ! procedure, public,  pass(this)  :: adjustr => adjRStr
    procedure, public,  pass(this)  :: strip   => stripStr
    procedure, public,  pass(this)  :: upper   => upperStr
    procedure, public,  pass(this)  :: lower   => lowerStr

    procedure, private, pass(this)  :: getStr
    procedure, private, pass(this)  :: setStr

    procedure, private, pass(this)  :: lenStr
    procedure, private, pass(this)  :: trimStr
    procedure, private, pass(this)  :: adjLStr
    procedure, private, pass(this)  :: adjRStr
    procedure, private, pass(this)  :: lenTrimStr

    procedure, private, pass(this)  :: stripStr
    procedure, private, pass(this)  :: upperStr
    procedure, private, pass(this)  :: lowerStr

    procedure, private, pass(left)  :: assignStrStr
    procedure, private, pass(left)  :: assignStrChr
    procedure, private, pass(right) :: assignChrStr

    procedure, private, pass(left)  :: appendStrStr
    procedure, private, pass(left)  :: appendStrChr

    procedure, private, pass(left)  :: concatStrStr
    procedure, private, pass(left)  :: concatStrChr
    procedure, private, pass(right) :: concatChrStr

    procedure, private, pass(left)  :: compStrStr
    procedure, private, pass(left)  :: compStrChr
    procedure, private, pass(right) :: compChrStr

    procedure, private, pass(left)  :: compNStrStr
    procedure, private, pass(left)  :: compNStrChr
    procedure, private, pass(right) :: compNChrStr

  end type string

  interface string
    module procedure constructStr
  end interface string

  interface len
    module procedure lenStr
  end interface len

  interface trim
    module procedure trimStr
  end interface trim

  interface adjustl
    module procedure adjLStr
  end interface adjustl

  interface adjustr
    module procedure adjRStr
  end interface adjustr

  interface len_trim
    module procedure lenTrimStr
  end interface len_trim

  interface assignment(=)
    module procedure assignStrStr
    module procedure assignStrChr
    module procedure assignChrStr
  end interface

  interface operator(+)
    module procedure appendStrStr
    module procedure appendStrChr
  end interface

  interface operator(//)
    module procedure concatStrStr
    module procedure concatStrChr
    module procedure concatChrStr
  end interface

  interface operator(==)
    module procedure compStrStr
    module procedure compStrChr
    module procedure compChrStr
  end interface

  interface operator(/=)
    module procedure compNStrStr
    module procedure compNStrChr
    module procedure compNChrStr
  end interface

contains

  type(string) function constructStr()
    constructStr%chr = ""
  end function constructStr

  ! ================================================================ !
  !  Set and Get
  ! ================================================================ !
  pure function getStr(this) result(retValue)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: retValue
    retValue = this%chr
  end function getStr

  pure subroutine setStr(this, setValue)
    class(string),    intent(inout) :: this
    character(len=*), intent(in)    :: setValue
    if(allocated(this%chr)) this%chr = setValue
  end subroutine setStr

  ! ================================================================ !
  !  Standard String Information and Operations
  ! ================================================================ !
  elemental function lenStr(this) result(retValue)
    class(string), intent(in) :: this
    integer                   :: retValue
    if(allocated(this%chr)) then
      retValue = len(this%chr)
    else
      retValue = 0
    end if
  end function lenStr

  pure function trimStr(this) result(retValue)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: retValue
    if(allocated(this%chr)) then
      retValue = trim(this%chr)
    end if
  end function trimStr

  pure function adjLStr(this) result(retValue)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: retValue
    if(allocated(this%chr)) then
      retValue = adjustl(this%chr)
    end if
  end function adjLStr

  pure function adjRStr(this) result(retValue)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: retValue
    if(allocated(this%chr)) then
      retValue = adjustr(this%chr)
    end if
  end function adjRStr

  elemental function lenTrimStr(this) result(retValue)
    class(string), intent(in) :: this
    integer                   :: retValue
    if(allocated(this%chr)) then
      retValue = len_trim(this%chr)
    else
      retValue = 0
    end if
  end function lenTrimStr

  ! ================================================================ !
  !  String Manipulation
  !  Upper and Lower are based on:
  !    http://fortranwiki.org/fortran/show/String_Functions
  ! ================================================================ !
  type(string) elemental function stripStr(this, zero)
    class(string), intent(in)           :: this
    logical,       intent(in), optional :: zero
    integer i, cut
    cut = len(this%chr)
    if(present(zero)) then
      if(zero) then
        do i=1, len(this%chr)
          if(this%chr(i:i) == char(0)) then
            cut = i-1
            exit
          end if
        end do
      end if
    end if
    stripStr%chr = trim(adjustl(this%chr(1:cut)))
  end function stripStr

  type(string) pure function upperStr(this)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: tmpValue
    character          :: ch
    integer, parameter :: ulOffset = ichar("A") - ichar("a")
    integer            :: i
    allocate(character(len(this%chr)) :: tmpValue)
    do i = 1,len(this%chr)
      ch = this%chr(i:i)
      if(ch >= "a" .and. ch <= "z") ch = char(ichar(ch)+ulOffset)
      tmpValue(i:i) = ch
    end do
    upperStr%chr = tmpValue
    deallocate(tmpvalue)
  end function upperStr

  type(string) elemental function lowerStr(this)
    class(string),    intent(in)  :: this
    character(len=:), allocatable :: tmpValue
    character          :: ch
    integer, parameter :: ulOffset = ichar("A") - ichar("a")
    integer            :: i
    allocate(character(len(this%chr)) :: tmpValue)
    do i = 1,len(this%chr)
      ch = this%chr(i:i)
      if(ch >= "A" .and. ch <= "Z") ch = char(ichar(ch)-ulOffset)
      tmpValue(i:i) = ch
    end do
    lowerStr%chr = tmpValue
    deallocate(tmpvalue)
  end function lowerStr

  ! ================================================================ !
  !  String Assignment
  ! ================================================================ !
  elemental subroutine assignStrStr(left, right)
    class(string), intent(inout) :: left
    class(string), intent(in)    :: right
    left%chr = right%chr
  end subroutine assignStrStr

  elemental subroutine assignStrChr(left, right)
    class(string),    intent(inout) :: left
    character(len=*), intent(in)    :: right
    left%chr = right
  end subroutine assignStrChr

  elemental subroutine assignChrStr(left, right)
    character(len=*), intent(inout) :: left
    class(string),    intent(in)    :: right
    left = right%chr
  end subroutine assignChrStr

  ! ================================================================ !
  !  Append Strings with +, Returning String
  ! ================================================================ !
  type(string) elemental function appendStrStr(left, right)
    class(string),    intent(in)  :: left
    class(string),    intent(in)  :: right
    character(len=:), allocatable :: tmpChr
    integer nOld, nNew
    nOld =        len(left%chr)
    nNew = nOld + len(right%chr)
    allocate(character(nNew) :: tmpChr)
    tmpChr(1:nOld)      = left%chr
    tmpChr(nOld+1:nNew) = right%chr
    appendStrStr%chr    = tmpChr
    deallocate(tmpChr)
  end function appendStrStr

  type(string) elemental function appendStrChr(left, right)
    class(string),    intent(in)  :: left
    character(len=*), intent(in)  :: right
    character(len=:), allocatable :: tmpChr
    integer nOld, nNew
    nOld =        len(left%chr)
    nNew = nOld + len(right)
    allocate(character(nNew) :: tmpChr)
    tmpChr(1:nOld)      = left%chr
    tmpChr(nOld+1:nNew) = right
    appendStrChr%chr    = tmpChr
    deallocate(tmpChr)
  end function appendStrChr

  ! ================================================================ !
  !  Concat Strings with //, Returning Character
  ! ================================================================ !
  pure function concatStrStr(left, right) result(retValue)
    class(string),    intent(in)  :: left
    class(string),    intent(in)  :: right
    character(len=:), allocatable :: retValue
    integer nOld, nNew
    nOld =        len(left%chr)
    nNew = nOld + len(right%chr)
    allocate(character(nNew) :: retValue)
    retValue(1:nOld)      = left%chr
    retValue(nOld+1:nNew) = right%chr
  end function concatStrStr

  pure function concatChrStr(left, right) result(retValue)
    character(len=*), intent(in)  :: left
    class(string),    intent(in)  :: right
    character(len=:), allocatable :: retValue
    integer nOld, nNew
    nOld =        len(left)
    nNew = nOld + len(right%chr)
    allocate(character(nNew) :: retValue)
    retValue(1:nOld)      = left
    retValue(nOld+1:nNew) = right%chr
  end function concatChrStr

  pure function concatStrChr(left, right) result(retValue)
    class(string),    intent(in)  :: left
    character(len=*), intent(in)  :: right
    character(len=:), allocatable :: retValue
    integer nOld, nNew
    nOld =        len(left%chr)
    nNew = nOld + len(right)
    allocate(character(nNew) :: retValue)
    retValue(1:nOld)      = left%chr
    retValue(nOld+1:nNew) = right
  end function concatStrChr

  ! ================================================================ !
  !  Compare Strings, Equal
  ! ================================================================ !
  elemental function compStrStr(left, right) result(retValue)
    class(string), intent(in) :: left
    class(string), intent(in) :: right
    logical retValue
    retValue = left%chr == right%chr
  end function compStrStr

  elemental function compStrChr(left, right) result(retValue)
    class(string),    intent(in) :: left
    character(len=*), intent(in) :: right
    logical retValue
    retValue = left%chr == right
  end function compStrChr

  elemental function compChrStr(left, right) result(retValue)
    character(len=*), intent(in) :: left
    class(string),    intent(in) :: right
    logical retValue
    retValue = left == right%chr
  end function compChrStr

  ! ================================================================ !
  !  Compare Strings, Not Equal
  ! ================================================================ !
  elemental function compNStrStr(left, right) result(retValue)
    class(string), intent(in) :: left
    class(string), intent(in) :: right
    logical retValue
    retValue = left%chr /= right%chr
  end function compNStrStr

  elemental function compNStrChr(left, right) result(retValue)
    class(string),    intent(in) :: left
    character(len=*), intent(in) :: right
    logical retValue
    retValue = left%chr /= right
  end function compNStrChr

  elemental function compNChrStr(left, right) result(retValue)
    character(len=*), intent(in) :: left
    class(string),    intent(in) :: right
    logical retValue
    retValue = left /= right%chr
  end function compNChrStr

end module strings

! ================================================================================================ !
! Shared module for general physical constants
! Last modified: 2018-05-25
! See: http://pdg.lbl.gov/2017/reviews/rpp2016-rev-phys-constants.pdf
! Some values are not updated to ensure numerical compatability with older studies
! ================================================================================================ !
module physical_constants

  use floatPrecision

  implicit none

  ! Proton and Electron Mass (MeV)
  real(kind=fPrec), parameter :: pmap  = 938.271998_fPrec               ! Old
  real(kind=fPrec), parameter :: pmae  = 0.510998902_fPrec              ! PDG 2002

  ! Proton and Electron Mass (MeV) Latest Values
  real(kind=fPrec), parameter :: pmap_18 = 938.272081_fPrec             ! PDG 2018
  real(kind=fPrec), parameter :: pmae_18 = 0.5109989461_fPrec           ! PDG 2018

  ! Classical electron radius
  real(kind=fPrec), parameter :: crade    = 2.817940285e-15_fPrec       ! Old
  real(kind=fPrec), parameter :: crade_18 = 2.8179403227e-15_fPrec      ! PDG 2018

  ! Speed of light
  real(kind=fPrec), parameter :: clight = 2.99792458e8_fPrec            ! Exact by definition

  ! Avogadro constant
! real(kind=fPrec), parameter :: fnavo  = 6.02214129e23_fPrec           ! Old
! real(kind=fPrec), parameter :: fnavo  = 6.022140857e23_fPrec          ! PDG 2018
  real(kind=fPrec), parameter :: fnavo  = 6.02214076e23_fPrec           ! Exact by definition

  ! Planck constant
! real(kind=fPrec), parameter :: planck = 6.626070040e-34_fPrec
  real(kind=fPrec), parameter :: planck = 6.62607015e-34_fPrec          ! Exact by definition

  !Electric charge
  real(kind=fPrec), parameter :: echarge = 1.602176634e-19_fPrec        ! Exact by definition

  ! Vacuum permittivity
  real(kind=fPrec), parameter :: eps0   = 8.854187817e-12_fPrec

end module physical_constants

! ================================================================================================ !
! Shared module for numerical constants
! Last modified: 2018-05-25
! To ensure that the same values (including round-off) is used throughout the program.
! ================================================================================================ !
module numerical_constants

  use floatPrecision

  implicit none

! real(kind=fPrec), parameter :: pi      = 3.141592653589793238462643383279502884197169399375105820974_fPrec
! real(kind=fPrec), parameter :: inv_ln2 = 1.442695040888963407359924681001892137426645954152985934135_fPrec

  ! We set the parameters of irrational numbers explicitly to their nearest binary representation
  ! without depending on rounding from decimal representation. These use decimal round near.
  ! Small program for checking binary and hex here: https://gist.github.com/vkbo/0e5d0c4b7b1ecb533a0486c79a30f741
  ! Note: Transfer to real128 only works for GNU

  real(kind=fPrec), parameter :: pi      = real(z'400921fb54442d18',fPrec)
  real(kind=fPrec), parameter :: pi2     = real(z'3ff921fb54442d18',fPrec)
  real(kind=fPrec), parameter :: twopi   = real(z'401921fb54442d18',fPrec)
  real(kind=fPrec), parameter :: pisqrt  = real(z'3ffc5bf891b4ef6a',fPrec)
  real(kind=fPrec), parameter :: inv_ln2 = real(z'3ff71547652b82fe',fPrec)
  real(kind=fPrec), parameter :: rad     = real(z'3f91df46a2529d39',fPrec)

  ! The variable pieni is roughly the smallest normal single precision float value.
  ! However, 1e-38 is actually subnormal in 32 bit (0x006ce3ee). Smallest normal is 1.17549435e-38 (0x00800000)
  ! This is probably not a good idea for performance in single prec, but changing it makes a difference in postprocessing it seems.
  real(kind=fPrec), parameter :: pieni  = 1e-38_fPrec

  real(kind=fPrec), parameter :: zero   = 0.0_fPrec
  real(kind=fPrec), parameter :: half   = 0.5_fPrec
  real(kind=fPrec), parameter :: one    = 1.0_fPrec
  real(kind=fPrec), parameter :: two    = 2.0_fPrec
  real(kind=fPrec), parameter :: three  = 3.0_fPrec
  real(kind=fPrec), parameter :: four   = 4.0_fPrec
  real(kind=fPrec), parameter :: five   = 5.0_fPrec
  real(kind=fPrec), parameter :: six    = 6.0_fPrec
  real(kind=fPrec), parameter :: seven  = 7.0_fPrec
  real(kind=fPrec), parameter :: eight  = 8.0_fPrec
  real(kind=fPrec), parameter :: nine   = 9.0_fPrec

  real(kind=fPrec), parameter :: c1e1   = 1.0e1_fPrec
  real(kind=fPrec), parameter :: c1e2   = 1.0e2_fPrec
  real(kind=fPrec), parameter :: c2e2   = 2.0e2_fPrec
  real(kind=fPrec), parameter :: c1e3   = 1.0e3_fPrec
  real(kind=fPrec), parameter :: c2e3   = 2.0e3_fPrec
  real(kind=fPrec), parameter :: c4e3   = 4.0e3_fPrec
  real(kind=fPrec), parameter :: c1e4   = 1.0e4_fPrec
  real(kind=fPrec), parameter :: c1e5   = 1.0e5_fPrec
  real(kind=fPrec), parameter :: c1e6   = 1.0e6_fPrec
  real(kind=fPrec), parameter :: c1e7   = 1.0e7_fPrec
  real(kind=fPrec), parameter :: c1e8   = 1.0e8_fPrec
  real(kind=fPrec), parameter :: c1e9   = 1.0e9_fPrec
  real(kind=fPrec), parameter :: c1e10  = 1.0e10_fPrec
  real(kind=fPrec), parameter :: c1e12  = 1.0e12_fPrec
  real(kind=fPrec), parameter :: c1e13  = 1.0e13_fPrec
  real(kind=fPrec), parameter :: c1e15  = 1.0e15_fPrec
  real(kind=fPrec), parameter :: c1e16  = 1.0e16_fPrec
  real(kind=fPrec), parameter :: c1e27  = 1.0e27_fPrec
  real(kind=fPrec), parameter :: c1e38  = 1.0e38_fPrec

  real(kind=fPrec), parameter :: c180e0 = 1.8e2_fPrec

  real(kind=fPrec), parameter :: c1m1   = 1.0e-1_fPrec
  real(kind=fPrec), parameter :: c2m1   = 2.0e-1_fPrec
  real(kind=fPrec), parameter :: c1m2   = 1.0e-2_fPrec
  real(kind=fPrec), parameter :: c5m2   = 5.0e-2_fPrec
  real(kind=fPrec), parameter :: c1m3   = 1.0e-3_fPrec
  real(kind=fPrec), parameter :: c1m4   = 1.0e-4_fPrec
  real(kind=fPrec), parameter :: c5m4   = 5.0e-4_fPrec
  real(kind=fPrec), parameter :: c1m5   = 1.0e-5_fPrec
  real(kind=fPrec), parameter :: c1m6   = 1.0e-6_fPrec
  real(kind=fPrec), parameter :: c2m6   = 2.0e-6_fPrec
  real(kind=fPrec), parameter :: c1m7   = 1.0e-7_fPrec
  real(kind=fPrec), parameter :: c1m8   = 1.0e-8_fPrec
  real(kind=fPrec), parameter :: c1m9   = 1.0e-9_fPrec
  real(kind=fPrec), parameter :: c2m9   = 2.0e-9_fPrec
  real(kind=fPrec), parameter :: c1m10  = 1.0e-10_fPrec
  real(kind=fPrec), parameter :: c1m12  = 1.0e-12_fPrec
  real(kind=fPrec), parameter :: c1m13  = 1.0e-13_fPrec
  real(kind=fPrec), parameter :: c1m15  = 1.0e-15_fPrec
  real(kind=fPrec), parameter :: c1m18  = 1.0e-18_fPrec
  real(kind=fPrec), parameter :: c1m21  = 1.0e-21_fPrec
  real(kind=fPrec), parameter :: c1m24  = 1.0e-24_fPrec
  real(kind=fPrec), parameter :: c1m27  = 1.0e-27_fPrec
  real(kind=fPrec), parameter :: c1m36  = 1.0e-36_fPrec
  real(kind=fPrec), parameter :: c1m38  = 1.0e-38_fPrec

end module numerical_constants

!
!  This file contains all the main modules holding the SixTrack shared variables
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!
! ================================================================================================ !
!  MAIN ARRAYS SIZE COMMON VARIABLES
!  Last modified: 2018-06-13
! ================================================================================================ !
module parpro

  implicit none

  integer, parameter :: mbea  = 99        ! Maximum number of beam-beam slices
  integer, parameter :: mcor  = 10        ! Maximum number of extra parameters (DIFF block)
  integer, parameter :: mcop  = mcor + 6  ! FOX/DA variable
  integer, parameter :: mpa   = 6         ! Maximum number of trajectories
  integer, parameter :: mran  = 500       ! Maximum number of inserted elements (subroutine ord)
  integer, parameter :: ncom  = 100       ! Maximum number of combinations of elements (COMB block)
  integer, parameter :: ncor1 = 600       ! Maximum number of corrections of closed orbit
  integer, parameter :: nema  = 15        ! Maximum order of the one turn map (DIFF block)
  integer, parameter :: ninv  = 1000      ! Number of invariances (postprocessing)
  integer, parameter :: nlya  = 10000     ! Something something postprocessing
  integer, parameter :: nmon1 = 600       ! Maximum number of monitors (closed orbit)
  integer, parameter :: nper  = 16        ! Maximum number of super periods (BLOC list, line 1)
  integer, parameter :: nplo  = 20000     ! Plotting
  integer, parameter :: npos  = 20000     ! Something something postprocessing
  integer, parameter :: nran  = 2000000   ! Maximum size for scaling nzfz
  integer, parameter :: nrco  = 5         ! Maximum order of compensation (RESO block)
  integer, parameter :: mmul  = 20        ! Maximum order of multipoles
  integer, parameter :: nelb  = 280       ! Maximum elements per BLOC

  ! Maximum length of strings
  integer, parameter :: mNameLen  = 48    ! Maximum length of element names. Keep in sync with MadX (and inside Geant4 code!)
  integer, parameter :: mFileName = 64    ! Maximum length of file names
  integer, parameter :: mPathName = 255   ! Maximum length of path names
  integer, parameter :: mStrLen   = 161   ! Standard string length
  integer, parameter :: mDivLen   = 132   ! Length of lout output lines
  integer, parameter :: mInputLn  = 1600  ! Buffer size for single lines read from input files

  integer :: ntr   =  1   ! Number of phase trombones

  integer :: nzfz  = -1   ! Number of allocated multipole random numbers
  integer :: nele  = -1   ! Number of allocated SINGle elements
  integer :: nblo  = -1   ! Number of allocated BLOCs
  integer :: nblz  = -1   ! Number of allocated STRUcture elements
  integer :: npart = -1   ! Number of allocated particles
  integer :: nbb   = -1   ! Beam-beam lenses

  integer, parameter :: nele_initial  = 500
  integer, parameter :: nblo_initial  = 100
  integer, parameter :: nblz_initial  = 1000
  integer, parameter :: npart_initial = 2
  integer, parameter :: nbb_initial   = 100

  ! Dividing line for output
  character(len=mDivLen), parameter :: str_divLine = repeat("-",mDivLen)

end module parpro

! ================================================================================================ !
!  PARBEAM COMMON VARIABLES
!  Last modified: 2018-06-12
! ================================================================================================ !
module parbeam

  use floatPrecision

  implicit none

  real(kind=fPrec), parameter :: xcut = 7.77_fPrec
  real(kind=fPrec), parameter :: ycut = 7.46_fPrec
  real(kind=fPrec), parameter :: h    =  1.0_fPrec/63.0_fPrec
  integer,          parameter :: nx   = 490
  integer,          parameter :: ny   = 470
  integer,          parameter :: idim = (nx+2)*(ny+2)

  integer,          save :: kstep
  real(kind=fPrec), save :: hrecip
  real(kind=fPrec), save :: wtreal(idim)
  real(kind=fPrec), save :: wtimag(idim)

  ! common /beam_exp/
  integer,          save :: beam_expflag      = 0       ! 0: Old BEAM block, 1: New BEAM::EXPERT
  logical,          save :: beam_expfile_open = .false. ! Have we opened the file 'beam_expert.txt'?

end module parbeam

! ================================================================================================ !
!  Global Settings Module
!  Last modiffied: 2018-06-10
!  Holds global settings values and parameters not directly related to the physics
! ================================================================================================ !
module mod_settings

  implicit none

  ! SETTINGS Block (fort.3)
  logical, save :: st_print        = .false. ! PRINT flag (fort.3)
  integer, save :: st_quiet        = 0       ! QUIET Level 0=verbose, 1=minimal, 2=quiet
  logical, save :: st_debug        = .false. ! Global DEBUG flag
  logical, save :: st_notrack      = .false. ! Flag to disable tracking (exit after initialisation)
  logical, save :: st_partsum      = .false. ! Flag to print final particle summary
  logical, save :: st_writefort12  = .false. ! Flag to write fort.12 after tracking
  logical, save :: st_fStateWrite  = .false. ! Dump particle final state file
  logical, save :: st_fStateText   = .false. ! Dump particle final state file as text
  logical, save :: st_fStateIons   = .false. ! Dump particle final state file with ion columns
  logical, save :: st_iStateWrite  = .false. ! Dump particle initial state file
  logical, save :: st_iStateText   = .false. ! Dump particle initial state file as text
  logical, save :: st_iStateIons   = .false. ! Dump particle initial state file with ion columns

  ! Checpoint/Restart Kills Switch Settings
  logical,              save :: st_killswitch = .false. ! Enables the kill on turn number debug feature
  integer, allocatable, save :: st_killturns(:)         ! List of killswitch turns

end module mod_settings

! ================================================================================================ !
!  THAT BIG COMMON VARIABLES MODULE
!  Last modified: 2019-01-14
! ================================================================================================ !
module mod_common

  use parpro
  use floatPrecision
  use numerical_constants
  use physical_constants, only : pmap
  use, intrinsic :: iso_fortran_env, only : int16, int32

  implicit none

  ! Parameters
  real(kind=fPrec),  parameter :: eps_dcum   = c1m6    ! Tolerance for machine length mismatch [m]

  ! Various Flags and Variables
  character(len=80), save      :: toptit(5)  = " "     ! DANGER: If the len changes, CRCHECK will break
  character(len=80), save      :: sixtit     = " "     ! DANGER: If the len changes, CRCHECK will break
  character(len=80), save      :: commen     = " "     ! DANGER: If the len changes, CRCHECK will break
  logical,           save      :: print_dcum = .false. ! Print dcum. Set in the SETTINGS block
  integer,           save      :: ithick     = 0       ! Thick tracking flag

  ! File Names and Units
  character(len=mFileName), public, save :: fort2   = "fort.2"   ! Name of machine geometry file
  character(len=mFileName), public, save :: fort3   = "fort.3"   ! Name of main input file
  character(len=mFileName), public, save :: fort6   = "fort.6"   ! Name of main output file (stdout)
  character(len=mFileName), public, save :: fort10  = "fort.10"  ! Name of main postprocessing file (text)
  character(len=mFileName), public, save :: fort110 = "fort.110" ! Name of main postprocessing file (binary)
  character(len=mFileName), public, save :: fort208 = "fort.208" ! Collimation/FLUKA

  integer,                  public, save :: unit10  = -1         ! Unit of main postprocessing file (text)
  integer,                  public, save :: unit110 = -1         ! Unit of main postprocessing file (binary)
  integer,                  public, save :: unit208 = -1         ! Collimation/FLUKA

  !  GENERAL VARIABLES
  ! ===================

  ! Error Variables
  integer,          save :: ierro      = 0

  ! Loop Variables
  integer,          save :: iu         = 0    ! Number of entries in the accelerator
  integer,          save :: il         = 0    ! Number of single elements
  integer,          save :: kanf       = 0    ! Structure index where the GO keyword is issued

  ! TRACK Block Variables
  real(kind=fPrec), save :: amp0       = zero    ! End amplitude
  integer,          save :: numl       = 1       ! Number of turns in the forward direction
  integer,          save :: numlr      = 0       ! Number of turns in the backward direction
  integer,          save :: numx       = 0       ! Checkpoint turn (turn-1)
  integer,          save :: napx       = 0       ! Number of amplitude variations
  integer,          save :: ird        = 0       ! Ignored
  integer,          save :: niu(2)     = 0       ! Start and stop structure element for optics calculation
  integer,          save :: numlcp     = 1000    ! How often to write checkpointing files
  integer,          save :: idfor      = 0       ! Add closed orbit to initial coordinates
  integer,          save :: irew       = 0       ! Rewind fort.59-90
  integer,          save :: iclo6      = 0       ! 6D closed orbit flags
  integer,          save :: nde(2)     = 0       ! Number of turns at flat bottom / energy ramping
  integer,          save :: nwr(4)     = 1       ! Writings to singletrackfile.dat
  integer,          save :: ntwin      = 1       ! How to calculate the distance in phase space
  integer,          save :: napxo      = 0       ! Original value of napx
  integer,          save :: napxto     = 0       ! Particles times turns
  integer,          save :: nnuml      = 0       ! Turn number for POSTPR
  logical,          save :: curveff    = .false. ! Enable the curvature effect in a combined function magnet
  logical,          save :: firstrun   = .true.  ! Switched off after the first completed turn (not necessarily turn 1 if C/R)
  logical,          save :: iexact     = .false. ! Exact solution of the equation of motion
  logical,          save :: rdfort13   = .false. ! Wheteher to read distribution from fort.13 or not

  ! INITIAL COORDINATES Block Variables
  real(kind=fPrec), save :: rat        = zero
  integer,          save :: iver       = 0

  ! BLOC DEFINITONS Block
  integer,          save :: mper       = 0    ! Number of super periods
  integer,          save :: msym(nper) = 0
  integer,          save :: mblo       = 0
  integer,          save :: mbloz      = 0

  ! STRUCTURE Block
  logical,          save :: strumcol   = .false. ! Whether the structure block is multicolumn or not

  ! Synchrotron Motion and Differential Algebra Block
  real(kind=fPrec), save :: qs         = zero ! Synchrotron tune [N/turn]
  real(kind=fPrec), save :: pma        = pmap ! Rest mass of the particle in MeV/c^2
  real(kind=fPrec), save :: phas       = zero ! Synchrotron acceleration phase [rad]
  real(kind=fPrec), save :: hsy(3)     = zero ! Cavity [voltage, unused, RF frequency]
  real(kind=fPrec), save :: crad       = zero ! electron radius * electron mass / pma
  real(kind=fPrec), save :: dppoff     = zero ! Offset relative momentum deviation
  real(kind=fPrec), save :: tlen       = one  ! Length of the accelerator [m]
  real(kind=fPrec), save :: mtcda      = one  ! Somthing FOX
  real(kind=fPrec), save :: dpscor     = one  ! Scaling factor for relative momentum deviation
  real(kind=fPrec), save :: sigcor     = one  ! Path length difference
  integer,          save :: iicav      = 0    ! Used between runcav and runda
  integer,          save :: ition      = 0    ! Transition energy switch:
  integer,          save :: idp        = 0    ! Synchrotron motion
  integer,          save :: ixcav      = 0    ! Stores ix, presumably for cavity
  integer,          save :: icode      = 0
  integer,          save :: idam       = 0
  integer,          save :: its6d      = 0

  ! RF Cavities
  integer,          save :: icy        = 0    ! Accelerating cavity: Number of "CAV" locations in STRUCT
  integer,          save :: ncy        = 0    ! Accelerating cavity: Number of "CAV" locations times super periods mper
  integer,          save :: ncy2       = 0    ! Accelerating cavity: Number of cavities (kz = +/- 12) in SING

  ! Organisation of Random Numbers
  integer,          save :: iorg       = 0    ! Organisation of random numbers flag
  integer,          save :: izu0       = 0    ! Start value for the random number generator
  integer,          save :: mcut       = 0    ! Sigma cut for random numbers
  integer,          save :: mout2      = 0    ! Magnet Fluctuations: Write fort.2 > fort.4 (mod_fluc)

  ! Iteration Errors
  real(kind=fPrec), save :: dma        = c1m12 ! Precision of closed orbit displacements
  real(kind=fPrec), save :: dmap       = c1m15 ! Precision of derivative of closed orbit displacements
  real(kind=fPrec), save :: dkq        = c1m10 ! Variations of quadrupole strengths
  real(kind=fPrec), save :: dqq        = c1m10 ! Precision of tunes
  real(kind=fPrec), save :: dsm0       = c1m10 ! Variations of sextupole strengths
  real(kind=fPrec), save :: dech       = c1m10 ! Precision of chromaticity correction
  real(kind=fPrec), save :: de0        = c1m9  ! Variations of momentum spread for chromaticity calculation
  real(kind=fPrec), save :: ded        = c1m9  ! Variations of momentum spread for evaluation of dispersion
  real(kind=fPrec), save :: dsi        = c1m9  ! Precision of desired orbit r.m.s. value
  real(kind=fPrec), save :: aper(2)    = c1e3  ! Precision of aperture limits

  integer,          save :: itco       = 500   ! Number of iterations for closed orbit calculation
  integer,          save :: itcro      = 10    ! Number of iterations for chromaticity correction
  integer,          save :: itqv       = 10    ! Number of iterations for Q adjustment

  ! Closed Orbit
  real(kind=fPrec), save :: di0(2)     = zero
  real(kind=fPrec), save :: dip0(2)    = zero
  real(kind=fPrec), save :: ta(6,6)    = zero

  ! Correction of Closed Orbit
  real(kind=fPrec), save :: sigma0(2)  = zero ! Desired RMS values of the randomly distributed closed orbit
  integer,          save :: iclo       = 0    ! Closed orbit correction switch
  integer,          save :: ncorru     = 0    ! Number of correctors to be used
  integer,          save :: ncorrep    = 0    ! Number of corrections

  integer,          save :: nhmoni     = 0
  integer,          save :: nhcorr     = 0
  integer,          save :: nvmoni     = 0
  integer,          save :: nvcorr     = 0

  real(kind=fPrec), save :: clo6(3)    = zero ! 6D closed orbit correction position
  real(kind=fPrec), save :: clop6(3)   = zero ! 6D closed orbit correction momentum

  ! Tune Variation
  real(kind=fPrec), save :: qw0(3)     = zero ! Qx/Qy/delta_Q
  integer,          save :: iq(3)      = 0    ! Index of elements
  integer,          save :: iqmod      = 0    ! Switch to calculate the tunes
  integer,          save :: iqmod6     = 0    ! Switch to calculate the tunes

  ! Linear Optics
  real(kind=fPrec), save :: eui        = 0    ! Eigenemittance
  real(kind=fPrec), save :: euii       = 0    ! Eigenemittance
  integer,          save :: ilin       = 0    ! Linear optics 4D/6D calculation flag
  integer,          save :: nt         = 0    ! Number of the blocks to which the linear parameter will be printed
  integer,          save :: ntco       = 0    ! Switch to write out linear coupling parameters
  integer,          save :: iprint     = 0    ! Print the linear optics functions at ...
  integer,          save :: nlin       = 0    ! Number of elements for write out

  ! Combination of Elements
  integer,          save :: icomb0(20) = 0    ! Index of single element
  integer,          save :: icoe       = 0    ! Number of combinations (lines in block)

  ! Search for Optimum Places to Compensate Resonances and Sub-Resonance Calculation
  integer,          save :: mesa       = 0    ! Number of positions to be checked
  integer,          save :: mp         = 0    ! Order of the resonance
  integer,          save :: m21        = 0    ! Resonances of order 1
  integer,          save :: m22        = 0    ! Resonances of order 2
  integer,          save :: m23        = 0    ! Resonances of order 3
  integer,          save :: ise1       = 0    ! Distance to a resonance
  integer,          save :: ise2       = 0    ! Distance to a resonance
  integer,          save :: ise3       = 0    ! Distance to a resonance
  integer,          save :: ise        = 0    ! Flag on/off
  integer,          save :: isub       = 0    ! Sub-resonance calculation switch
  integer,          save :: nta        = 0    ! Lowest order of the resonance
  integer,          save :: nte        = 0    ! Highest order of the resonance
  integer,          save :: ipt        = 0    ! Switch to change the nearest distance to the resonance

  integer,          save :: nre        = 0    ! Number of resonances
  integer,          save :: npp        = 0    ! Order of the resonance
  integer,          save :: nrr(5)     = 0    ! Resonances of order n
  integer,          save :: ipr(5)     = 0    ! Distance to the resonance
  integer,          save :: nur        = 0    ! Number of sub-resonances
  integer,          save :: nu(5)      = 0    ! Order of the multipole
  real(kind=fPrec), save :: totl       = zero ! Length of the accelerator [m]
  real(kind=fPrec), save :: qxt        = zero ! Horizontal tune including the integer part
  real(kind=fPrec), save :: qzt        = zero ! Vertical tune including the integer part
  real(kind=fPrec), save :: tam1       = zero ! Horizontal amplitudes [mm]
  real(kind=fPrec), save :: tam2       = zero ! Vertical amplitudes [mm]
  integer,          save :: irmod2     = 0    ! Resonance compensation on/off
  integer,          save :: nch        = 0    ! Switch for the chromaticity correction
  integer,          save :: nqc        = 0    ! Switch for the tune adjustment

  real(kind=fPrec), save :: dtr(10)    = zero
  integer,          save :: ire(12)    = 0

  real(kind=fPrec), save :: rtc(9,18,10,5) = zero
  real(kind=fPrec), save :: rts(9,18,10,5) = zero

  ! Beam-Beam Variables
  real(kind=fPrec), save :: sigz       = zero ! RMS bunch length
  real(kind=fPrec), save :: sige       = zero ! RMS energy spread
  real(kind=fPrec), save :: partnum    = zero ! Number of particles in bunch
  real(kind=fPrec), save :: parbe14    = zero !
  real(kind=fPrec), save :: emitx      = zero ! Horisontal emittance
  real(kind=fPrec), save :: emity      = zero ! Vertical emittance
  real(kind=fPrec), save :: emitz      = zero ! Longitudinal emittance
  real(kind=fPrec), save :: gammar     = one  ! Inverse Lorentz factor
  real(kind=fPrec), save :: brho       = zero ! magnetic rigitidy of beam [Tm]
  integer,          save :: ibb6d      = 0    ! 6D beam-beam switch
  integer,          save :: nbeam      = 0    ! Beam-beam elements flag
  integer,          save :: ibbc       = 0    ! Switch for linear coupling considered in 4D and 6D
  integer,          save :: ibeco      = 1    ! Subtract the closed orbit introduced by BEAM/WIRE
  integer,          save :: ibtyp      = 0    ! Switch to use the fast beam–beam algorithms
  integer,          save :: lhc        = 1    ! Switch for the LHC with its anti-symmetric IR

  ! Decoupling of Motion
  integer,          save :: iskew      = 0    ! Skew switch
  integer,          save :: nskew(6)   = 0    ! Index to skew quadrupole families
  real(kind=fPrec), save :: qwsk(2)    = zero ! Horisontal and vertical tune
  real(kind=fPrec), save :: betx(2)    = zero
  real(kind=fPrec), save :: betz(2)    = zero
  real(kind=fPrec), save :: alfx(2)    = zero
  real(kind=fPrec), save :: alfz(2)    = zero

  ! RF Multipoles
  integer,          save :: iord       = 0
  integer,          save :: nordm      = 0

  ! Reference Particle
  real(kind=fPrec),    save :: e0      = zero ! Reference energy [MeV]
  real(kind=fPrec),    save :: e0f     = zero ! Reference momentum [MeV/c]
  real(kind=fPrec),    save :: nucm0   = pmap ! Reference mass [MeV/c^2]
  real(kind=fPrec),    save :: nucmda  = pmap ! Reference mass [MeV/c^2] (DA)
  real(kind=fPrec),    save :: gamma0  = one  ! Reference beam Lorentz factor
  real(kind=fPrec),    save :: beta0   = zero ! Reference beam relativistic beta
  integer(kind=int32), save :: aa0     = 1    ! Reference nucleon number
  integer(kind=int32), save :: zz0     = 1    ! Reference charge multiplicity
  integer(kind=int32), save :: qq0     = 1    ! Reference charge
  integer(kind=int32), save :: pdgid0  = 2212 ! Reference particle PDG ID
  integer,             save :: pdgyear = 2002 ! Reference particle PDG year

  ! Tracking Particles
  real(kind=fPrec), save :: ej(mpa)    = zero ! Particle energy
  real(kind=fPrec), save :: ejf(mpa)   = zero ! Particle momentum

  ! Other Variables
  integer,          save :: ichromc    = 0
  integer,          save :: ilinc      = 0    ! 2 = Beam-beam closed orbit calc
  integer,          save :: iqmodc     = 0
  real(kind=fPrec), save :: corr(3,3)  = zero
  real(kind=fPrec), save :: chromc(2)  = 9.999999e23_fPrec
  real(kind=fPrec), save :: wxys(3)    = zero
  real(kind=fPrec), save :: clon(6)    = zero

  real(kind=fPrec), save :: aml6(6,6)  = zero ! 6D / FOX
  real(kind=fPrec), save :: edcor(2)   = zero ! Chromaticity-related

  ! Post-Procesing
  real(kind=fPrec), save :: dphix      = zero ! Horisontal angle interval used to stroboscope phase space [rad]
  real(kind=fPrec), save :: dphiz      = zero ! Vertical angle interval used to stroboscope phase space [rad]
  real(kind=fPrec), save :: qx0        = zero ! Horisontal tune
  real(kind=fPrec), save :: qz0        = zero ! Vertical tune
  real(kind=fPrec), save :: dres       = one  ! Maximum distance to the resonance
  real(kind=fPrec), save :: dfft       = one  ! Find resonances with the FFT spectrum below
  real(kind=fPrec), save :: cma1       = one  ! Scale for Lyapunov analysis
  real(kind=fPrec), save :: cma2       = one  ! Scale for Lyapunov analysis

  integer,          save :: nstart     = 0    ! Start turn number for the analysis
  integer,          save :: nstop      = 0    ! Stop turn number for the analysis
  integer,          save :: iskip      = 1    ! Number of samples to skip
  integer,          save :: iconv      = 0    ! Switch: tracking data are not normalised linearly
  integer,          save :: imad       = 0    ! Switch: MAD-X related

  integer,          save :: ipos       = 0    ! Post-processing on/off
  integer,          save :: iav        = 1    ! Averaging interval of the values of the distance in phase space
  integer,          save :: iwg        = 1    ! Switch: weighting of the slope calculation of the distance in phase space
  integer,          save :: ivox       = 1    ! Switch: tune close to an integer
  integer,          save :: ivoz       = 1    ! Switch: tune close to an integer
  integer,          save :: ires       = 1    ! Closest resonances search up to order
  integer,          save :: ifh        = 0    ! FFT analysis tune interval

  integer,          save :: kwtype     = 0    ! Disabled
  integer,          save :: itf        = 0    ! Switch to get PS file of plots
  integer,          save :: icr        = 0    ! Disabled
  integer,          save :: idis       = 0    ! Switch to select plot
  integer,          save :: icow       = 0    ! Switch to select plot
  integer,          save :: istw       = 0    ! Switch to select plot
  integer,          save :: iffw       = 0    ! Switch to select plot
  integer,          save :: nprint     = 1    ! Switch to stop the printing of the post-processing fort.6
  integer,          save :: ndafi      = 1    ! Number of data files to be processed

  !  ALLOCATABLES
  ! ==============

  ! Block Element Indexed (nblo)
  character(len=:), allocatable, save :: bezb(:)        ! Block Elements: Name
  real(kind=fPrec), allocatable, save :: elbe(:)        ! Block Elements: Length
  integer,          allocatable, save :: mtyp(:,:)      ! Block Elements: Indices of single elements (:,nelb)

  real(kind=fPrec), allocatable, save :: bl1(:,:,:)     ! Block Elements: (:,2,6)
  real(kind=fPrec), allocatable, save :: bl2(:,:,:)     ! Block Elements: (:,2,6)
  integer,          allocatable, save :: mel(:)         ! Block Elements: Number of single elements

  ! Single Element Indexed (nele)
  character(len=:), allocatable, save :: bez(:)         ! Single Elements: 1st field, name
  character(len=:), allocatable, save :: bezl(:)        ! Single Elements: Linear optics write out
  real(kind=fPrec), allocatable, save :: ed(:)          ! Single Elements: 3rd field, additional
  real(kind=fPrec), allocatable, save :: ek(:)          ! Single Elements: 4th field, additional
  real(kind=fPrec), allocatable, save :: el(:)          ! Single Elements: 5th field, length [m]
  real(kind=fPrec), allocatable, save :: bbbx(:)        ! Single Elements: 6th field
  real(kind=fPrec), allocatable, save :: bbby(:)        ! Single Elements: 7th field
  real(kind=fPrec), allocatable, save :: bbbs(:)        ! Single Elements: 8th field
  real(kind=fPrec), allocatable, save :: sm(:)          ! Single Elements: Non-linear field, avg strength
  integer,          allocatable, save :: kz(:)          ! Single Elements: 2nd field, type
  integer,          allocatable, save :: kp(:)          ! Single Elements: Additional flag
  real(kind=fPrec), allocatable, save :: dki(:,:)       ! Single Elements: [H bend kick, V bend kick, dipole length] (:,3)

  real(kind=fPrec), allocatable, save :: a(:,:,:)       ! Something Something Matrix (:,2,6)

  real(kind=fPrec), allocatable, save :: hsyc(:)        ! Accelerating cavity: 'Frequency'
  real(kind=fPrec), allocatable, save :: phasc(:)       ! Accelerating cavity: Lag phase

  real(kind=fPrec), allocatable, save :: benkc(:)       ! Multipoles: Bending strength of the dipole [mrad]
  real(kind=fPrec), allocatable, save :: r00(:)         ! Multipoles: Reference radius [mm]
  real(kind=fPrec), allocatable, save :: scalemu(:)     ! Multipoles: Scale (DYNK)
  integer,          allocatable, save :: nmu(:)         ! Multipoles: Max multipole order
  integer,          allocatable, save :: irm(:)         ! Multipoles: Index of the associated element

  real(kind=fPrec), allocatable, save :: freq_rfm(:)    ! RF Multipoles:
  integer,          allocatable, save :: nmu_rf(:)      ! RF Multipoles: Max multipole order
  integer,          allocatable, save :: irm_rf(:)      ! RF Multipoles: Index of the associated element

  real(kind=fPrec), allocatable, save :: xpl(:)         ! Displacement (DISP): Value of horizontal displacement [mm]
  real(kind=fPrec), allocatable, save :: xrms(:)        ! Displacement (DISP): RMS of horizontal displacement [mm]
  real(kind=fPrec), allocatable, save :: zpl(:)         ! Displacement (DISP): Value of vertical displacement [mm]
  real(kind=fPrec), allocatable, save :: zrms(:)        ! Displacement (DISP): RMS of vertical displacement [mm]

  character(len=:), allocatable, save :: bezr(:,:)      ! Organisation of Random Numbers (3,:)

  integer,          allocatable, save :: kpa(:)         ! Tune Variations: Element markers

  integer,          allocatable, save :: ncororb(:)     ! Obrit Correctors: Flag

  real(kind=fPrec), allocatable, save :: crabph(:)      ! Crab Cavities: Phase of the excitation
  real(kind=fPrec), allocatable, save :: crabph2(:)     ! Crab Cavities: Order 2
  real(kind=fPrec), allocatable, save :: crabph3(:)     ! Crab Cavities: Order 3
  real(kind=fPrec), allocatable, save :: crabph4(:)     ! Crab Cavities: Order 4

  real(kind=fPrec), allocatable, save :: ratioe(:)      ! Combination of Elements: Ratio of the magnetic strength
  integer,          allocatable, save :: iratioe(:)     ! Combination of Elements: Index

  integer,          allocatable, save :: isea(:)        ! Compensate Resonance: Element index

  real(kind=fPrec), allocatable, save :: parbe(:,:)     ! Beam-Beam: Input values (:,18)
  real(kind=fPrec), allocatable, save :: ptnfac(:)      ! Beam-Beam: Strength ratio

  real(kind=fPrec), allocatable, save :: acdipph(:)     ! AC Dipole: Phase (el)
  integer,          allocatable, save :: nturn1(:)      ! AC Dipole: Turns to free of excitation at the beginning of the run
  integer,          allocatable, save :: nturn2(:)      ! AC Dipole: Turns to ramp up the excitation amplitude
  integer,          allocatable, save :: nturn3(:)      ! AC Dipole: Turns of constant excitation amplitude
  integer,          allocatable, save :: nturn4(:)      ! AC Dipole: Turns to ramp down the excitation amplitude

  integer,          allocatable, save :: imtr(:)        ! Phase Trombones

  ! Single Element and Multipole Indexed (nele,mmul)
  real(kind=fPrec), allocatable, save :: bk0(:,:)       ! Multipoles: B-value
  real(kind=fPrec), allocatable, save :: ak0(:,:)       ! Multipoles: A-value
  real(kind=fPrec), allocatable, save :: bka(:,:)       ! Multipoles: B-RMS
  real(kind=fPrec), allocatable, save :: aka(:,:)       ! Multipoles: A-RMS
  real(kind=fPrec), allocatable, save :: norrfamp(:,:)  ! RF Multipoles:
  real(kind=fPrec), allocatable, save :: norrfph(:,:)   ! RF Multipoles:
  real(kind=fPrec), allocatable, save :: skrfamp(:,:)   ! RF Multipoles:
  real(kind=fPrec), allocatable, save :: skrfph(:,:)    ! RF Multipoles:

  ! Structure Element Indexed (nblz)
  real(kind=fPrec), allocatable, save :: sigmoff(:)
  real(kind=fPrec), allocatable, save :: tiltc(:)       ! Magnet Tilt: Cos component
  real(kind=fPrec), allocatable, save :: tilts(:)       ! Magnet Tilt: Sin component
  integer,          allocatable, save :: icext(:)       ! Magnet Error: Index (mod_fluc)
  integer,          allocatable, save :: mzu(:)         ! Magnet Error: Random number index
  integer,          allocatable, save :: icextal(:)     ! Magnet Misalignment: index (mod_fluc)

  character(len=:), allocatable, save :: bezs(:)        ! Name of structure element
  real(kind=fPrec), allocatable, save :: elpos(:)       ! Position of structure element
  integer,          allocatable, save :: ic(:)          ! Structure to single/block element map0

  real(kind=fPrec), allocatable, save :: xsi(:)         ! Tracking: Horisontal displacement
  real(kind=fPrec), allocatable, save :: zsi(:)         ! Tracking: Vertical displacement
  real(kind=fPrec), allocatable, save :: smi(:)         ! Tracking: Magnetic kick
  real(kind=fPrec), allocatable, save :: smizf(:)       ! Random Numbers: zfz*ek

  real(kind=fPrec), allocatable, save :: dcum(:)        ! Machine length in m (0:nblz+1)

  integer,          allocatable, save :: imbb(:)        ! Beam-Beam:

  ! Structure Element and Multipole Indexed (nblz,mmul)
  real(kind=fPrec), allocatable, save :: aaiv(:,:)      ! Multipoles:
  real(kind=fPrec), allocatable, save :: bbiv(:,:)      ! Multipoles:
  real(kind=fPrec), allocatable, save :: amultip(:,:)   ! Multipoles:
  real(kind=fPrec), allocatable, save :: bmultip(:,:)   ! Multipoles:

  ! Number of Particles (npart)
  real(kind=fPrec), allocatable, save :: track6d(:,:)   ! Beam-Beam (6,:)

  ! Random Numbers Indexed (nzfz)
  real(kind=fPrec), allocatable, save :: zfz(:)         ! Magnet errors

  ! Number of Multipoles (mmul)
  real(kind=fPrec), allocatable, save :: field_cos(:,:) ! RF Multipoiles (2,:)
  real(kind=fPrec), allocatable, save :: fsddida(:,:)   ! RF Multipoiles (2,:)
  real(kind=fPrec), allocatable, save :: field_sin(:,:) ! RF Multipoiles (2,:)
  real(kind=fPrec), allocatable, save :: fcodda(:,:)    ! RF Multipoiles (2,:)

  ! Number of Monitors (nmon1)
  real(kind=fPrec), allocatable, save :: betam(:,:)     ! Orbit Correction: (:,2)
  real(kind=fPrec), allocatable, save :: pam(:,:)       ! Orbit Correction: (:,2)
  real(kind=fPrec), allocatable, save :: bclorb(:,:)    ! Orbit Correction: (:,2)

  ! Number of Orbit Corrections (ncor1)
  real(kind=fPrec), allocatable, save :: betac(:,:)     ! Orbit Correction: (:,2)
  real(kind=fPrec), allocatable, save :: pac(:,:)       ! Orbit Correction: (:,2)

  ! Number of Combinations of Elements (ncom)
  real(kind=fPrec), allocatable, save :: ratio(:,:)     ! Combination of Elements: Ratio (:,20)
  integer,          allocatable, save :: icomb(:,:)     ! Combination of Elements: Index (:,20)

  ! Number of Beam-Beam Lenses (nbb)
  integer,          allocatable, save :: nbeaux(:)      ! (:)
  real(kind=fPrec), allocatable, save :: sigman(:,:)    ! (2,:)
  real(kind=fPrec), allocatable, save :: sigman2(:,:)   ! sigman^2 (2,:)
  real(kind=fPrec), allocatable, save :: sigmanq(:,:)   ! (2,:)
  real(kind=fPrec), allocatable, save :: clobeam(:,:)   ! (6,:)
  real(kind=fPrec), allocatable, save :: beamoff(:,:)   ! (6,:)
  real(kind=fPrec), allocatable, save :: bbcu(:,:)      ! (:,12)

  ! Number of Phase Trombones (ntr)
  real(kind=fPrec), allocatable, save :: cotr(:,:)      ! (:,6)
  real(kind=fPrec), allocatable, save :: rrtr(:,:,:)    ! (:,6,6)

contains

subroutine mod_common_expand_arrays(nele_new, nblo_new, nblz_new, npart_new, nbb_new)

  use mod_alloc
  use mod_settings
  use numerical_constants, only : zero,one

  implicit none

  integer, intent(in) :: nele_new
  integer, intent(in) :: nblo_new
  integer, intent(in) :: nblz_new
  integer, intent(in) :: npart_new
  integer, intent(in) :: nbb_new

  logical :: firstRun   = .true.
  integer :: nele_prev  = -2
  integer :: nblo_prev  = -2
  integer :: nblz_prev  = -2
  integer :: npart_prev = -2
  integer :: nbb_prev   = -2

  if(nele_new /= nele_prev) then
    call alloc(ed,                   nele_new,       zero,   "ed")
    call alloc(el,                   nele_new,       zero,   "el")
    call alloc(ek,                   nele_new,       zero,   "ek")
    call alloc(sm,                   nele_new,       zero,   "sm")
    call alloc(kz,                   nele_new,       0,      "kz")
    call alloc(kp,                   nele_new,       0,      "kp")
    call alloc(bbbx,                 nele_new,       zero,   "bbbx")
    call alloc(bbby,                 nele_new,       zero,   "bbby")
    call alloc(bbbs,                 nele_new,       zero,   "bbbs")
    call alloc(xpl,                  nele_new,       zero,   "xpl")
    call alloc(zpl,                  nele_new,       zero,   "zpl")
    call alloc(xrms,                 nele_new,       zero,   "xrms")
    call alloc(zrms,                 nele_new,       zero,   "zrms")
    call alloc(a,                    nele_new,2,6,   zero,   "a")
    call alloc(hsyc,                 nele_new,       zero,   "hsyc")
    call alloc(phasc,                nele_new,       zero,   "phasc")
    call alloc(bk0,                  nele_new, mmul, zero,   "bk0")
    call alloc(ak0,                  nele_new, mmul, zero,   "ak0")
    call alloc(bka,                  nele_new, mmul, zero,   "bka")
    call alloc(aka,                  nele_new, mmul, zero,   "aka")
    call alloc(benkc,                nele_new,       zero,   "benkc")
    call alloc(norrfamp,             nele_new, mmul, zero,   "norrfamp")
    call alloc(norrfph,              nele_new, mmul, zero,   "norrfph")
    call alloc(skrfamp,              nele_new, mmul, zero,   "skrfamp")
    call alloc(skrfph,               nele_new, mmul, zero,   "skrfph")
    call alloc(freq_rfm,             nele_new,       zero,   "freq_rfm")
    call alloc(r00,                  nele_new,       zero,   "r00")
    call alloc(scalemu,              nele_new,       one,    "scalemu")
    call alloc(irm,                  nele_new,       0,      "irm")
    call alloc(irm_rf,               nele_new,       0,      "irm_rf")
    call alloc(nmu,                  nele_new,       0,      "nmu")
    call alloc(nmu_rf,               nele_new,       0,      "nmu_rf")
    call alloc(bezr,    mNameLen, 3, nele_new,       " ",    "bezr")
    call alloc(kpa,                  nele_new,       0,      "kpa")
    call alloc(bez,     mNameLen,    nele_new,       " ",    "bez")
    call alloc(bezl,    mNameLen,    nele_new,       " ",    "bezl")
    call alloc(ncororb,              nele_new,       0,      "ncororb")
    call alloc(ratioe,               nele_new,       one,    "ratioe")
    call alloc(iratioe,              nele_new,       0,      "iratioe")
    call alloc(isea,                 nele_new,       0,      "isea")
    call alloc(dki,                  nele_new, 3,    zero,   "dki")
    call alloc(parbe,                nele_new, 18,   zero,   "parbe")
    call alloc(ptnfac,               nele_new,       zero,   "ptnfac")
    call alloc(imtr,                 nele_new,       0,      "imtr")
    call alloc(acdipph,              nele_new,       zero,   "acdipph")
    call alloc(nturn1,               nele_new,       0,      "nturn1")
    call alloc(nturn2,               nele_new,       0,      "nturn2")
    call alloc(nturn3,               nele_new,       0,      "nturn3")
    call alloc(nturn4,               nele_new,       0,      "nturn4")
    call alloc(crabph,               nele_new,       zero,   "crabph")
    call alloc(crabph2,              nele_new,       zero,   "crabph2")
    call alloc(crabph3,              nele_new,       zero,   "crabph3")
    call alloc(crabph4,              nele_new,       zero,   "crabph4")
  end if

  if(nblo_new /= nblo_prev) then
    call alloc(bezb,    mNameLen,    nblo_new,       " ",    "bezb")
    call alloc(elbe,                 nblo_new,       zero,   "elbe")
    call alloc(mel,                  nblo_new,       0,      "mel")
    call alloc(mtyp,                 nblo_new, nelb, 0,      "mtyp")
    call alloc(bl1,                  nblo_new, 2, 6, zero,   "bl1")
    call alloc(bl2,                  nblo_new, 2, 6, zero,   "bl2")
  end if

  if(nblz_new /= nblz_prev) then
    call alloc(ic,                   nblz_new,       0,      "ic")
    call alloc(elpos,                nblz_new+1,     zero,   "elpos", 0)
    call alloc(bezs,      mNameLen,  nblz_new,       " ",    "bezs")
    call alloc(mzu,                  nblz_new,       0,      "mzu")
    call alloc(imbb,                 nblz_new,       0,      "imbb")
    call alloc(icext,                nblz_new,       0,      "icext")
    call alloc(icextal,              nblz_new,       0,      "icextal")
    call alloc(tiltc,                nblz_new,       one,    "tiltc")
    call alloc(tilts,                nblz_new,       zero,   "tilts")
    call alloc(xsi,                  nblz_new,       zero,   "xsi")
    call alloc(zsi,                  nblz_new,       zero,   "zsi")
    call alloc(smi,                  nblz_new,       zero,   "smi")
    call alloc(smizf,                nblz_new,       zero,   "smizf")
    call alloc(aaiv,          mmul,  nblz_new,       zero,   "aaiv")
    call alloc(bbiv,          mmul,  nblz_new,       zero,   "bbiv")
    call alloc(amultip,       mmul,  nblz_new,       zero,   "amultip")
    call alloc(bmultip,       mmul,  nblz_new,       zero,   "bmultip")
    call alloc(dcum,                 nblz_new+1,     zero,   "dcum", 0)
    call alloc(sigmoff,              nblz_new,       zero,   "sigmoff")
  end if

  if(npart_new /= npart_prev) then
    call alloc(track6d, 6,           npart_new,      zero,   "track6d")
  end if

  if(nbb_new /= nbb_prev) then
    call alloc(nbeaux,               nbb,            0,      "nbeaux")
    call alloc(sigman,            2, nbb,            zero,   "sigman")
    call alloc(sigman2,           2, nbb,            zero,   "sigman2")
    call alloc(sigmanq,           2, nbb,            zero,   "sigmanq")
    call alloc(clobeam,           6, nbb,            zero,   "clobeam")
    call alloc(beamoff,           6, nbb,            zero,   "beamoff")
    call alloc(bbcu,                 nbb, 12,        zero,   "bbcu")
  end if

  ! The arrays that don't currently have scalable sizes only need to be allocated once
  if(firstRun) then
    call alloc(betam,                nmon1, 2,       zero,   "betam")
    call alloc(pam,                  nmon1, 2,       zero,   "pam")
    call alloc(bclorb,               nmon1, 2,       zero,   "bclorb")

    call alloc(betac,                ncor1, 2,       zero,   "betac")
    call alloc(pac,                  ncor1, 2,       zero,   "pac")

    call alloc(ratio,                ncom,  20,      zero,   "ratio")
    call alloc(icomb,                ncom,  20,      0,      "icomb")

    call alloc(field_cos,         2, mmul,           zero,   "field_cos")
    call alloc(fsddida,           2, mmul,           zero,   "fsddida")
    call alloc(field_sin,         2, mmul,           zero,   "field_sin")
    call alloc(fcodda,            2, mmul,           zero,   "fcodda")

    call alloc(cotr,                 ntr,  6,        zero,   "cotr")
    call alloc(rrtr,                 ntr,  6,6,      zero,   "rrtr")
  end if

  firstRun   = .false.
  nele_prev  = nele_new
  nblo_prev  = nblo_new
  nblz_prev  = nblz_new
  npart_prev = npart_new

end subroutine mod_common_expand_arrays

end module mod_common

! ================================================================================================ !
!  DA COMMON VARIABLES
!  Last modified: 2019-01-15
! ================================================================================================ !
module mod_common_da

  use parpro
  use floatPrecision
  use numerical_constants

  implicit none

  ! Differential Algebra (DIFF)
  real(kind=fPrec), save :: preda      = c1m38 ! Precision needed by the DA package
  integer,          save :: idial      = 0     ! DIFF block switch
  integer,          save :: nord       = 0     ! Order of the map
  integer,          save :: nvar       = 0     ! Number of the variables
  integer,          save :: nvar2      = 0     ! Number of the variables (not with ncor added)
  integer,          save :: nsix       = 0     ! Switch to calculate a 5x6 instead of a 6x6 map
  integer,          save :: ncor       = 0     ! Number of zero-length elements to be additional parameters
  integer,          save :: ipar(mcor) = 0     ! DIFF variable

  ! Normal Forms (NORM)
  integer,          save :: inorm      = 0     ! NORM block switch
  integer,          save :: nordf      = 0     ! Order of the Normal Form
  integer,          save :: nvarf      = 0     ! Number of variables
  integer,          save :: nord1      = 1     ! 3rd variable in NORM (not in manual)
  integer,          save :: idptr      = 0     ! 4th variable in NORM (not in manual)
  integer,          save :: imod1      = 0     ! Mode
  integer,          save :: imod2      = 0     ! Mode
  integer,          save :: ndimf      = 0     ! NORM vriable

end module mod_common_da

! ================================================================================================ !
!  TRACKING COMMON VARIABLES
!  Last modified: 2018-06-21
! ================================================================================================ !
module mod_common_track

  use parpro
  use floatPrecision
  use numerical_constants

  implicit none

  ! Tracking
  real(kind=fPrec), save :: x(mpa,2) = zero
  real(kind=fPrec), save :: y(mpa,2) = zero
  real(kind=fPrec), save :: amp(2)   = [c1m3,zero]
  real(kind=fPrec), save :: bet0(2)  = zero
  real(kind=fPrec), save :: alf0(2)  = zero
  real(kind=fPrec), save :: clo(2)   = zero
  real(kind=fPrec), save :: clop(2)  = zero
  integer,          save :: nwri     = 0     ! Flag for frequency of calls to writebin. Set by nwr(3) in TRAC

  ! Chromaticity
  real(kind=fPrec), save :: cro(2)   = zero  ! Desired values of the chromaticity
  integer,          save :: crois(2) = 0     ! Index of the elements in the single elements list
  integer,          save :: ichrom   = 0     ! Flag for calculation, 1: "traditional", 2: including beam-beam, 3: both

  ! tas
  real(kind=fPrec), save :: tasm(6,6)

  ! Allocatables
  integer,          allocatable, save :: ktrack(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: strack(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: strackc(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: stracks(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: strackx(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: strackz(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: dpsv1(:)   ! (npart)

  ! Linear Optics
  real(kind=fPrec), allocatable, save :: tbetax(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: tbetay(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: talphax(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: talphay(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: torbx(:)   ! (nblz)
  real(kind=fPrec), allocatable, save :: torby(:)   ! (nblz)
  real(kind=fPrec), allocatable, save :: torbxp(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: torbyp(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: tdispx(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: tdispy(:)  ! (nblz)
  real(kind=fPrec), allocatable, save :: tdispxp(:) ! (nblz)
  real(kind=fPrec), allocatable, save :: tdispyp(:) ! (nblz)

  ! Substitute variables for x,y and is for DA version
  real(kind=fPrec), save :: xxtr(mpa,2)
  real(kind=fPrec), save :: yytr(mpa,2)

contains

subroutine mod_commont_expand_arrays(nblz_new,npart_new)

  use mod_alloc
  use numerical_constants, only : zero

  implicit none

  integer, intent(in) :: nblz_new
  integer, intent(in) :: npart_new

  call alloc(ktrack,  nblz_new,  0,    "ktrack")
  call alloc(strack,  nblz_new,  zero, "strack")
  call alloc(strackc, nblz_new,  zero, "strackc")
  call alloc(stracks, nblz_new,  zero, "stracks")
  call alloc(strackx, nblz_new,  zero, "strackx")
  call alloc(strackz, nblz_new,  zero, "strackz")

  call alloc(tbetax,  nblz_new,  zero, "tbetax")
  call alloc(tbetay,  nblz_new,  zero, "tbetay")
  call alloc(talphax, nblz_new,  zero, "talphax")
  call alloc(talphay, nblz_new,  zero, "talphay")
  call alloc(torbx,   nblz_new,  zero, "torbx")
  call alloc(torby,   nblz_new,  zero, "torby")
  call alloc(torbxp,  nblz_new,  zero, "torbxp")
  call alloc(torbyp,  nblz_new,  zero, "torbyp")
  call alloc(tdispx,  nblz_new,  zero, "tdispx")
  call alloc(tdispy,  nblz_new,  zero, "tdispy")
  call alloc(tdispxp, nblz_new,  zero, "tdispxp")
  call alloc(tdispyp, nblz_new,  zero, "tdispyp")

  call alloc(dpsv1,   npart_new, zero, "dpsv1")

end subroutine mod_commont_expand_arrays

! Copy from actual variables to temp DA variables
subroutine comt_daStart
  xxtr(1:mpa,1:2) = x(1:mpa,1:2)
  yytr(1:mpa,1:2) = y(1:mpa,1:2)
end subroutine comt_daStart

! Copy from temp DA variables to actual variables
subroutine comt_daEnd
  x(1:mpa,1:2) = xxtr(1:mpa,1:2)
  y(1:mpa,1:2) = yytr(1:mpa,1:2)
end subroutine comt_daEnd

end module mod_common_track

! ================================================================================================ !
!  Main Variables Used for Particle Tracking
!  Last modified: 2019-05-09
! ================================================================================================ !
module mod_common_main

  use parpro
  use floatPrecision
  use numerical_constants
  use, intrinsic :: iso_fortran_env, only : int16, int32

  implicit none

  real(kind=fPrec), save :: qw(2)      = zero
  real(kind=fPrec), save :: qwc(3)     = zero
  real(kind=fPrec), save :: clo0(2)    = zero
  real(kind=fPrec), save :: clop0(2)   = zero
  real(kind=fPrec), save :: ekk(2)     = zero
  real(kind=fPrec), save :: cr(mmul)   = zero
  real(kind=fPrec), save :: ci(mmul)   = zero
  real(kind=fPrec), save :: temptr(6)  = zero
  real(kind=fPrec), save :: clo6v(3)   = zero
  real(kind=fPrec), save :: clop6v(3)  = zero
  real(kind=fPrec), save :: tas(6,6)   = zero
  real(kind=fPrec), save :: tasau(6,6) = zero
  real(kind=fPrec), save :: qwcs(3)    = zero
  real(kind=fPrec), save :: di0xs      = zero
  real(kind=fPrec), save :: di0zs      = zero
  real(kind=fPrec), save :: dip0xs     = zero
  real(kind=fPrec), save :: dip0zs     = zero
  real(kind=fPrec), save :: di0au(4)
  real(kind=fPrec), save :: tau(6,6)
  real(kind=fPrec), save :: wx(3)
  real(kind=fPrec), save :: x1(6)
  real(kind=fPrec), save :: x2(6)
  real(kind=fPrec), save :: fake(2,20)
  real(kind=fPrec), save :: xau(2,6)
  real(kind=fPrec), save :: cloau(6)

  !  Arrays
  ! ========

  ! Number of Structure Elements (nblz)
  real(kind=fPrec), allocatable, save :: zsiv(:)       ! Displacement of elements, including error
  real(kind=fPrec), allocatable, save :: xsiv(:)       ! Displacement of elements, including error
  real(kind=fPrec), allocatable, save :: smiv(:)       ! Magnetic kick, including error

  ! Number of Particles (npart)
  real(kind=fPrec), allocatable, save :: xv1(:)        ! Transverse coordinates: Horisontal position
  real(kind=fPrec), allocatable, save :: yv1(:)        ! Transverse coordinates: Horisontal angle
  real(kind=fPrec), allocatable, save :: xv2(:)        ! Transverse coordinates: Vertical position
  real(kind=fPrec), allocatable, save :: yv2(:)        ! Transverse coordinates: Vertical angle
  real(kind=fPrec), allocatable, save :: sigmv(:)      ! Longitudinal coordinate: Position offset
  real(kind=fPrec), allocatable, save :: dpsv(:)       ! Longitudinal coordinate: Momentum offset from reference momentum e0f
  real(kind=fPrec), allocatable, save :: ejfv(:)       ! Particle momentum
  real(kind=fPrec), allocatable, save :: ejv(:)        ! Particle energy

  real(kind=fPrec), allocatable, save :: oidpsv(:)     ! 1/(1+dpsv)
  real(kind=fPrec), allocatable, save :: moidpsv(:)    ! Relative rigidity offset
  real(kind=fPrec), allocatable, save :: omoidpsv(:)   ! Relative rigidity offset
  real(kind=fPrec), allocatable, save :: rvv(:)        ! Beta_0 / Beta(j)
  real(kind=fPrec), allocatable, save :: ejf0v(:)      ! Temporary array for momentum updates
  real(kind=fPrec), allocatable, save :: dam(:)        ! Distance in phase space
  real(kind=fPrec), allocatable, save :: dpd(:)        ! Thick tracking only: 1+dpsv
  real(kind=fPrec), allocatable, save :: dpsq(:)       ! Thick tracking only: sqrt(1+dpsv)
  real(kind=fPrec), allocatable, save :: ampv(:)       ! Amplitude variations
  real(kind=fPrec), allocatable, save :: nucm(:)       ! Particle mass
  real(kind=fPrec), allocatable, save :: mtc(:)        ! Mass-to-charge ratio

  real(kind=fPrec), allocatable, save :: spin_x(:)     ! x component of the particle spin
  real(kind=fPrec), allocatable, save :: spin_y(:)     ! y component of the particle spin
  real(kind=fPrec), allocatable, save :: spin_z(:)     ! z component of the particle spin

  integer(kind=int32), allocatable, save :: nqq(:)     ! Particle charge
  integer(kind=int32), allocatable, save :: naa(:)     ! Ion atomic mass
  integer(kind=int32), allocatable, save :: nzz(:)     ! Ion atomic number
  integer(kind=int32), allocatable, save :: pdgid(:)   ! Particle PDGid

  integer,          allocatable, save :: numxv(:)      ! Turn in which a particle was lost

! The following variables are int32 for usage with the FLUKA IO TCP/IP communication
! If these are to be changed, remember to also update the FLUKA IO C code (and the CR variables).
! Also update the root output and geant4 interface (all fixed to int32s currently)
  integer(kind=int32), allocatable, save :: partID(:)   ! Particle ID
  integer(kind=int32), allocatable, save :: parentID(:) ! Particle parent ID in case of secondary particles
  integer(kind=int32), save :: MaximumPartID            ! Maximum used particle ID
  real(kind=fPrec),    allocatable, save :: partWeight(:) ! Particle weighting for FLUKA and geant4

  integer,          allocatable, save :: pairID(:,:)   ! The original particle pair ID for a particle
  integer,          allocatable, save :: pairMap(:,:)  ! A reverse map for pairID to index
  logical,          allocatable, save :: pstop(:)      ! Particle lost flag (post-processing)
  logical,          allocatable, save :: llostp(:)     ! Particle lost flag
  real(kind=fPrec), allocatable, save :: aperv(:,:)    ! Aperture at loss
  integer,          allocatable, save :: iv(:)         ! Entry in the sequence where loss occured

  real(kind=fPrec), allocatable, save :: bl1v(:,:,:,:) ! Thick tracking only: Transfer matrix for linear tracking (6,2,npart,nblo)

contains

subroutine mod_commonmn_expand_arrays(nblz_new,npart_new)

  use mod_alloc
  use mod_common, only : nucm0, aa0, zz0, qq0, pdgid0
  use numerical_constants, only : zero, one

  implicit none

  integer, intent(in) :: nblz_new
  integer, intent(in) :: npart_new

  integer :: nblz_prev  = -2
  integer :: npart_prev = -2
  integer npair_new

  npair_new = (npart_new+1)/2

  if(nblz_new /= nblz_prev) then
    call alloc(smiv,     nblz_new,     zero,    "smiv")
    call alloc(zsiv,     nblz_new,     zero,    "zsiv")
    call alloc(xsiv,     nblz_new,     zero,    "xsiv")
  end if

  if(npart_new /= npart_prev) then
    call alloc(xv1,        npart_new, zero,    "xv1")
    call alloc(yv1,        npart_new, zero,    "yv1")
    call alloc(xv2,        npart_new, zero,    "xv2")
    call alloc(yv2,        npart_new, zero,    "yv2")
    call alloc(sigmv,      npart_new, zero,    "sigmv")
    call alloc(dpsv,       npart_new, zero,    "dpsv")
    call alloc(ejv,        npart_new, zero,    "ejv")
    call alloc(ejfv,       npart_new, zero,    "ejfv")
    call alloc(dam,        npart_new, zero,    "dam")
    call alloc(rvv,        npart_new, one,     "rvv")
    call alloc(ejf0v,      npart_new, zero,    "ejf0v")
    call alloc(numxv,      npart_new, 0,       "numxv")
    call alloc(partID,     npart_new, 0,       "partID")
    call alloc(parentID,   npart_new, 0,       "parentID")
    call alloc(partWeight, npart_new, one,     "partWeight")
    call alloc(pairID,  2, npart_new, 0,       "pairID")
    call alloc(pairMap, 2, npair_new, 0,       "pairMap")
    call alloc(pstop,      npart_new, .false., "pstop")
    call alloc(llostp,     npart_new, .false., "llostp")
    call alloc(dpd,        npart_new, zero,    "dpd")
    call alloc(dpsq,       npart_new, zero,    "dpsq")
    call alloc(oidpsv,     npart_new, one,     "oidpsv")
    call alloc(moidpsv,    npart_new, one,     "moidpsv")
    call alloc(omoidpsv,   npart_new, zero,    "omoidpsv")
    call alloc(nucm,       npart_new, zero,    "nucm")
    call alloc(mtc,        npart_new, nucm0,   "mtc")
    call alloc(spin_x,     npart_new, zero,    "spin_x")
    call alloc(spin_y,     npart_new, zero,    "spin_y")
    call alloc(spin_z,     npart_new, zero,    "spin_z")
    call alloc(naa,        npart_new, aa0,     "naa")
    call alloc(nzz,        npart_new, zz0,     "nzz")
    call alloc(nqq,        npart_new, qq0,     "nqq")
    call alloc(pdgid,      npart_new, pdgid0,  "pdgid")
    call alloc(ampv,       npart_new, zero,    "ampv")
    call alloc(aperv,   2, npart_new, zero,    "aperv")
    call alloc(iv,         npart_new, 0,       "iv")
  end if

  nblz_prev  = nblz_new
  npart_prev = npart_new

end subroutine mod_commonmn_expand_arrays

subroutine mod_commonmn_expand_thickarrays(npart_new, nblo_new)

  use mod_alloc
  use numerical_constants, only : zero

  implicit none

  integer,intent(in) :: npart_new, nblo_new

  call alloc(bl1v,6,2,npart_new,nblo_new,zero,"bl1v")

end subroutine mod_commonmn_expand_thickarrays

end module mod_common_main

! ================================================================================================ !
!  SOMETHING-SOMETHING COMMON VARIABLES
!  Last modified: 2018-06-13
! ================================================================================================ !
module mod_commons

  use parpro
  use floatPrecision
  use numerical_constants

  implicit none

  real(kind=fPrec), allocatable, save :: as(:,:,:,:) ! (6,2,npart,nele)
  real(kind=fPrec), allocatable, save :: al(:,:,:,:) ! (6,2,npart,nele)
  real(kind=fPrec), allocatable, save :: at(:,:,:,:) ! (6,2,npart,nele)
  real(kind=fPrec), allocatable, save :: a2(:,:,:,:) ! (6,2,npart,nele)

  real(kind=fPrec), save :: sigm(mpa) = zero
  real(kind=fPrec), save :: dps(mpa)  = zero
  real(kind=fPrec), save :: chi0      = zero  ! Starting phase of the initial coordinate
  real(kind=fPrec), save :: chid      = zero  ! Phase difference between first and second particles
  real(kind=fPrec), save :: exz(2,6)  = zero
  real(kind=fPrec), save :: dp1       = zero
  integer,          save :: idz(2)    = [1,0] ! Coupling on/off
  integer,          save :: itra      = 0     ! Number of particles

contains

subroutine mod_commons_expand_thickarrays(nele_new, npart_new)

  use mod_alloc
  use numerical_constants, only : zero

  implicit none

  integer,intent(in) :: nele_new, npart_new

  call alloc(al,6,2,npart_new,nele_new,zero,"al")
  call alloc(as,6,2,npart_new,nele_new,zero,"as")
  call alloc(at,6,2,2,        nele_new,zero,"at")
  call alloc(a2,6,2,2,        nele_new,zero,"a2")

end subroutine mod_commons_expand_thickarrays

end module mod_commons

! ================================================================================================ !
!  MAIN COMMON VARIABLES
!  Last modified: 2018-06-13
! ================================================================================================ !
module mod_commond2

  use floatPrecision
  use parpro, only : nele, nema
  use crcoall
  use numerical_constants

  implicit none

  !Note: These only to be neccessary for thick4d?
  real(kind=fPrec), allocatable, save :: ald6(:,:,:,:), asd6(:,:,:,:) !(nele,2,6,nema)

contains

subroutine mod_commond2_expand_arrays(nele_new)

  use mod_alloc

  implicit none

  integer, intent(in) :: nele_new

  call alloc(ald6,nele_new,2,6,nema,zero,'ald6')
  call alloc(asd6,nele_new,2,6,nema,zero,'asd6')

end subroutine mod_commond2_expand_arrays

end module mod_commond2

! ================================================================================================ !
!  LIELIB AND DABNEW COMMON VARIABLES
!  Last modified: 2018-06-11
! ================================================================================================ !
module mod_lie_dab

  use floatPrecision

  implicit none

  ! From lielib
  integer, parameter :: ndim  = 3
  integer, parameter :: ndim2 = 6
  integer, parameter :: ntt   = 40
  integer, parameter :: nreso = 20

  integer,          save :: nd,nd2,no,nv
  integer,          save :: ifilt,idpr,iref,itu
  integer,          save :: lienot,iflow,jtune
  integer,          save :: ndc,ndc2,ndpt,ndt
  integer,          save :: nplane(ndim),ista(ndim),idsta(ndim)
  integer,          save :: mx(ndim,nreso),nres
  real(kind=fPrec), save :: epsplane,xplane(ndim)
  real(kind=fPrec), save :: sta(ndim),dsta(ndim),angle(ndim),radn(ndim)
  real(kind=fPrec), save :: ps(ndim),rads(ndim)
  real(kind=fPrec), save :: xintex(0:20)

  ! From dabnew
  integer, save      :: lda = -1
  integer, save      :: lst = -1
  integer, save      :: lea = -1
  integer, save      :: lia = -1
  integer, save      :: lno = -1
  integer, parameter :: lnv = 40

  integer,                       save :: ndat,nda,ndamaxi,lfi
  integer,                       save :: nst,nomax,nvmax,nmmax,nocut
  integer,          allocatable, save :: idano(:),idanv(:),idapo(:)
  integer,          allocatable, save :: idalm(:),idall(:)
  integer,          allocatable, save :: i1(:),i2(:)
  integer,          allocatable, save :: ie1(:),ie2(:),ieo(:),ifi(:)
  integer,          allocatable, save :: ia1(:),ia2(:)
  logical,          allocatable, save :: allvec(:)
  character(len=:), allocatable, save :: daname(:)
  real(kind=fPrec), allocatable, save :: cc(:),facint(:)
  real(kind=fPrec),              save :: eps,epsmac

  ! dascr variables
  integer,           save :: idao
  integer,           save :: iscrda(100)
  integer,           save :: iscrri(100)
  real(kind=fPrec),  save :: rscrri(100)

contains

subroutine mld_allocArrays(da_version)

  use mod_alloc
  use numerical_constants, only : zero

  implicit none

  logical, intent(in) :: da_version

  if(da_version) then
    lda = 10000
    lst = 20050000
    lea = 100000
    lia = 10000000
    lno = 120
  else
    lda = 10000
    lst = 200000
    lea = 500
    lia = 10000
    lno = 120
  end if

  call alloc(idano,lda,0,"idano")
  call alloc(idanv,lda,0,"idanv")
  call alloc(idapo,lda,0,"idapo")
  call alloc(idalm,lda,0,"idalm")
  call alloc(idall,lda,0,"idall")

  call alloc(i1,lst,0,"i1")
  call alloc(i2,lst,0,"i2")

  call alloc(ie1,lea,0,"ie1")
  call alloc(ie2,lea,0,"ie2")
  call alloc(ieo,lea,0,"ieo")
  call alloc(ifi,lea,0,"ifi")

  call alloc(ia1,lia,0,"ia1",0)
  call alloc(ia2,lia,0,"ia2",0)

  call alloc(allvec,   lda,.false.,     "allvec")
  call alloc(daname,10,lda,"          ","daname")

  call alloc(cc,    lst,zero,"cc")
  call alloc(facint,lno,zero,"facint",0)

end subroutine mld_allocArrays

end module mod_lie_dab

subroutine pyfluka_init(n_alloc, debug_level, cwd_path)
    use mod_fluka
    !, only : fluka_enable, fluka_mod_init
    use physical_constants, only : clight
    use mod_units, only : units_path

    implicit none
    integer, intent(in)    :: n_alloc
    integer, intent(in)    :: debug_level
    character(len=255), intent(in) :: cwd_path

    ! NB: In SixTrack, npart was passed, not n_alloc.
    ! (Needed for e.g. avoiding to re-compile?)
    units_path = cwd_path
    fluka_debug_level  = debug_level

    call fluka_mod_init(n_alloc, 500, clight)
    fluka_enable = .true.
end subroutine


subroutine pyfluka_connect(timeout_sec)
    use crcoall
    use mod_fluka
    !, only : fluka_connect, fluka_connected

    implicit none

    integer fluka_con
    integer(kind=4), intent(in) :: timeout_sec

    ! start connection to FLUKA and initialise max ID
    if(fluka_enable) then
       fluka_con = fluka_is_running()
       if(fluka_con == -1) then
          write(lout,"(a)") "FLUKA> ERROR Fluka is expected to run but it is NOT actually the case"
          flush(lout)
          call fluka_close
       end if
       if(fluka_debug_level > 0) then
           write(unit_pyfluka,"(a)") "FLUKA> Initializing FlukaIO interface"
           flush(unit_pyfluka)
       end if
       fluka_con = fluka_connect(timeout_sec)
       if(fluka_con == -1) then
          write(lout,"(a)") "FLUKA> ERROR Cannot connect to Fluka server"
          flush(lout)
          call fluka_close
       endif
       if(fluka_debug_level > 0) then
          write(unit_pyfluka,"(a)") "FLUKA> Successfully connected to Fluka server"
          flush(unit_pyfluka)
       end if
       fluka_connected = .true.
    endif

end subroutine


subroutine pyfluka_close()
    use mod_fluka
    !, only : fluka_close

    implicit none

    call fluka_close

end subroutine


subroutine pyfluka_init_max_uid(npart)
    use crcoall
    use mod_fluka
    !, only : fluka_init_max_uid, fluka_enable

    implicit none
    integer, intent(in)    :: npart
    integer fluka_con

    ! P.Garcia Ortega, A.Mereghetti and V.Vlachoudis, for the FLUKA Team
    ! last modified: 26-08-2014
    ! send npart to fluka
    if(fluka_enable) then
       if(fluka_debug_level > 0) then
           write(unit_pyfluka,"(a,i0)") "FLUKA> Sending npart = ",npart
           flush(unit_pyfluka)
       end if
       ! IMPORTANT: The call to fluka_init_max_uid is absolutely needed.
       ! The FLUKA server looks (in order!) for the corresponding message.
       fluka_con = fluka_init_max_uid( npart )

       if(fluka_con < 0) then
          write(lout,"(a,i0,a,i0,a)") "FLUKA> ERROR ", fluka_con, ": Failed to send npart ",npart," to fluka "
          flush(lout)
          call fluka_close
       end if

       if(fluka_debug_level > 0) then
           write(unit_pyfluka,"(a)") "FLUKA> Sending npart successful"
           flush(unit_pyfluka)
       end if
       flush(lout)
    end if

end subroutine


subroutine pyfluka_set_synch_part(part_e0, part_pc0, part_mass0, part_a0, part_z0, part_q0)
    use crcoall
    use mod_common
    use mod_fluka

    implicit none
    integer fluka_con

    real(kind=8),    intent(in) :: part_e0, part_pc0, part_mass0
    integer(kind=4), intent(in) :: part_a0, part_z0, part_q0

    ! A.Mereghetti and D.Sinuela Pastor, for the FLUKA Team
    ! last modified: 18-01-2016
    ! initialise energy/momentum/rest mass of reference particle in mod_fluka
    !     and synch magnetic rigidity with Fluka (for the time being, consider
    !     only protons);
    if(fluka_enable) then
       if(fluka_debug_level > 0) then
           write(unit_pyfluka,"(a)") "FLUKA> Updating the reference particle"
           flush(unit_pyfluka)
       end if

       ! Optional: Let's also set the reference particle in mod_common, like was done in SixTrack.
       ! Default values for e0 and e0f are 0!
       ! Will only be needed when/if e0f etc become used in mod_fluka.f90.
       e0 = part_e0
       e0f = part_pc0
       nucm0 = part_mass0
       aa0 = part_a0
       zz0 = part_z0
       qq0 = part_q0

       ! IMPORTANT: The call to fluka_set_synch_part is absolutely needed.
       ! The FLUKA server looks (in order!) for the corresponding message.
       fluka_con = fluka_set_synch_part(part_e0, part_pc0, part_mass0, part_a0, part_z0, part_q0)

       if(fluka_con < 0) then
          write(lout,"(a,i0,a)") "FLUKA> ERROR ", fluka_con, ": Failed to update the reference particle"
          flush(lout)
          call fluka_close
       end if

       if(fluka_debug_level > 0) then
           write(unit_pyfluka,"(a)") "FLUKA> Updating the reference particle successful"
           flush(unit_pyfluka)
       end if
    end if

end subroutine


subroutine track_fluka(turn, fluka_id, length, alive_part, max_part, x_part, xp_part, y_part, yp_part, &
                       zeta_part, e_part, m_part, q_part, A_part, Z_part, pdg_id_part, part_id, parent_id, &
                       part_weight, spin_x_part, spin_y_part, spin_z_part)

    use floatPrecision
    use numerical_constants, only : zero, one, c1e3, c1m3
    use crcoall
    use parpro
    use mod_common
    use mod_common_track
    use mod_common_main
    use mod_fluka

    implicit none

    integer(kind=4), intent(in)    :: turn
    integer(kind=2), intent(in)    :: fluka_id
    real(kind=8),    intent(in)    :: length
    integer,         intent(inout) :: alive_part           ! napx
    integer,         intent(in)    :: max_part             ! npart
    real(kind=8),    intent(inout) :: x_part(max_part)     ! [mm]    xv1
    real(kind=8),    intent(inout) :: xp_part(max_part)    ! [1e-3]  yv1
    real(kind=8),    intent(inout) :: y_part(max_part)     ! [mm]    xv2
    real(kind=8),    intent(inout) :: yp_part(max_part)    ! [1e-3]  yv2
    real(kind=8),    intent(inout) :: zeta_part(max_part)  ! [mm]    sigmv
    real(kind=8),    intent(inout) :: e_part(max_part)     ! [MeV]   ejv   (ejfv is momentum, dpsv is delta, oidpsv is 1/(1+d))
    real(kind=8),    intent(inout) :: m_part(max_part)     ! [MeV]   nucm
    integer(kind=2), intent(inout) :: q_part(max_part)     !         nqq     Charge
    integer(kind=4), intent(inout) :: A_part(max_part)     !         naa     Ion atomic mass
    integer(kind=4), intent(inout) :: Z_part(max_part)     !         nzz     Ion atomic number
    integer(kind=4), intent(inout) :: pdg_id_part(max_part) !         pdgid   Particle PDGid
    integer(kind=4), intent(inout) :: part_id(max_part)
    integer(kind=4), intent(inout) :: parent_id(max_part)
    real(kind=8),    intent(inout) :: part_weight(max_part)
    real(kind=8),    intent(inout) :: spin_x_part(max_part)  ! spin_x  ! x component of the particle spin
    real(kind=8),    intent(inout) :: spin_y_part(max_part)  ! spin_y  ! y component of the particle spin
    real(kind=8),    intent(inout) :: spin_z_part(max_part)  ! spin_z  ! z component of the particle spin

    integer ret

    npart = max_part
    napx = alive_part

    ret = fluka_send_receive(turn, fluka_id, length, alive_part, max_part, x_part, y_part, xp_part, yp_part, &
                           zeta_part, e_part, A_part, Z_part, m_part, q_part, pdg_id_part, &
                           part_id, parent_id, part_weight, spin_x_part, spin_y_part, spin_z_part )
    napx = alive_part

    if (ret.lt.0) then
        write(lout,*) 'FLUKA> ERROR ', ret, ' in Fluka communication returned by fluka_send_receive...'
        write(lout,*) 'ENDED WITH ERROR.'
        flush(lout)
    end if

    return
end subroutine track_fluka

module mod_pdgid

  implicit none

contains

! Calculates the  PDG id number given A + Z
subroutine CalculatePDGid(id, a, z)

  use, intrinsic :: iso_fortran_env

  integer(kind=int32), intent(out) :: id
  integer(kind=int32), intent(in) :: a
  integer(kind=int32), intent(in) :: z

  !Nuclear codes are given as 10-digit numbers ±10LZZZAAAI.

  if(a == 1 .and. z == 1) then
    id = 2212
    return
  end if
  id = 1000000000 + int(a,int32)*10 + int(z,int32)*10000

end subroutine CalculatePDGid

! Calculates the A + Z given a PDG id number
subroutine CalculateAZ(id, a, z)

  use, intrinsic :: iso_fortran_env

  integer(kind=int32), intent(in) :: id
  integer(kind=int32), intent(out) :: a
  integer(kind=int32), intent(out) :: z

  integer(kind=int32) :: z1,z2,z3
  integer(kind=int32) :: a1,a2,a3
  integer(kind=int32) :: tmpid

  if(id == 2212) then
    a = 1
    z = 1
    return
  end if

  if(id < 1000000000) then
    a = 0
    z = 0
    return
  end if

  tmpid = id - 1000000000

  tmpid = tmpid / 10
  a1 = mod(tmpid,10_int32)

  tmpid = tmpid / 10
  a2 = mod(tmpid,10_int32)

  tmpid = tmpid / 10
  a3 = mod(tmpid,10_int32)

  a = a1 + 10*a2 + 100*a3

  tmpid = tmpid / 10
  z1 = mod(tmpid,10_int32)

  tmpid = tmpid / 10
  z2 = mod(tmpid,10_int32)

  tmpid = tmpid / 10
  z3 = mod(tmpid,10_int32)

  z = z1 + 10*z2 + 100*z3

end subroutine CalculateAZ

!Learn to speak "FLUKA"
subroutine GetFLUKAid_fromPDG(pdgid, fluka_id)

  use, intrinsic :: iso_fortran_env

  use crcoall

  integer(kind=int32), intent(in)  :: pdgid
  integer(kind=int32), intent(out) :: fluka_id

  integer(kind=int32) :: A
  integer(kind=int32) :: Z

  !Only way is to do an A->B translation using the numbers in the FLUKA manual
  !FM.pdf "Table 5.1: Fluka particle names and code numbers"

  if(pdgid == 2212) then
    !proton
    fluka_id = 1

  else if(pdgid == -2212) then
    !anti proton
    fluka_id = 2

  else if(pdgid == 11) then
    !electron
    fluka_id = 3

  else if(pdgid == -11) then
    !positron
    fluka_id = 4

  !5 to 9 are neutrals

  else if(pdgid == -13) then
    !mu+
    fluka_id = 10

  else if(pdgid == 13) then
    !mu-
    fluka_id = 11

  else if(pdgid == 211) then
    !pi+
    fluka_id = 13

  else if(pdgid == -211) then
    !pi-
    fluka_id = 14

  else if(pdgid == 321) then
    !k+
    fluka_id = 15

  else if(pdgid == -321) then
    !k-
    fluka_id = 16

  else if(pdgid == 3122) then
    !lambda
    fluka_id = 17

  else if(pdgid == -3122) then
    !anti lambda
    fluka_id = 18

  else if(pdgid == 3112) then
    !sigma-
    fluka_id = 20

  else if(pdgid == 3222) then
    !sigma+
    fluka_id = 21

  else if(pdgid == -3222) then
    !anti-sigma-
    fluka_id = 31

  else if(pdgid == -3112) then
    !anti-sigma+
    fluka_id = 33

  else if(pdgid == 3312) then
    !Xi-
    fluka_id = 36

  else if(pdgid == -3312) then
    !Xi+
    fluka_id = 37

  else if(pdgid == 3334) then
    !Omega-
    fluka_id = 38

  else if(pdgid == -3334) then
    !anti omega
    fluka_id = 39

  else if(pdgid == -15) then
    !tau+
    fluka_id = 41

  else if(pdgid == 15) then
    !tau-
    fluka_id = 42

  else if(pdgid > 1000000000) then
    !ion
    call CalculateAZ(pdgid, A, Z)

    if(Z == 1) then

      if(A == 1) then
        !Protons, etc
        fluka_id = 1
      else if(A == 2) then
        fluka_id = -3
      else if(A == 3) then
        fluka_id = -4
      else
        fluka_id = -2
      end if

    else if(Z == 2) then
      !Helium, etc
      if(A == 3) then
        fluka_id = -5
      else if(A == 4) then
        fluka_id = -6
      else
        fluka_id = -2
      end if

    else
      !Generic heavy ion
      fluka_id = -2
    end if
  else
    !something else
    write(lerr,"(a,i0,a)") "PDGID> ERROR Unknown particle ID ",pdgid," in FLUKA conversion"
    ERROR STOP 'ENDED WITH ERROR.'
  end if

end subroutine GetFLUKAid_fromPDG


!FLUKA -> PDGid conversion
subroutine GetPDGid_fromFLUKA(fluka_id, pdg_id, A, Z)

  use, intrinsic :: iso_fortran_env

  use crcoall

  integer(kind=int32), intent(in)  :: fluka_id
  integer(kind=int32), intent(out) :: pdg_id

  integer(kind=int32), intent(in) :: A
  integer(kind=int32), intent(in) :: Z

  !Only way is to do an A->B translation using the numbers in the FLUKA manual
  !FM.pdf "Table 5.1: Fluka particle names and code numbers"

  if(fluka_id == 1) then
    !proton
    pdg_id = 2212

  else if(fluka_id == 2) then
    !anti proton
    pdg_id = -2212

  else if(fluka_id == 3) then
    !electron
    pdg_id = 11

  else if(fluka_id == 4) then
    !positron
    pdg_id = -11

  !5 to 9 are neutrals

  else if(fluka_id == 10) then
    !mu+
    pdg_id = -13

  else if(fluka_id == 11) then
    !mu-
    pdg_id = 13

  else if(fluka_id == 13) then
    !pi+
    pdg_id = 211

  else if(fluka_id == 14) then
    !pi-
    pdg_id = -211

  else if(fluka_id == 15) then
    !k+
    pdg_id = 321

  else if(fluka_id == 16) then
    !k-
    pdg_id = -321

  else if(fluka_id == 17) then
    !lambda
    pdg_id = 3122

  else if(fluka_id == 18) then
    !anti lambda
    pdg_id = -3122

  else if(fluka_id == 20) then
    !sigma-
    pdg_id = 3112

  else if(fluka_id == 21) then
    !sigma+
    pdg_id = 3222

  else if(fluka_id == 31) then
    !anti-sigma-
    pdg_id = -3222

  else if(fluka_id == 33) then
    !anti-sigma+
    pdg_id = -3112

  else if(fluka_id == 36) then
    !Xi-
    pdg_id = 3312

  else if(fluka_id == 37) then
    !Xi+
    pdg_id = -3312

  else if(fluka_id == 38) then
    !Omega-
    pdg_id = 3334

  else if(fluka_id == 39) then
    !anti omega
    pdg_id = -3334

  else if(fluka_id == 41) then
    !tau+
    pdg_id = -15

  else if(fluka_id == 42) then
    !tau-
    pdg_id = 15

  else if(fluka_id == -2 .or. fluka_id == -3 .or. fluka_id == -4 .or. fluka_id == -5 .or. fluka_id == -6) then
    !ion
    call CalculatePDGid(pdg_id, A, Z)

  else
    ! something else
    write(lerr,"(a,i0,a)") "PDGID> ERROR Unknown particle ID ",fluka_id," in PDG ID conversion"
    ERROR STOP 'ENDED WITH ERROR.'
  end if

end subroutine GetPDGid_fromFLUKA

end module mod_pdgid

! =================================================================================================
!  STANDARD OUTPUT MODULE
!  Last modified: 2019-05-08
!  Default to standard output and error, but can be set to other units for CR version
! =================================================================================================
module crcoall
  use, intrinsic :: iso_fortran_env, only : output_unit, error_unit
  implicit none
  integer, public, save :: lout  = output_unit  ! Should be unit 6
  integer, public, save :: lerr  = error_unit   ! Should be unit 0
  integer, public, save :: crlog = -1           ! Writing to this outside of an #ifdef CR will segfault
end module crcoall

! =================================================================================================
!  FLOAT PRECISION MODULE
!  Last modified: 2019-05-08
! =================================================================================================
module floatPrecision






  use, intrinsic :: iso_fortran_env, only : real64
  implicit none
  integer, parameter :: fPrec = real64






end module floatPrecision

! ================================================================================================ !
!  FILE UNITS MODULE
! ===================
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2018-12-13
!  Updated: 2019-05-02
!
!  Module for keeping track of opened file units, their file names, and open the files correctly
!  depending on build flags like BOINC or FIO.
!
!  Note: The maximum number of allowed open units is 256. To ensure we cannot run out of units, the
!  module sets the last assigned unit number to 250. The log file is at 251. this leaves 4 units for
!  debug use in the code, if absolutely necessary.
! ================================================================================================ !
module mod_units

  use parpro, only : mPathName

  implicit none

  logical, public,  save       :: units_beQuiet  = .true.            ! No writing to lout when this flag is .true.
  character(len=255), public   :: units_path = ""                    ! Path prefix for all files opened through this module

  ! Keep track of units
  integer, parameter           :: units_minUnit  = 1                 ! First unit to keep track of
  integer, parameter           :: units_maxUnit  = 250               ! Last unit to keep track of
  integer, parameter           :: units_minAuto  = 100               ! First unit available for dynamic allocation
  integer, private, save       :: units_nextUnit = units_minAuto     ! Next unit available for dynamic allocation
  integer, private, save       :: units_logUnit  = -1                ! File unit for internal log file
  character(len=14), parameter :: units_logFile  = "file_units.log"  ! File name for internal log file

  type, private :: unitRecord
    character(len=:), allocatable, private :: file            ! The requested file name (not BOINC)
    character(len=3),              private :: mode  = " "     ! Read/write mode
    logical,                       private :: taken = .false. ! Whether a unit is known to be taken or not
    logical,                       private :: open  = .false. ! Whether file is opened by the module or not
    logical,                       private :: fixed = .true.  ! Whether the unit was requested as a fixed unit or not
  end type unitRecord

  ! Array to keep track of files
  type(unitRecord), private, save :: units_uList(units_minUnit:units_maxUnit+1)

  private :: f_writeLog

contains

! ================================================================================================ !
!  Initialise Units Module
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-12-13
!  This subroutine opens the log file at the highest unit. Make sure this unit is free!
! ================================================================================================ !
subroutine f_initUnits

  ! All we need to do is open the log file
  units_logUnit  = units_maxUnit+1
  units_uList(units_logUnit)%file  = units_logFile
  units_uList(units_logUnit)%mode  = "w"
  units_uList(units_logUnit)%taken = .true.
  units_uList(units_logUnit)%open  = .true.
  units_uList(units_logUnit)%fixed = .true.

  open(units_logUnit,file=units_logFile,form="formatted",status="replace",action="write")
  write(units_logUnit,"(a)") "# File Units Log"
  write(units_logUnit,"(a)") repeat("#",100)
  write(units_logUnit,"(a)") "#   AtTime  Action    Unit  Status    FileName"
  flush(units_logUnit)
  call f_writeLog("INIT",units_logUnit,"FIXED",units_logFile)

end subroutine f_initUnits

! ================================================================================================ !
!  Request New File Units
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2018-12-13
!  Updated: 2018-12-13
!  Send in a file name, and get a unit back. If the has already been assigned a unit, this is
!  returned. Otherwise, a new unit is selected.
! ================================================================================================ !
subroutine f_requestUnit(file,unit)

  use crcoall

  character(len=*), intent(in)  :: file
  integer,          intent(out) :: unit

  integer i
  logical isOpen

  if(len_trim(file) > mPathName) then
    write(lerr,"(2(a,i0))") "UNITS> ERROR Max length of file path in f_requestUnit is ",mPathName,&
      " characters, got ",len_trim(file)
    !call ERROR STOP 'ENDED WITH ERROR.'
  end if

  unit = -1
  call f_getUnit(file,unit)
  if(unit > 0) then
    call f_writeLog("REQUEST",unit,"EXISTS",trim(file))
    return
  end if

  do i=units_nextUnit,units_maxUnit
    if(units_uList(i)%taken) cycle
    inquire(unit=i, opened=isOpen)
    if(isOpen) then
      if(units_uList(i)%taken .eqv. .false.) then
        units_uList(i)%file  = "unknown"
        units_uList(i)%mode  = ""
        units_uList(i)%taken = .true.
        units_uList(i)%open  = .false.
        units_uList(i)%fixed = .false.
        call f_writeLog("REQUEST",i,"TAKEN",trim(file))
      end if
    else
      unit = i
      exit
    end if
  end do

  if(unit > 0) then
    call f_writeLog("REQUEST",unit,"NEW",trim(file))
    units_uList(unit)%file  = trim(file)
    units_uList(unit)%mode  = ""
    units_uList(unit)%taken = .true.
    units_uList(unit)%open  = .false.
    units_uList(unit)%fixed = .false.
    units_nextUnit = unit + 1
  else
    write(lerr,"(a,i0)") "UNITS> ERROR Could not find an available file unit within the allowed range."
    !call ERROR STOP 'ENDED WITH ERROR.'
  end if

end subroutine f_requestUnit

! ================================================================================================ !
!  Get Existing File Units
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2018-12-13
!  Updated: 2019-05-02
!  Will search through the record for a filename, and return its unit. -1 if it is not assigned.
! ================================================================================================ !
subroutine f_getUnit(file,unit)

  character(len=*), intent(in)  :: file
  integer,          intent(out) :: unit

  integer i

  unit = -1
  do i=units_minUnit,units_maxUnit
    if(allocated(units_uList(i)%file)) then
      if(units_uList(i)%file == trim(file)) then
        unit = i
        exit
      end if
    end if
  end do

end subroutine f_getUnit


pure function units_resolve_path(file) result(full)
  character(len=*), intent(in) :: file
  character(len=:), allocatable :: full
  character(len=:), allocatable :: wd
  integer :: lf

  full = trim(file)

  if (len_trim(full) == 0) return

  ! Absolute path? (POSIX)
  if (full(1:1) == '/') return

  lf = len_trim(units_path)
  if (lf == 0) return

  wd = trim(units_path)
  if (wd(len_trim(wd):len_trim(wd)) == '/') then
    full = wd // full
  else
    full = wd // '/' // full
  end if
end function units_resolve_path



! ================================================================================================ !
!  Open a File
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2018-12-13
!  Updated: 2019-05-02
!  This is a wrapper for Fortran open that also handles all the various build options.
!  The parameters are:
!   - unit      :: The unit number. Either a previously assigned one, or a fixed unit
!   - file      :: The file name. The file name will be checked to ensure that the unit value
!                  matches previous assigned or used unit.
!   - formatted :: .true. for formatted file, .false. for unformatted
!   - mode      :: Short form for action and position keywords.
!                  r, w,and rw correspond to read, write, and readwrite
!                  - corresponds to rewind, + to append, and default is asis
!   - err       :: Optional: If ommitted, errors will cause a call to prror.
!   - status    :: Optional: File status. Defaults to unknown
!   - recl      :: Optional: Record length. Is only used for nagfor
! ================================================================================================ !
subroutine f_open(unit,file,formatted,mode,err,iostat,status,access,recl)

  use crcoall

  integer,                    intent(in)  :: unit
  character(len=*),           intent(in)  :: file
  logical,                    intent(in)  :: formatted
  character(len=*),           intent(in)  :: mode
  logical,          optional, intent(out) :: err
  integer,          optional, intent(out) :: iostat
  character(len=*), optional, intent(in)  :: status
  character(len=*), optional, intent(in)  :: access
  integer,          optional, intent(in)  :: recl

  character(len=:), allocatable :: fFileName, fStatus, fAction, fPosition, fMode, fAccess

  character(len=:), allocatable :: fPath
  integer :: lp
  logical :: is_abs


  integer fRecl, fStat, chkUnit
  logical fFio

  if(present(recl)) then
    fRecl = recl
  else
    fRecl = 0
  end if

  if(present(status)) then
    fStatus = status
  else
    fStatus = "unknown"
  end if

  if(present(access)) then
    fAccess = access
  else
    fAccess = "sequential"
  end if

  if(unit < units_minUnit .or. unit > units_maxUnit) then
    write(lerr,"(3(a,i0),a)") "UNITS> ERROR Unit ",unit," is out of range ",units_minUnit,":",units_maxUnit," in f_open"
    !call prror
  end if

  ! Decide on actual file name to open (prefix with units_path if requested)
  fFileName = units_resolve_path(file)

  if(len_trim(fFileName) > mPathName) then
    write(lerr,"(2(a,i0))") "UNITS> ERROR Max length of file path in f_open is ",mPathName,&
                            " characters, got ",len_trim(fFileName)
  end if


  fFio = .false.

  fRecl = 0

  if(.not. formatted) fFio = .false.

  fMode = mode
  select case(mode)
  case("r")
    fAction   = "read"
    fPosition = "asis"
  case("w")
    fAction   = "write"
    fPosition = "asis"
  case("rw")
    fAction   = "readwrite"
    fPosition = "asis"
  case("r-")
    fAction   = "read"
    fPosition = "rewind"
  case("w-")
    fAction   = "write"
    fPosition = "rewind"
  case("rw-")
    fAction   = "readwrite"
    fPosition = "rewind"
  case("w+")
    fAction   = "write"
    fPosition = "append"
  case("rw+")
    fAction   = "readwrite"
    fPosition = "append"
  case default
    write(lout,"(a)") "UNITS> WARNING Unknown file mode '"//trim(fMode)//"', defaulting to 'r'"
    fMode     = "r"
    fAction   = "read"
    fPosition = "asis"
  end select

  ! Check that we don't have a fixed vs. assigned unit crash
  if(allocated(units_uList(unit)%file)) then
    if(units_uList(unit)%file /= file .and. units_uList(unit)%file /= " ") then
      write(lerr,"(a,i0,a)") "UNITS> ERROR Unit ",unit," has already been assigned to file '"//&
        trim(units_uList(unit)%file)//"' /= '"//trim(file)//"'"
      !call prror
    end if
  end if

  call f_getUnit(trim(file),chkUnit)
  if(chkUnit > 0) then
    ! We already have that file name in the record
    if(chkUnit /= unit) then
      write(lerr,"(a,i0)") "UNITS> ERROR File '"//trim(file)//"' has already been assigned to unit ",chkUnit
      !call prror
    end if
  else
    ! The file is opened with a fixed unit, so save the info
    units_uList(unit)%file  = trim(file)
    units_uList(unit)%mode  = trim(fMode)
    units_uList(unit)%taken = .true.
    units_uList(unit)%open  = .true.
    units_uList(unit)%fixed = .true.
  end if

  if(formatted) then
    if(fRecl > 0) then
      if(fFio) then
        open(unit,file=fFileName,form="formatted",status=fStatus,iostat=fStat,&
          action=fAction,access=fAccess,position=fPosition,round="nearest",recl=fRecl,err=10)
      else
        open(unit,file=fFileName,form="formatted",status=fStatus,iostat=fStat,&
          action=fAction,access=fAccess,position=fPosition,recl=fRecl,err=10)
      end if
    else
      if(fFio) then
        open(unit,file=fFileName,form="formatted",status=fStatus,iostat=fStat,&
          action=fAction,access=fAccess,position=fPosition,round="nearest",err=10)
      else
        open(unit,file=fFileName,form="formatted",status=fStatus,iostat=fStat,&
          action=fAction,access=fAccess,position=fPosition,err=10)
      end if
    end if
  else
    open(unit,file=fFileName,form="unformatted",status=fStatus,iostat=fStat,&
      action=fAction,access=fAccess,position=fPosition,err=10)
  endif

  if(present(iostat)) then
    iostat = fStat
  end if

  if(fStat /= 0) then
    call f_writeLog("OPEN",unit,"ERROR",file)
    if(present(err)) then
      err = .true.
      if(units_beQuiet .eqv. .false.) then
        write(lout,"(a,i0)") "UNITS> File '"//trim(file)//"' reported iostat = ",fStat
      end if
    else
      write(lerr,"(a,i0)") "UNITS> ERROR File '"//trim(file)//"' reported iostat = ",fStat
      !call prror
    end if
  end if

  if(units_uList(unit)%fixed) then
    call f_writeLog("OPEN",unit,"FIXED",file)
  else
    call f_writeLog("OPEN",unit,"ASSIGNED",file)
  end if
  if(present(err)) then
    err = .false.
  end if

  return

10 continue
  call f_writeLog("OPEN",unit,"ERROR",file)
  if(present(iostat)) then
    iostat = fStat
  end if
  if(present(err)) then
    err = .true.
    if(units_beQuiet .eqv. .false.) then
      write(lout,"(a)") "UNITS> Could not open '"//trim(file)//"'"
    end if
  else
    write(lerr,"(a)") "UNITS> ERROR Could not open '"//trim(file)//"'"
    !call prror
  end if

end subroutine f_open

! ================================================================================================ !
!  Close File Units
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2018-12-13
!  Updated: 2019-10-10
!  Preferred method for closing file as it keeps the record up to date
! ================================================================================================ !
subroutine f_close(unit, cErr)

  use crcoall

  integer,           intent(in)  :: unit
  logical, optional, intent(out) :: cErr

  integer ioStat
  logical isOpen

  if(unit < units_minUnit .or. unit > units_maxUnit) then
    write(lerr,"(3(a,i0),a)") "UNITS> ERROR Unit ",unit," is out of range ",units_minUnit,":",units_maxUnit," in f_close"
    !call prror
  end if

  if(present(cErr)) then
    cErr = .false.
  end if

  inquire(unit=unit, opened=isOpen)
  if(isOpen) then
    if(units_uList(unit)%taken) then
      call f_writeLog("CLOSE",unit,"CLOSED",units_uList(unit)%file)
    else
      call f_writeLog("CLOSE",unit,"CLOSED","*** Unknown File ***")
    end if
    flush(unit)
    close(unit, iostat=ioStat)
    if(ioStat == 0) then
      units_uList(unit)%open = .false.
    else
      if(units_uList(unit)%taken) then
        write(lerr,"(a,i0)") "UNITS> ERROR Failed to close file '"//trim(units_uList(unit)%file)//"', status code ",ioStat
        call f_writeLog("CLOSE",unit,"ERROR",units_uList(unit)%file)
      else
        write(lerr,"(2(a,i0))") "UNITS> ERROR Failed to close file unit ",unit,", status code ",ioStat
        call f_writeLog("CLOSE",unit,"ERROR","*** Unknown File ***")
      end if
      if(present(cErr)) then
        cErr = .true.
      end if
    end if
  else
    if(units_uList(unit)%taken) then
      call f_writeLog("CLOSE",unit,"NOTOPEN",units_uList(unit)%file)
    else
      call f_writeLog("CLOSE",unit,"NOTOPEN","*** Unknown File ***")
    end if
  end if

end subroutine f_close

! ================================================================================================ !
!  Free File Units
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-05-02
!  Updated: 2019-05-02
!  Free a file unit so that it can be assigned again. This implies close.
! ================================================================================================ !
subroutine f_freeUnit(unit)

  use crcoall

  integer, intent(in) :: unit

  logical isOpen

  if(unit < units_minUnit .or. unit > units_maxUnit) then
    write(lerr,"(3(a,i0),a)") "UNITS> ERROR Unit ",unit," is out of range ",units_minUnit,":",units_maxUnit," in f_close"
    !call prror
  end if

  inquire(unit=unit, opened=isOpen)
  if(isOpen) then
    call f_close(unit)
  end if

  call f_writeLog("FREE",unit,"FREED",units_uList(unit)%file)

  units_uList(unit)%file  = " "
  units_uList(unit)%mode  = " "
  units_uList(unit)%taken = .false.
  units_uList(unit)%open  = .false.
  units_uList(unit)%fixed = .true.

end subroutine f_freeUnit

! ================================================================================================ !
!  Flush Single or All File Units
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-12-13
! ================================================================================================ !
subroutine f_flush(unit)

  implicit none

  integer, optional, intent(in) :: unit

  integer i
  logical isOpen

  if(present(unit)) then
    inquire(unit=unit, opened=isOpen)
    if(isOpen) flush(unit)
    return
  end if

  do i=units_minUnit,units_maxUnit
    inquire(unit=i, opened=isOpen)
    if(isOpen) flush(i)
  end do

end subroutine f_flush

! =================================================================================================
!  Reposition Text File
!
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Created: 2019-07-24
!  Updated: 2019-12-19
!
!  The routine was moved from Scatter Module, and was originally intended for Checkpoint/Restart,
!  but should also work outside of C/R.
!
!  Parameters:
!   * fileName : The file name of the file to be opened. Needed both to ensure not multiple units
!                is assigned, and to make log messages more readable.
!   * fileUnit : The file unit variable for the file. The unit can be assigned already, but must
!                not be open. This routine opens the file, and returns the unit.
!   * filePos  : The file position variable used to track the latest position in the file. This is
!                the variable the calling code must keep track on and checkpoint.
!   * newPos   : The desired position the file should be truncated to. This is the value the
!                calling code should restore from checkpoint file. It is the checkpointed value of
!                filePos.
! =================================================================================================
subroutine f_positionFile(fileName, fileUnit, filePos, newPos)

  use parpro
  use crcoall

  character(len=*), intent(in)    :: fileName
  integer,          intent(inout) :: fileUnit
  integer,          intent(inout) :: filePos
  integer,          intent(in)    :: newPos

  logical isOpen, fErr
  integer iError
  integer j
  character(len=mInputLn) aRecord

  call f_requestUnit(fileName,fileUnit)
  inquire(unit=fileUnit,opened=isOpen)
  if(isOpen) then





    write(lerr, "(a,i0,a)") "UNITS> ERROR Failed while repositioning '"//trim(fileName)//"', "//&
      "unit ",fileUnit," already in use"
    !call prror
  end if

  if(newPos /= -1) then
    call f_open(unit=fileUnit,file=fileName,formatted=.true.,mode="rw",err=fErr,iostat=iError,status="old")
    if(fErr) goto 10
    filePos = 0
    do j=1,newPos
      read(fileUnit,"(a)",end=10,err=10,iostat=iError) aRecord
      filePos = filePos + 1
    end do
    ! Truncate file at requested position
    endfile(fileUnit,iostat=iError)
    call f_close(fileUnit)

    ! Re-open for appending
    call f_open(unit=fileUnit,file=fileName,formatted=.true.,mode="w+",err=fErr,iostat=iError,status="old")
    if(fErr) goto 10




    write(lout, "(2(a,i0))") "UNITS> Sucessfully repositioned '"//trim(fileName)//"': "//&
      "Position: ",filePos,", Position C/R: ",newPos
  else




    write(lout, "(a,i0)") "UNITS> Did not attempt repositioning '"//trim(fileName)//"' at line ",newPos
    write(lout, "(a)")    "UNITS> If anything has been written to the file, it will be correctly truncated"
  end if




  flush(lout)

  return

10 continue





  write(lerr, "(a,i0)")    "UNITS> ERROR While reading '"//trim(fileName)//"', iostat = ",iError
  write(lerr, "(2(a,i0))") "UNITS>       Current position: ",filePos,", requested position: ",newPos
  !call prror

end subroutine f_positionFile

! ================================================================================================ !
!  Internal Log File Writer
!  V.K. Berglyd Olsen, BE-ABP-HSS
!  Last modified: 2018-12-13
! ================================================================================================ !
subroutine f_writeLog(action,unit,status,file)

  use parpro
  use floatPrecision

  character(len=*), intent(in) :: action
  integer,          intent(in) :: unit
  character(len=*), intent(in) :: status
  character(len=*), intent(in) :: file

  real(kind=fPrec)         cpuTime
  character(len=8)         wAction
  character(len=8)         wStatus
  character(len=mFileName) wFile
  integer                  cFile

  if(units_logUnit <= 0) return ! Only write if we have a log file open

  wAction = action
  wStatus = status

  cFile = len_trim(file)
  if(cFile > mFileName) then
    wFile = "[...]"//file(cFile-mFileName+5:cFile)
  else
    wFile = file
  end if

  call cpu_time(cpuTime)
  write(units_logUnit,"(f10.3,2x,a8,2x,i4,2x,a8,2x,a)") cpuTime,adjustl(wAction),unit,adjustl(wStatus),trim(wFile)
  flush(units_logUnit)

end subroutine f_writeLog

end module mod_units

      program client
      implicit none

      integer PORT
      integer NPARTS, NTURNS
      parameter (PORT = 14999)
      parameter (NPARTS = 20000, NTURNS = 150)

      integer i, j, n
      integer cid

      integer mtype
      integer turn, id, gen
      double precision wgt, x, y, z, tx, ty, tz, m, pc, t
      integer aa, zz
      integer ntconnect, ntsendp, ntsendeob, ntsendipt
      integer ntsendeoc, ntrecv, ntwait, ntend
      integer ntsendnpart, ntnpart
      integer ntsendbrhono, ntbrho

      integer N_PART, N_EOB, N_END
      parameter (N_PART = 1)
      parameter (N_EOB = 2)
      parameter (N_END  = 3)

      integer npart
      double precision brho

      turn = 0
      id   = 0
      gen  = 1
      wgt  = 1.0D+0
      x    = -6.319439221D-01
      y    = 1.147679085D+00
      z    = 1.0D+0
      tx   = -3.856529999D-05
      ty   = -2.004572999D-06
      tz   =  5.004483739D-06
      aa   = 1
      zz   = 1
      m    = 450.0D+0
      pc   = 4520.0D+0
      t   = 5.0D-3

      call ntinit()
      cid = ntconnect("localhost", PORT)
      if (cid.eq.-1) then
        write(*,*) "Error connecting to server"
        goto 1000
      end if

      write(*,*) "Connected to server"

      npart = 56000
      n = ntsendnpart(cid, npart)
      brho = 1.2345d0
      n = ntsendbrhono(cid, brho)

      do j = 1,NTURNS

        turn = j
c       Send ipt
        write(*,*) "IPT ", j
        n = ntsendipt(cid, j, 0)
        if(n.lt.0) then
          write(*,*) "Error sending IPT"
          goto 900
        end if

        do i = 1,NPARTS
          id = i

c         Send particle
          n = ntsendp(cid, id, gen, wgt,
     &                x, y, z, tx, ty, tz, aa, zz, m, pc, t)
          if(n.lt.0) then
            write(*,*) "Error sending P"
            write(*,*) id, wgt, x, y, z, tx, ty, tz, aa, zz, m, pc, t
            goto 900
          end if

c         Read all incoming particles to release server out buffer
100       continue
          n = ntrecv(cid, mtype, id, gen, wgt,
     &               x, y, z, tx, ty, tz, aa, zz, m, pc, t)
          if(n.gt.0) then
            goto 100
          end if
c         End of reading incoming particles

        end do ! Done sending current turn particles

c       Send end of turn
        write(*,*) "End of turn ", j
        n = ntsendeob(cid)
        if(n.lt.0) then
          write(*,*) "Error sending T"
          goto 900
        end if

c     + Wait until end of turn (Synchronize)
c     |
200     continue
          n = ntwait(cid, mtype, id, gen, wgt,
     &               x, y, z, tx, ty, tz, aa, zz, m, pc, t)
          if(n.eq.-1) then
            write(*,*) "Server timed out while waiting end of turn"
            goto 900
          end if
          if(mtype.ne.N_EOB) then
            goto 200
          end if
c     |
c     + Finished waiting end of turn


      end do ! Turn loop

      write(*,*) "Done sending particles"
      write(*,*) "Closing connection..."

c     Send end of computation
      n = ntsendeoc(cid)
      if(n.lt.0) then
        write(*,*) "Error sending F"
        goto 900
      end if

c     Wait end of comp
      n = ntwait(cid, mtype, id, gen, wgt,
     &           x, y, z, tx, ty, tz, aa, zz, m, pc, t)
      if(n.eq.-1) then
        write(*,*) "Server timed out while waiting end of comp"
        goto 900
      end if
      if(mtype.ne.N_END) then
        write(*,*) "Unexpected message received"
      end if
c     Both ends agreed to disconnect

900   continue ! Error while connected

c     Finish connection
      n = ntend(cid)

1000  continue ! Error connecting

      stop
      end

      program server
      implicit none

      integer sid ! Server id
      integer cid ! Connection id
      integer n
      integer count
      integer total
      integer PORT
      parameter (PORT = 14999)

      integer mtype
      integer turn, id, gen
      double precision wgt, x, y, z, tx, ty, tz, m, pc, t
      integer aa, zz
      integer ntaccept, ntstart, ntsendp, ntsendeob, ntserver
      integer ntsendeoc, ntshdwn, ntwait, ntend
      integer ntsendnpart, ntnpart
      integer ntsendbrhono, ntbrho

      integer N_PART, N_EOB, N_END, N_IPT
      parameter (N_PART = 1)
      parameter (N_EOB  = 2)
      parameter (N_END  = 3)
      parameter (N_IPT  = 5)

      integer npart
      double precision brho

      ! Initialize fluka connections
      call ntinit()

      sid = ntserver()
      if(sid.eq.-1) then
        write(*,*) "Error creating the server"
        stop
      end if
      ! Listen
      n = ntstart(sid, PORT)
      if(n.eq.-1) then
        write(*,*) "Error cannot start server"
        stop
      end if

      write(*,*) "Listening on port ", n


100   continue ! while(1)
        write(*,*) "** Waiting for new connection"
        cid = ntaccept(sid)

        npart = ntnpart(cid)
        write(*,*) ">>>>>>>>> npart=",npart
        n  = ntbrho(cid, brho)
        write(*,*) ">>>>>>>>> brho=",brho, n

        if(.not.cid.lt.0) then
          write(*,*) "** New connection accepted"
!          n = nttimeout(cid, 20)

            total = 0
            count = 0

200         continue ! while(1)

              n = ntwait(cid,
     &              mtype, id, gen, wgt,
     &              x, y, z, tx, ty, tz, aa, zz, m, pc, t)
              if(n.lt.0) then
                write(*,*) "Client timeout"
                goto 900
              end if

              if(mtype.eq.N_PART) then
                count = count + 1
!                write(*,*) "<"
                n = ntsendp(cid,
     &                id, gen, wgt,
     &                x, y, z, tx, ty, tz, aa, zz, m, pc, t)

                if(n.lt.0) then
                  write(*,*) "Error sending"
                  goto 900
                end if
!                write(*,*) ">"
              else if(mtype.eq.N_IPT) then
                !ipt = id
                turn = gen
              else if(mtype.eq.N_EOB) then
!                write(*,*) "T"
                write(*,*) "  End of turn ", turn, " received ", count,
     &                     " particles"
                n = ntsendeob(cid)
                total = total + count
                count = 0
              else if(mtype.eq.N_END) then
!                write(*,*) "F"
                n = ntsendeoc(cid)
!                write(*,*) "f"
                write(*,*) "** Connection closed"
                goto 900
              end if

            goto 200

900         continue

            n = ntend(cid)
            cid = -1

        end if

      goto 100

! Finished shutdown server
      n = ntshdwn(sid)

      end

#!/bin/bash
#
# Vittorio Boccone -  22/06/10
#  boccone@cern.ch
#
# Modified by Roberto Versaci  22-09-2010
# Modified by Vittorio Boccone 02-03-2011 - add output file
#
# Fluka Project Builder 
#  replace the different includes
#  with the hardcoded text
#
inputfile=$1
#
base=${1%%.*} 
ext=${1#*.}
#
# if 2 arguments are passed use the second as destination
if [ "$#" = "2" ]  ; then
    outputfile=$2
else
    outputfile=$base"_exp."$ext
fi
#
if [ -n "${inputfile}" ] ; then
    if [ -e ${inputfile} ] ; then 
	echo -e "$(tput bold setaf 1)expand$(tput sgr0): Building the input file $(tput setaf 2)${outputfile}$(tput sgr0)"
	cp ${inputfile} ${outputfile}
	for name in $(awk -F'^#include' '{print $2}' ${inputfile}) ; do
	  newname=`echo "$name" | sed -e 's/\./\\\./g' | sed -e 's:\/:\\\/:g'`
	  echo -e "         Including $(tput setaf 4)${name}$(tput sgr0)"
	  if [ -e "$name" ] ; then
	      sed -e "/$newname/r $name" -e "/$newname/d" $outputfile > tmp.inp
	      mv tmp.inp $outputfile
	  else 
	      echo "File " $name " does not exist"
	  fi
	done
    else
	echo "File to be expanded does not exist"
    fi
else
    echo "No input file specified"
fi

PSEUDOCODE for material interactions tracking in collimator
===========================================================

- create DriftTrajectory from particle
- loop:
    - find first crossing with collimator shape (segments)
    - if distance larger than end of BeamElement -> move particle to exendit and break loop
    - move particle to collimator impact point
    - create MCSTrajectory from new particle
    - loop:
        - find first crossing with collimator shape (segments)
        - do not move, but calculate path length
        - compare to distance to nuclear interaction
        - shortest wins (nuclear or exit)
        - move to next point
    - when at exit, create DriftTrajectory from particle



PSEUDOCODE for material interactions tracking in crystal
========================================================

- create DriftTrajectory from particle
- loop:
    - find first crossing with crystal shape (segments)
    - if distance larger than end of BeamElement -> move particle to end and break loop
    - move particle to crystal impact point
    - create MCSTrajectory (if amorphous) or CircularTrajectory (if channelling) from new particle
    - loop:
        - find first crossing with crystal shape (segments)
        - do not move, but calculate path length
        - compare to distance to nuclear interaction and dechannelling
        - shortest wins (nuclear, dechannelling, or exit)
        - move to next point
    - when at exit, create DriftTrajectory from particle


PSEUDOCODE for crossing finder
==============================

- if DriftTrajectory and any segment
=> use analytical
